<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/common.php');

// セッションチェック
// ログインしていない場合はログインページにリダイレクト
require_once (dirname(__FILE__).'/sessionchk.php');

// ページ名
define('PAGE_NAME', 'アカウント管理');

?>


<!DOCTYPE html>
<html lang="ja">
<head>
 <meta charset="utf-8">
 <title><?php echo P_TITLE;?> | <?php echo PAGE_NAME;?></title>

 <meta http-equiv="X-UA-Compatible" content="IE=edge">
 <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

 <link rel="stylesheet" type="text/css" href="css/dataTables.bootstrap.min.css"/>
 <link rel="stylesheet" type="text/css" href="css/bootstrap.min.css"/>
 <link href="css/style.css" rel="stylesheet">

</head>
<body>

 <?php include 'inc/header.php'; ?> <!-- ヘッダー共通部 -->
 <?php include 'inc/pagename.php'; ?> <!-- ページ名共通部 -->

 <div class="container-fluid">
  <div class="row">
   <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
   <div class="col-sm-12 col-md-10" style="background-color:white;">
    <div>
     <table id="myTable" class="table table-striped tagle-bordered">
      <thead>
       <tr>
        <th>ユーザー名</th>
        <th>種別</th>
        <th>権限</th>
        <th>状態</th>
        <th>エラー数</th>
        <th>劇場ID</th>
        <th>備考</th>
       </tr>
      </thead>
      <tbody>
<?php $message; ?>
      </tbody>
      <tfoot>
       <tr>
        <th>ユーザー名</th>
        <th>種別</th>
        <th>権限</th>
        <th>状態</th>
        <th>エラー数</th>
        <th>劇場ID</th>
        <th>備考</th>
       </tr>
      </tfoot>
     </table>
    </div>
    <div style="height:60px">
     <hr>
     <div class="pull-left">
<?php if ($user_authority <= 2): ?>
      <button id="registButton" type="button" class="btn btn-primary">登録</button>
<?php endif; ?>
<?php if ($user_authority <= 1): ?>
      <button id="updateButton" type="button" class="btn btn-success" disabled>更新</button>
<?php endif; ?>
     </div>
<?php if ($user_kind == 0): ?>
     <div class="pull-right">
      <button id="deleteButton" type="button" class="btn btn-danger" disabled>削除</button>
     </div>
<?php endif; ?>
     <br>
    </div>
   </div>
   <div id="form" class="modal fade" tabindex="-1">
    <div class="modal-dialog modal-dialog-centered ">
     <div class="modal-content">
      <div class="modal-header">
       <h4 id="dialogTitle" class="modal-title">登録</h4>
       <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
      </div>
      <div class="modal-body">
       <div class="container-fluid">
        <div class="row">
         <div class="col-lg-12">
          <div id="alert_form"></div>
          <form class="form-horizontal" id="sample-form">
           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputUser">ユーザー名 (必須)</label>
            <div class="col-sm-8">
             <input type="text" class="form-control ime-disabled" id="inputUser" name="inputUser" placeholder="半角英大・小・数字混在、8文字以上" />
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputPass">パスワード (必須)</label>
            <div class="col-sm-8">
             <input type="password" class="form-control ime-disabled" id="inputPass" name="inputPass" placeholder="半角英大・小・数字混在、8文字以上" />
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputKind">種別 (必須)</label>
            <div class="col-sm-8">
             <select id="inputKind" name="inputKind" class="form-control">
<?php if ($user_kind == 0): ?>
              <option value="00">システム管理者</option>
<?php else: ?>
              <option value="00" disabled>システム管理者</option>
<?php endif; ?>
<?php if (($user_kind <= 1) && ($user_authority <= 2)): ?>
              <option value="01">管理者</option>
<?php else: ?>
              <option value="01" disabled>管理者</option>
<?php endif; ?>
<?php if ($user_authority <= 2): ?>
              <option value="02">劇場管理者</option>
<?php else: ?>
              <option value="02" disabled>劇場管理者</option>
<?php endif; ?>
             </select>
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputAuthority">権限 (必須)</label>
            <div class="col-sm-8">
             <select id="inputAuthority" name="inputAuthority" class="form-control">
<?php if (($user_kind == 0) || ($user_kind == 1 && $user_authority <= 0)): ?>
              <option value="00">すべて</option>
<?php else: ?>
              <option value="00" disabled>すべて</option>
<?php endif; ?>
<?php if ($user_authority <= 2): ?>
              <option value="01">追加更新</option>
              <option value="02">追加のみ</option>
              <option value="03">閲覧のみ</option>
<?php else: ?>
              <option value="01" disabled>追加更新</option>
              <option value="02" disabled>追加のみ</option>
              <option value="03" disabled>閲覧のみ</option>
<?php endif; ?>
             </select>
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputExistence">状態 (必須)</label>
            <div class="col-sm-8">
             <select id="inputExistence" name="inputExistence" class="form-control">
              <option value="00">有効</option>
<?php if ($user_kind == 0 || ($user_authority <= 1)): ?>
              <option value="01">停止</option>
<?php else: ?>
              <option value="01" disabled>停止</option>
<?php endif; ?>
<?php if ($user_kind == 0 || ($user_authority == 0)): ?>
              <option value="02">削除</option>
<?php else: ?>
              <option value="02" disabled>削除</option>
<?php endif; ?>
             </select>
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputError_cnt">エラー回数 (任意)</label>
            <div class="col-sm-8">
             <select id="inputError_cnt" name="inputError_cnt" class="form-control">
              <option value="00">0</option>
              <option value="01">1</option>
              <option value="02">2</option>
             </select>
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputGekijo_id">劇場ID (不可)</label>
            <div class="col-sm-8">
<?php if ($user_kind == 0): ?>
             <input type="text" value="<?php echo $user_gekijo_id ?>" class="form-control ime-disabled" id="inputGekijo_id" name="inputGekijo_id" placeholder="登録する劇場ID" />
<?php else: ?>
             <input type="text" value="<?php echo $user_gekijo_id ?>" class="form-control ime-disabled" id="inputGekijo_id" name="inputGekijo_id" placeholder="登録する劇場ID"  readonly />
<?php endif; ?>
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputComment">備考 (任意)</label>
            <div class="col-sm-8">
             <input type="text" name="inputComment" class="form-control ime-disabled" id="inputComment" placeholder="備考" />
            </div>
           </div>
          </form>
         </div>
        </div>
       </div>
      </div>
      <div class="modal-footer">
       <div id="inputError" class="float-left" style="color:red; padding:5px;"></div>
        <button id="sendRegistButton" type="button" class="btn btn-primary"><i class="fa fa-check"></i>&nbsp;登録</button>
        <button id="sendUpdateButton" type="button" class="btn btn-primary"><i class="fa fa-check"></i>&nbsp;修正</button>
        <button type="button" class="btn btn-default" data-dismiss="modal"><i class="fa fa-remove"></i>&nbsp;閉じる</button>
       </div>
      </div>
     </div>

     <!-- Modal -->
     <div class="modal fade" id="messageModalSuccess" role="dialog">
      <div class="modal-dialog">
       <!-- Modal content-->
       <div class="modal-content modalmsg-success">
        <div class="modal-header">
         <h4 class="modal-title" id="modalSuccessLabel"></h4>
        </div>
       </div>
      </div>
     </div>

     <!-- Modal -->
     <div class="modal fade" id="messageModalError" role="dialog">
      <div class="modal-dialog">
       <!-- Modal content-->
       <div class="modal-content modalmsg-danger">
        <div class="modal-header">
         <button type="button" class="close"  id="modalErrorClose">
          <span aria-hidden="true">&times;</span>
         </button>
         <h4 class="modal-title" id="modalErrorLabel"></h4>
        </div>
        <div class="modal-body modalmsg-body" id="modalErrorMsg">
        </div>
       </div>
      </div>
     </div>
    </div>
    <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
   </div>
  </div>
 </div>

 <?php include 'inc/footer.php'; ?> <!-- フッター共通部 -->

</body>
 <script type="text/javascript" src="js/jquery-3.5.1.js"></script>
 <script type="text/javascript" src="js/bootstrap.min.js"></script>
 <script type="text/javascript" src="js/jquery.dataTables.min.js"></script>
 <script type="text/javascript" src="js/dataTables.bootstrap.min.js"></script>
 <script type="text/javascript" src="js/bootbox.min.js"></script>
 <script type="text/javascript" src="js/jquery.validate.js"></script>
 <script type="text/javascript" src="js/validate-ja.js"></script>
 <script type="text/javascript" src="js/account.js"></script>
</html>
