<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/common.php');

// セッションチェック
// ログインしていない場合はログインページにリダイレクト
require_once (dirname(__FILE__).'/sessionchk.php');

// ページ名
define('PAGE_NAME', 'アンケート管理');

?>

<!DOCTYPE html>
<html lang="ja">
<head>
 <meta charset="utf-8">
 <title><?php echo P_TITLE;?> | <?php echo PAGE_NAME;?></title>

 <meta http-equiv="X-UA-Compatible" content="IE=edge">
 <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

 <link rel="stylesheet" type="text/css" href="css/dataTables.bootstrap.min.css"/>
 <link rel="stylesheet" type="text/css" href="css/bootstrap.min.css"/>
 <link rel="stylesheet" type="text/css" href="css/jquery.datetimepicker.css"/>
 <link href="css/style.css" rel="stylesheet">

</head>
<body>

 <?php include 'inc/header.php'; ?> <!-- ヘッダー共通部 -->
 <?php include 'inc/pagename.php'; ?> <!-- ページ名共通部 -->

 <input type="hidden" id="hidden1" value="<?php echo $user_kind ?>">
 <input type="hidden" id="hidden2" value="<?php echo $user_authority ?>">
 <input type="hidden" id="hidden3" value="<?php echo Q_URL ?>">
 <input type="hidden" id="hidden4" value="<?php echo P_NAME ?>">
 <div class="container-fluid">
  <div class="row">
   <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
   <div class="col-sm-12 col-md-10" style="background-color:white;">
    <div>
     <table id="myTable" class="table table-striped tagle-bordered">
      <thead>
       <tr>
        <th>劇場</th>
        <th>ID</th>
        <th>アンケート名</th>
        <th>回答</th>
        <th>訪問</th>
        <th>状態</th>
        <th>開始日時</th>
        <th>終了日時</th>
        <th></th>
       </tr>
      </thead>
      <tbody>
<?php $message; ?>
      </tbody>
      <tfoot>
       <tr>
        <th>劇場</th>
        <th>ID</th>
        <th>アンケート名</th>
        <th>回答</th>
        <th>訪問</th>
        <th>状態</th>
        <th>開始日時</th>
        <th>終了日時</th>
        <th></th>
       </tr>
      </tfoot>
     </table>
    </div>
    <div style="height:60px">
     <hr>
     <div class="pull-left">
<?php if ($user_authority <= 2): ?>
      <button id="registButton" type="button" class="btn btn-primary">登録</button>
<?php endif; ?>
<?php if ($user_authority <= 1): ?>
      <button id="updateButton" type="button" class="btn btn-success" disabled>更新</button>
<?php endif; ?>
<?php if ($user_authority <= 2): ?>
      <button id="listButton" type="button" class="btn btn-info">項目</button>
<?php endif; ?>
      <button id="dispButton" type="button" class="btn btn-info">表示</button>
      <button id="reportButton" type="button" class="btn btn-warning">結果</button>
     </div>
<?php if ($user_kind == 0): ?>
     <div class="pull-right">
      <button id="deleteButton" type="button" class="btn btn-danger" disabled>削除</button>
     </div>
<?php endif; ?>
     <br>
    </div>
   </div>

   <div id="form" class="modal fade" tabindex="-1">
    <div class="modal-dialog modal-dialog-centered ">
     <div class="modal-content">
      <div class="modal-header">
       <h4 id="dialogTitle" class="modal-title">登録</h4>
       <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
      </div>
      <div class="modal-body">
       <div class="container-fluid">
        <div class="row">
         <div class="col-lg-12">
          <div id="alert_form"></div>
          <form class="form-horizontal" id="sample-form">
           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputGid">劇場ID (必須)</label>
            <div class="col-sm-8">
<?php if ($user_kind == 2): ?>
             <input type="text" class="form-control ime-disabled" id="inputGid" name="inputGid" placeholder="半角英数字４文字" value="<?php echo $user_gekijo_id ?>" disabled/>
<?php else: ?>
             <input type="text" class="form-control ime-disabled" id="inputGid" name="inputGid" placeholder="半角英数字４文字" value="" />
<?php endif; ?>
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputAid">アンケートID (必須)</label>
            <div class="col-sm-8">
             <input type="text" class="form-control ime-disabled" id="inputAid" name="inputAid" placeholder="半角英数字４文字" />
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputAname">アンケート名称 (必須)</label>
            <div class="col-sm-8">
             <input type="text" name="inputAname" class="form-control" id="inputAname" placeholder="アンケート名称" />
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputAexplanation">アンケート説明 (任意)</label>
            <div class="col-sm-8">
             <input type="text" name="inputAexplanation" class="form-control" id="inputAexplanation" placeholder="アンケート説明文" />
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputAexistence">アンケート状態 (必須)</label>
            <div class="col-sm-8">
             <select id="inputAexistence" name="inputAexistence" class="form-control">
              <option value="00">有効</option>
<?php if ($user_authority <= 1): ?>
              <option value="01">停止</option>
<?php else: ?>
              <option value="01" disabled>停止</option>
<?php endif; ?>
<?php if ($user_authority == 0): ?>
              <option value="02">削除</option>
<?php else: ?>
              <option value="02" disabled>削除</option>
<?php endif; ?>
             </select>
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputAstart">開始日時 (必須)</label>
            <div class="col-sm-8">
             <input type="text" name="inputAstart" class="form-control ime-disabled" id="inputAstart" placeholder="開始日時" />
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputAend">終了日時 (必須)</label>
            <div class="col-sm-8">
             <input type="text" name="inputAend" class="form-control ime-disabled" id="inputAend" placeholder="終了日時" />
            </div>
           </div>

           <div id="demo-area">
            <div class="form-group unit">
             <label class="col-sm-4 control-label" for="inputQid">設問項目 (必須)<span class="btn btn-danger demo-minus">-</span></label>
             <div class="col-sm-8  form-inline">
              <input type="text" name="inputQid[]" class="form-control ime-disabled inputQid" id="inputQid" placeholder="設問項目" />&nbsp;
              <label class="control-label" for="inputReq" data-toggle="tooltip" title="設問項目を入力必須に設定する">入力必須</label>
              <input type="checkbox" name="inputReq[]" class="form-control inputReq" id="inputReq" checked>
             </div>
            </div>
           </div>
           <div id="demo-plus" class="btn btn-primary">+</div>
          </form>
         </div>
        </div>
       </div>
      </div>
      <div class="modal-footer">
       <div id="inputError" class="float-left" style="color:red; padding:5px;"></div>
       <button id="sendRegistButton" type="button" class="btn btn-primary"><i class="fa fa-check"></i>&nbsp;登録</button>
       <button id="sendUpdateButton" type="button" class="btn btn-primary"><i class="fa fa-check"></i>&nbsp;修正</button>
       <button type="button" class="btn btn-default" data-dismiss="modal"><i class="fa fa-remove"></i>&nbsp;閉じる</button>
      </div>
     </div>
    </div>

 <!-- Modal -->
    <div class="modal fade" id="messageModalSuccess" role="dialog">
     <div class="modal-dialog">
      <!-- Modal content-->
      <div class="modal-content modalmsg-success">
       <div class="modal-header">
        <h4 class="modal-title" id="modalSuccessLabel"></h4>
       </div>
      </div>
     </div>
    </div>

 <!-- Modal -->
    <div class="modal fade" id="messageModalError" role="dialog">
     <div class="modal-dialog">
      <!-- Modal content-->
      <div class="modal-content modalmsg-danger">
       <div class="modal-header">
        <button type="button" class="close"  id="modalErrorClose">
         <span aria-hidden="true">&times;</span>
        </button>
        <h4 class="modal-title" id="modalErrorLabel"></h4>
       </div>
       <div class="modal-body modalmsg-body" id="modalErrorMsg">
       </div>
      </div>
     </div>
    </div>

   </div>
   <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
  </div>
 </div>

 <?php include 'inc/footer.php'; ?> <!-- フッター共通部 -->

</body>
 <script type="text/javascript" src="js/jquery-3.5.1.js"></script>
 <script type="text/javascript" src="js/bootstrap.min.js"></script>
 <script type="text/javascript" src="js/jquery.dataTables.min.js"></script>
 <script type="text/javascript" src="js/dataTables.bootstrap.min.js"></script>
 <script type="text/javascript" src="js/bootbox.min.js"></script>
 <script type="text/javascript" src="js/jquery.validate.js"></script>
 <script type="text/javascript" src="js/validate-ja.js"></script>
 <script type="text/javascript" src="js/jquery.datetimepicker.full.min.js"></script>

 <script type="text/javascript" src="js/administration.js"></script>
</html>
