<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/apicommon.php');

// 不正POSTチェック
if(empty($_POST['id'])) {
 echo json_encode("error");
 exit();
}

$init_success = false;
$session_change = true;
//--------------------------------------------------------
// セッション(正常なアクセスか判定)チェック
//--------------------------------------------------------
require_once (dirname(__FILE__).'/apisessionchk.php');

$data = array();

//ユーザー有効
if($init_success){
//--------------------------------------------------------
// アンケートを管理するテーブル(TBL_QUESTIONNAIRE)を読み込む
//--------------------------------------------------------
 try {
  //データベース関数のファイルの読み込み
  require_once ('../../'.L_BASE.'/db/q_admin.php');

  $q_admin = new q_adminDb();
  $ret = $q_admin->selectAadmin("", $_POST["id"]);
  $q_admin->closeDetaBase();

 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "adminRecord01\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "adminRecord02\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }

 foreach ($ret as $key => $value){
  $data[$key] = array(
   "id"=> $value['id'],
   "gekijo_id"=> $value['gekijo_id'],
   "a_id"=> $value['a_id'],
   "a_name"=> $value['a_name'],
   "a_explanation"=> $value['a_explanation'],
   "a_existence"=> $value['a_existence'],
   "existence_name"=>cnvExistence($value['a_existence']),
   "a_start"=>$value['a_start'],
   "a_end"=>$value['a_end'],
   "a_qid" => json_decode($value['a_qid']),
   "a_disp" => json_decode($value['a_disp']),
   "creation_dt"=>$value['creation_dt'],
   "creation_user"=>$value['creation_user'],
   "modification_dt"=>$value['modification_dt'],
   "modification_user"=>$value['modification_user']
  );
 }
}

//--------------------------------------------------------
// アンケートの設問を管理するテーブル(TBL_QUESTION)のデータを送信
//--------------------------------------------------------
$json_data = array(
 "draw" => 1,
 "recordsTotal" => count($data) ,
 "recordsFiltered" => count($data) ,

 "data" => $data
);
echo json_encode($data);  // send data as json format
?>
