<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/apicommon.php');

$init_success = false;
$session_change = true;
//--------------------------------------------------------
// セッション(正常なアクセスか判定)チェック
//--------------------------------------------------------
require_once (dirname(__FILE__).'/apisessionchk.php');

$data = array();

//ユーザー有効
if($init_success){
//--------------------------------------------------------
// アンケートを管理するテーブル(TBL_QUESTIONNAIRE)を読み込む
//--------------------------------------------------------
 try {
  //データベース関数のファイルの読み込み
  require_once ('../../'.L_BASE.'/db/q_admin.php');

  $q_admin = new q_adminDb();
  $ret = $q_admin->selectAadmin(($ret[0]['kind'] == 2 ) ? $ret[0]['gekijo_id'] : "");
  $q_admin->closeDetaBase();

 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "admin_init01\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "admin_init02\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }

//--------------------------------------------------------
//  アンケートページへのアクセスログ(TBL_ACCESSLOG)を読み込む
//--------------------------------------------------------
 try {
  //データベース関数のファイルの読み込み
  require_once ('../../'.L_BASE.'/db/accesslog.php');

  $accesslog = new accesslogDb();
  foreach ($ret as $key => $value){
   $countAll = $accesslog->countAccessLog($value['a_id'], $value['gekijo_id']);
   $count = $accesslog->countAccessLog($value['a_id'], $value['gekijo_id'], 3);
   $data[$key] = array(
    "id"=> $value['id'],
    "gekijo_id"=> $value['gekijo_id'],
    "a_id"=> $value['a_id'],
    "a_name"=> $value['a_name'],
    "a_existence"=> $value['a_existence'],
    "existence_name"=>cnvExistence($value['a_existence']),
    "a_start"=>$value['a_start'],
    "a_end"=>$value['a_end'],
    "countAll"=>$countAll,
    "count"=>$count,
   );
  }
  $accesslog->closeDetaBase();

 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "admin_init03\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "admin_init04\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }
}

//--------------------------------------------------------
// アンケートを管理するテーブル(TBL_QUESTIONNAIRE)のデータを送信
//--------------------------------------------------------
$json_data = array(

 "draw" => 1,
 "recordsTotal" => count($data) ,
 "recordsFiltered" => count($data) ,

 "data" => $data
);
echo json_encode($json_data);  // send data as json format
?>
