<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/apicommon.php');

// 不正POSTチェック
if(empty($_POST['a_id'])) {
 echo json_encode(array('result'=> "error"));
 exit();
}

$init_success = false;
$session_change = true;
//--------------------------------------------------------
// セッション(正常なアクセスか判定)チェック
//--------------------------------------------------------
require_once (dirname(__FILE__).'/apisessionchk.php');

$data = array();

//ユーザー有効
if($init_success){
//--------------------------------------------------------
// アンケートの設問をチェックする
//--------------------------------------------------------
 try {
  //データベース関数のファイルの読み込み
  require_once ('../../'.L_BASE.'/db/q_setting.php');
  $q_setting = new q_settingDb();

  $a_qidArray = $_POST["a_qid"];
  foreach ($a_qidArray as $key => $value){
   if($a_qidArray[$key]["qid"] == "") {
    $q_setting->closeDetaBase();
    $json_data = array(
         'result'=> "error",
         'errorcode'=> "5203",
         'message'=> "設問項目IDを正しく入力してください。"
    );
    echo json_encode($json_data);
    return;
   }
   $keyIndex = array_count_values(array_column($a_qidArray, 'qid'))[$a_qidArray[$key]["qid"]];

   if($keyIndex != 1) {
    $q_setting->closeDetaBase();
    $json_data = array(
         'result'=> "error",
         'errorcode'=> "5204",
         'message'=> "設問項目IDが重複しています。"
    );
    echo json_encode($json_data);
    return;
   }
   $ret_setting = $q_setting->selectQsetting2($a_qidArray[$key]["qid"]);
   if(empty($ret_setting[0])){
    $q_setting->closeDetaBase();
    $json_data = array(
         'result'=> "error",
         'errorcode'=> "5202",
         'message'=> "設問ID[ ".$a_qidArray[$key]["qid"]." ]が存在しません。"
    );
    echo json_encode($json_data);
    return;
   }
   if($a_qidArray[$key]["req"] == "true") {
    $a_qidArray[$key]["req"] =true;
   }
   else {
    $a_qidArray[$key]["req"] =false;
   }
  }
  $q_setting->closeDetaBase();

//--------------------------------------------------------
// アンケートを管理するテーブル(TBL_QUESTIONNAIRE)にアンケートを登録する
//--------------------------------------------------------
  //データベース関数のファイルの読み込み
  require_once ('../../'.L_BASE.'/db/q_admin.php');

  $q_admin = new q_adminDb();
  $ret = $q_admin->insertAadmin($_POST["a_id"], $_POST["gekijo_id"], $_POST["a_name"], $_POST["a_explanation"], intval($_POST["a_existence"]), $_POST["a_start"], $_POST["a_end"], $a_qidArray, NULL, $_SESSION['user_id']);
  $q_admin->commit();
  $q_admin->closeDetaBase();

  if(!isset($ret) || empty($ret)) {
   $errorcode = "5201";
   $message = "アンケートIDが既に登録されています。";
   $init_success = false;
  }

 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "admin_regist01\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "admin_regist02\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }

}
else{ // セッション切れ
 $json_data = array(
  'result'=> "error",
  'errorcode'=> "5101",
  'message'=> "セッションエラー。"
 );
 echo json_encode($json_data);
 return;
}

//--------------------------------------------------------
// アンケート登録結果を送信
//--------------------------------------------------------
if ($init_success){
 $json_data = array(
  'result'=> "success"
 );
}else{
 $json_data = array(
  'result'=> "error",
  'errorcode'=> $errorcode,
  'message'=> $message
 );
}
echo json_encode($json_data);
?>
