<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/apicommon.php');

// 不正POSTチェック
if(empty($_POST['gid']) || empty($_POST['aid']) ||  empty($_POST['qid'])) {
 $json_data = array(
  'result'=> "error",
  'errorcode'=> "6102",
  'message'=> "不正アクセス。"
 );
 echo json_encode($json_data);
 return;
}

$init_success = false;
$session_change = false;
//--------------------------------------------------------
// セッション(正常なアクセスか判定)チェック
//--------------------------------------------------------
require_once (dirname(__FILE__).'/apisessionchk.php');

// 表示メッセージ
$message = "";
$errorcode = "";
$aid = $_POST['aid'];
$gid = $_POST['gid'];
$qid = $_POST['qid'];

//ユーザー有効
if($init_success){
//--------------------------------------------------------
// アンケートと回答を読み込んでアンケート結果表示データを作成
//--------------------------------------------------------
 try {
  //設問データの読み込み
  require_once ('../../'.L_BASE.'/db/q_setting.php');

  $q_setting = new q_settingDb();
  $ret_setting = $q_setting->selectQsetting2($qid);
  $q_setting->closeDetaBase();
  $q_select = json_decode($ret_setting[0]['q_select'],true);

  //データベース関数のファイルの読み込み
  require_once ('../../'.L_BASE.'/db/q_admin.php');
  $q_admin = new q_adminDb();

  //回答データの読み込み
  $qnos = array();
  $q_array = array();
  $other = array();

  $q_kind = $ret_setting[0]['q_kind'];

  switch($q_kind) {
   case  1: //単一選択ドロップダウン
   case 21: //単一選択ラジオボタン
   case 31: //複数選択チェックボックス
   case 22: //単一選択ラジオボタンとその他記述
   case 32: //複数選択チェックボックスとその他記述

    $a_arrayb = array();
    if($q_kind != 1) {
     $qnos[] = 0; // 無回答
     $q_array[] = "無回答";
     $a_arrayb[] = 0;
    }
    foreach($q_select as $qno=>$qval) {
     if($q_kind != 1) {
      $qnos[] = $qno+1; // $qno:選択番号
     }
     else {
      $qnos[] = $qno; // $qno:選択番号
     }
     $q_array[] = $qval; // $qval:選択文言
     $a_arrayb[] = 0;
    }

    $q_list = $q_admin->selectAadmin3($gid, $aid, $qid);

    if(count($q_list) != 0){
     $startDay1 = $q_list[0]["a_start"];
     $endDay1 = $q_list[0]["a_end"];

     $data = array();

     foreach($q_list as $q_list_key=>$ret_admin) {
      $startDay = $ret_admin["a_start"];
      $endDay = $ret_admin["a_end"];
      $gidb = $ret_admin["gekijo_id"];
      $aidb = $ret_admin["a_id"];
      $a_name = $ret_admin["a_name"];

      $a_array = array();
      $a_array = $a_arrayb;
      $ret_answer = $q_admin->selectAnswer2($gidb,$aidb,$qid,$startDay,$endDay,$qnos);

      $data_count = $ret_answer[0]['total'];
      foreach ($qnos as $key => $value){
       $a_array[$key] = $ret_answer[0][(string)$value];
      }

      $data_list = array(
       "title"=> $a_name,
       "count"=> $data_count,
       "a_array"=>$a_array,
      );
      $data[] = $data_list;
     }

     if($q_kind == 22 || $q_kind == 32){ //その他記述あり
      $ret_answer = $q_admin->selectAnswer3($gid,$aid,$qid,$startDay1,$endDay1);
      foreach ($ret_answer as $key => $value){
       $other[] = json_decode($value['other'],true)[0] ;
      }
     }
     $q_admin->closeDetaBase();
    }
    else{
     $json_data = array(
      'result'=> "error",
      'errorcode'=> "6103",
      'message'=> "該当アンケート無し。"
     );
     echo json_encode($json_data);
     return;
    }
    break;
   case 91: //自由記述一行
   case 99: //自由記述複数行
    try {
     $ret_admin = $q_admin->selectAadmin2($gid, $aid);
     if(count($ret_admin) != 0){
      $data = array();
      $startDay = $ret_admin[0]["a_start"];
      $endDay = $ret_admin[0]["a_end"];

      $ret_answer = $q_admin->selectAnswer3($gid,$aid,$qid,$startDay,$endDay);
      foreach ($ret_answer as $key => $value){
       $other[] = json_decode($value['other'],true)[0] ;
      }
      $q_admin->closeDetaBase();
     }
     else{
      $json_data = array(
       'result'=> "error",
       'errorcode'=> "6104",
       'message'=> "該当アンケート無し。"
      );
      echo json_encode($json_data);
      return;
     }

    }catch(ErrorException $ex){
     if(DEBUG_LEVEL != "0"){
      error_log("[". date('Y-m-d H:i:s') . "]". "admin_report01\n","3","debug.log");
      error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
     }
    }catch(PDOException $ex){
     if(DEBUG_LEVEL != "0"){
      error_log("[". date('Y-m-d H:i:s') . "]". "admin_report02\n","3","debug.log");
      error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
     }
    }
    break;
   default:
    break;
  }

 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "admin_report03\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "admin_report04\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }

}
else{ // セッション切れ
 $json_data = array(
  'result'=> "error",
  'errorcode'=> "6101",
  'message'=> "セッションエラー。"
 );
 echo json_encode($json_data);
 return;
}

//--------------------------------------------------------
// アンケート結果表示データを送信
//--------------------------------------------------------
switch($q_kind) {
 case  1: //単一選択ドロップダウン
 case 21: //単一選択ラジオボタン
 case 31: //複数選択チェックボックス
 case 22: //単一選択ラジオボタンとその他記述
 case 32: //複数選択チェックボックスとその他記述
  break;
 case 91: //自由記述一行
 case 99: //自由記述複数行
  $data = array(
  );
  break;
 default:
  $data = array(
  );
  break;
}
$senddata = array(
 "qid"=> $qid,
 "kind"=> $q_kind,
 "qnos"=> $qnos,
 "q_array"=>$q_array,
 "data"=>$data,
 "other"=>$other,
);

$json_data = array(
 'result'=> "success",
 'data'=> $senddata
);

echo json_encode($json_data);
?>
