<?php
//セッション名を指定
session_name(SESSION_NAME);
//セッション開始
session_start();

//データベース関数のファイルの読み込み
require_once ('../../'.L_BASE.'/db/meibo.php');
//検証及びエスケープ処理の関数のファイルの読み込み
require_once '../session_validation.php';
require_once '../meibo_string.php';

//セッションIDを初期化
$cookie_session_id = NULL;

//クッキーからセッションIDを取得
if (isset($_COOKIE[session_name()])){
 $cookie_session_id = h($_COOKIE[session_name()]) ;
}

//セッションIDを変更（セッションハイジャック対策）
// session_regenerate_id(TRUE); 

//--------------------------------------------------------
// ログインチェック
//--------------------------------------------------------

if (isset($cookie_session_id)) {
 try {

  $meibo = new meiboDb();
  $ret = $meibo->selectSession($cookie_session_id);
  $meibo->closeDetaBase();

  if (isset($ret[0]) && !empty($ret[0]) && (count($ret) > 0) && isset($_SESSION['user_id'])) {
   // DBにセッション有
   // セッション比較
   if ($_SESSION['user_id'] == $ret[0]['user_id']) {
    // DBのセッションID同一でユーザー同一なら
    // セッションIDを更新
    if($session_change) {
     session_regenerate_id(TRUE); //セッションIDを変更
     $meibo = new meiboDb();
     $meibo->updateSession( session_id(), $_SESSION['user_id'] );
     $meibo->commit();
     $meibo->closeDetaBase();
    }
    $init_success = true;
   }
  }

 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "apiSessinChk01\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "apiSessinChk02\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }
}
?>
