<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/apicommon.php');

// 不正POSTチェック
if(empty($_POST['user_id'])) {
 echo json_encode("error");
 exit();
}

$init_success = false;
$session_change = false;
//--------------------------------------------------------
// セッション(正常なアクセスか判定)チェック
//--------------------------------------------------------
require_once (dirname(__FILE__).'/apisessionchk.php');

//ユーザー有効
if($init_success){
//--------------------------------------------------------
// ユーザーを管理するテーブル(TBL_USER)からユーザーを削除
//--------------------------------------------------------
 try {
  $meibo = new meiboDb();
  $ret = $meibo->deleteUser($_POST["user_id"]);

  //セッションIDを変更（セッションハイジャック対策）
  session_regenerate_id(TRUE); 
  $meibo->updateSession( session_id(), $_SESSION['user_id'] );

  $meibo->commit();
  $meibo->closeDetaBase();

  if(DEBUG_LEVEL == "2"){
   error_log("[". date('Y-m-d H:i:s') . "]". "deleteUser\n","3","debug.log");
   error_log("[". print_r($ret,true) . "]"."\n","3","debug.log");
  }

  if(!isset($ret) || empty($ret)) {
   $init_success = false;
  }
 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "delete01\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "delete02\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }
}

//--------------------------------------------------------
// ユーザー削除結果を送信
//--------------------------------------------------------
if ($init_success){
 $json_data = array(
  'result'=> "success"
 );
}else{
 $json_data = array(
  'result'=> "error"
 );
}
echo json_encode($json_data);

?>
