<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/apicommon.php');

// 不正POSTチェック
if(empty($_POST['user_id'])) {
 echo json_encode("error");
 exit();
}

$init_success = false;
$session_change = true;
//--------------------------------------------------------
// セッション(正常なアクセスか判定)チェック
//--------------------------------------------------------
require_once (dirname(__FILE__).'/apisessionchk.php');

$data = array();

//ユーザー有効
if($init_success){
//--------------------------------------------------------
// ユーザーを管理するテーブル(TBL_USER)を読み込む
//--------------------------------------------------------
 try {
  $meibo = new meiboDb();
  $ret = $meibo->selectMeibo($_POST['user_id']);
  $meibo->closeDetaBase();

  if(DEBUG_LEVEL == "2"){
   error_log("[". date('Y-m-d H:i:s') . "]". "selectMeibo\n","3","debug.log");
   error_log("[". print_r($ret,true) . "]"."\n","3","debug.log");
  }

 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "getRecord01\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "getRecord01\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }

 foreach ($ret as $key => $value){
  $data[$key] = array(
   "user_id"=> $value['user_id'],
   "kind"=>$value['kind'],
   "kind_name"=>cnvKind($value['kind']),
   "authority"=>$value['authority'],
   "authority_name"=>cnvAuthority($value['authority']),
   "existence"=>$value['existence'],
   "existence_name"=>cnvExistence($value['existence']),
   "error_cnt"=>$value['error_cnt'],
   "error_cnt_name"=>cnvEerror_cnt($value['error_cnt']),
   "gekijo_id"=>$value['gekijo_id'],
   "comment"=>$value['comment']
  );
 }
}

//--------------------------------------------------------
// ユーザーを管理するテーブル(TBL_USER)のデータを送信
//--------------------------------------------------------
echo json_encode($data);  // send data as json format
?>
