<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/apicommon.php');

// 不正POSTチェック
if(empty($_POST['group_id'])) {
 echo json_encode(array('result'=> "error"));
 exit();
}

$init_success = false;
$session_change = true;
//--------------------------------------------------------
// セッション(正常なアクセスか判定)チェック
//--------------------------------------------------------
require_once (dirname(__FILE__).'/apisessionchk.php');

// 表示メッセージ
$message = "";
$errorcode = "";

//ユーザー有効
if($init_success){
//--------------------------------------------------------
// アンケートの設問グループを管理するテーブル(TBL_QUESTION_GROUP)にグループを登録する
//--------------------------------------------------------
 try {
  //データベース関数のファイルの読み込み
  require_once ('../../'.L_BASE.'/db/q_setting.php');

  $q_setting = new q_settingDb();
  $ret = $q_setting->insertQgroup($_POST["group_id"], $_POST["group_name"], $_POST["group_explanation"], $_SESSION['user_id']);
  $q_setting->commit();
  $q_setting->closeDetaBase();

  if(!isset($ret) || empty($ret)) {
   $errorcode = "3201";
   $message = "グループIDが既に登録されています。";
   $init_success = false;
  }

 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "group_regist01\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "group_regist02\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }

}
else{ // セッション切れ
 $json_data = array(
  'result'=> "error",
  'errorcode'=> "3101",
  'message'=> "セッションエラー。"
 );
 echo json_encode($json_data);
 return;
}

//--------------------------------------------------------
// 設問グループ登録結果を送信
//--------------------------------------------------------
if ($init_success){
 $json_data = array(
  'result'=> "success"
 );
}else{
 $json_data = array(
  'result'=> "error",
  'errorcode'=> $errorcode,
  'message'=> $message
 );
}
echo json_encode($json_data);
?>
