<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/apicommon.php');

$init_success = false;
$session_change = true;
//--------------------------------------------------------
// セッション(正常なアクセスか判定)チェック
//--------------------------------------------------------
require_once (dirname(__FILE__).'/apisessionchk.php');

$data = array();

//ユーザー有効
if($init_success){
//--------------------------------------------------------
// ユーザーを管理するテーブル(TBL_USER)を読み込む
//--------------------------------------------------------
 try {
  $dispKind = $ret[0]['kind'] ;
  $dispExistence = 0 ;
  if( ($ret[0]['kind'] == 0) || (($ret[0]['authority'] == 0)) ){
   $dispExistence = 2 ;
  }
  else if( $ret[0]['authority'] == 1 ){
   $dispExistence = 1 ;
  }

  $meibo = new meiboDb();
  $ret = $meibo->selectMeibo2($dispKind, $dispExistence, ( $ret[0]['kind'] == 2 ) ? $ret[0]['gekijo_id'] : "", ( $ret[0]['kind'] == 2 ) ? $ret[0]['authority'] : "");
  $meibo->closeDetaBase();
 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "search01\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "search02\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }


 foreach ($ret as $key => $value){
  $data[$key] = array(
   "user_id"=> $value['user_id'],
   "kind"=>$value['kind'],
   "kind_name"=>cnvKind($value['kind']),
   "authority"=>$value['authority'],
   "authority_name"=>cnvAuthority($value['authority']),
   "existence"=>$value['existence'],
   "existence_name"=>cnvExistence($value['existence']),
   "error_cnt"=>$value['error_cnt'],
   "error_cnt_name"=>cnvEerror_cnt($value['error_cnt']),
   "gekijo_id"=>$value['gekijo_id'],
   "comment"=>$value['comment']
  );
 }
}

//--------------------------------------------------------
// ユーザーを管理するテーブル(TBL_USER)のデータを送信
//--------------------------------------------------------
$json_data = array(

 "draw" => 1,
 "recordsTotal" => count($data) ,
 "recordsFiltered" => count($data) ,

 "data" => $data
);
echo json_encode($json_data);  // send data as json format
?>
