<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/apicommon.php');

$init_success = false;
$session_change = true;
//--------------------------------------------------------
// セッション(正常なアクセスか判定)チェック
//--------------------------------------------------------
require_once (dirname(__FILE__).'/apisessionchk.php');

$data = array();

//ユーザー有効
if($init_success){
//--------------------------------------------------------
// アンケートの設問を管理するテーブル(TBL_QUESTION)を読み込む
//--------------------------------------------------------
 try {
  //データベース関数のファイルの読み込み
  require_once ('../../'.L_BASE.'/db/q_setting.php');

  $q_setting = new q_settingDb();
  $ret = $q_setting->selectQsetting();
  $q_setting->closeDetaBase();

 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "setting_init01\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "setting_init02\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }

 foreach ($ret as $key => $value){
  $data[$key] = array(
   "id"=> $value['id'],
   "q_id"=> $value['q_id'],
   "q_name"=>$value['q_name'],
   "q_sentence"=>$value['q_sentence'],
   "group_id"=>$value['group_id']
  );
 }
}

//--------------------------------------------------------
// アンケートの設問を管理するテーブル(TBL_QUESTION)のデータを送信
//--------------------------------------------------------
$json_data = array(
 "draw" => 1,
 "recordsTotal" => count($data) ,
 "recordsFiltered" => count($data) ,

 "data" => $data
);
echo json_encode($json_data);  // send data as json format
?>
