<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/apicommon.php');

// 不正POSTチェック
if(empty($_POST['id'])) {
 echo json_encode(array('result'=> "error"));
 exit();
}

$init_success = false;
$session_change = true;
//--------------------------------------------------------
// セッション(正常なアクセスか判定)チェック
//--------------------------------------------------------
require_once (dirname(__FILE__).'/apisessionchk.php');

$data = array();

//ユーザー有効
if($init_success){
//--------------------------------------------------------
// アンケートの設問を管理するテーブル(TBL_QUESTION)の設問を更新する
//--------------------------------------------------------
 try {
  //データベース関数のファイルの読み込み
  require_once ('../../'.L_BASE.'/db/q_setting.php');

  $q_setting = new q_settingDb();
  $ret = $q_setting->updateQsetting($_POST["id"], $_POST["q_id"], $_POST["q_name"], $_POST["q_sentence"], $_POST["q_explanation"], intval($_POST["q_kind"]), $_POST["q_select"], intval($_POST["q_check"]), intval($_POST["q_minlength"]), intval($_POST["q_maxlength"]), $_POST["q_checkorg"], $_POST["q_checkorgmsg"], $_POST["q_unit"], $_POST["group_id"], $_SESSION['user_id']);
  $q_setting->commit();
  $q_setting->closeDetaBase();

  if(!isset($ret) || empty($ret)) {
    $errorcode = "4201";
    $message = "更新できません。";
    $init_success = false;
  }

 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "setting_update01\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "setting_update02\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }

}
else{ // セッション切れ
 $json_data = array(
  'result'=> "error",
  'errorcode'=> "4101",
  'message'=> "セッションエラー。"
 );
 echo json_encode($json_data);
 return;
}

//--------------------------------------------------------
// 設問更新結果を送信
//--------------------------------------------------------
if ($init_success){
 $json_data = array(
  'result'=> "success"
 );
}else{
 $json_data = array(
  'result'=> "error",
  'errorcode'=> $errorcode,
  'message'=> $message
 );
}
echo json_encode($json_data);
?>
