<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/apicommon.php');

// 不正POSTチェック
if(empty($_POST['gekijo_id'])) {
 echo json_encode(array('result'=> "error"));
 exit();
}

$init_success = false;
$session_change = false;
//--------------------------------------------------------
// セッション(正常なアクセスか判定)チェック
//--------------------------------------------------------
require_once (dirname(__FILE__).'/apisessionchk.php');

// 表示メッセージ
$message = "";
$errorcode = "";

//ユーザー有効
if($init_success){
//--------------------------------------------------------
// 劇場を管理するテーブル(TBL_GEKIJO)から劇場を削除する
//--------------------------------------------------------
 try {
  $meibo = new meiboDb();
  // 劇場に所属するユーザーを削除する
  $ret = $meibo->deleteGekijoUser($_POST["gekijo_id"]);

  if(!isset($ret) || empty($ret)) {
   $init_success = false;
   $meibo->rollback();
   $meibo->beginTransaction();
  }
  else {

//データベース関数のファイルの読み込み
   require_once ('../../'.L_BASE.'/db/gekijo.php');

   $gekijo = new gekijoDb();
   $ret_gekijo = $gekijo->deleteGekijo($_POST["gekijo_id"]);
   $gekijo->commit();
   $gekijo->closeDetaBase();

   if(!isset($ret_gekijo) || empty($ret_gekijo)) {
    $init_success = false;
    $meibo->rollback();
    $meibo->beginTransaction();
   }
  }

  //セッションIDを変更（セッションハイジャック対策）
  session_regenerate_id(TRUE); 
  $meibo->updateSession( session_id(), $_SESSION['user_id'] );
  $meibo->commit();
  $meibo->closeDetaBase();

 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "theater_delete01\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "theater_delete02\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }

}

//--------------------------------------------------------
// 劇場削除結果を送信
//--------------------------------------------------------
if ($init_success){
 $json_data = array(
  'result'=> "success"
 );
}else{
 $json_data = array(
  'result'=> "error"
 );
}
echo json_encode($json_data);
?>
