<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/apicommon.php');

$init_success = false;
$session_change = true;
//--------------------------------------------------------
// セッション(正常なアクセスか判定)チェック
//--------------------------------------------------------
require_once (dirname(__FILE__).'/apisessionchk.php');

$data = array();

//ユーザー有効
if($init_success){
//--------------------------------------------------------
// 劇場を管理するテーブル(TBL_GEKIJO)を読み込む
//--------------------------------------------------------
 try {
  //データベース関数のファイルの読み込み
  require_once ('../../'.L_BASE.'/db/gekijo.php');

  $dispKind = 0 ;
  if($ret[0]['kind'] != 0) {
   $dispKind = 2 ;
  }

  $dispExistence = 0 ;
  if( ($ret[0]['kind'] == 0) || (($ret[0]['kind'] == 1) && ($ret[0]['authority'] == 0)) ){
   $dispExistence = 2 ;
  }
  else if( ($ret[0]['kind'] == 1) && ($ret[0]['authority'] == 1) ){
   $dispExistence = 1 ;
  }

  $gekijo = new gekijoDb();
  $ret_gekijo = $gekijo->selectGekijo2($dispKind, $dispExistence, ( $ret[0]['kind'] == 2 ) ? $ret[0]['gekijo_id'] : "");
  $gekijo->closeDetaBase();
 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "theater_init01\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "theater_init02\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }

 foreach ($ret_gekijo as $key => $value){
  $data[$key] = array(
   "gekijo_id"=> $value['gekijo_id'],
   "gekijo_kind"=>$value['gekijo_kind'],
   "gekijo_existence"=>$value['gekijo_existence'],
   "existence_name"=>cnvExistence($value['gekijo_existence']),
   "gekijo_name"=>$value['gekijo_name'],
   "gekijo_sname"=>$value['gekijo_sname'],
   "gekijo_explanation"=>$value['gekijo_explanation'],
   "user_id"=>$value['user_id']
  );
 }
}

//--------------------------------------------------------
// 劇場を管理するテーブル(TBL_GEKIJO)のデータを送信
//--------------------------------------------------------
$json_data = array(
 "draw" => 1,
 "recordsTotal" => count($data) ,
 "recordsFiltered" => count($data) ,

 "data" => $data
);
echo json_encode($json_data);  // send data as json format
?>
