<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/apicommon.php');

// 不正POSTチェック
if(empty($_POST['gekijo_id'])) {
 echo json_encode(array('result'=> "error"));
 exit();
}

$init_success = false;
$session_change = false;
//--------------------------------------------------------
// セッション(正常なアクセスか判定)チェック
//--------------------------------------------------------
require_once (dirname(__FILE__).'/apisessionchk.php');

// 表示メッセージ
$message = "";
$errorcode = "";

//ユーザー有効
if($init_success){
//--------------------------------------------------------
// 劇場を管理するテーブル(TBL_GEKIJO)に劇場を登録する
//--------------------------------------------------------
 try {
  // ユーザーを管理するテーブル(TBL_USER)に劇場管理者ユーザーを登録
  session_regenerate_id(TRUE); 
  $meibo = new meiboDb();
  $ret = $meibo->insertUser(
   $_POST["gekijo_id"].$_POST["user_id"], password_hash($_POST["gekijo_id"].$_POST["user_id"].$_POST["gekijo_id"].$_POST["user_id"], PASSWORD_DEFAULT),
   intval($_POST["gekijo_kind"]), 0, 0, 0,
   $_POST["gekijo_id"], $_POST["gekijo_sname"], $_SESSION['user_id'], session_id());

  if(!isset($ret) || empty($ret)) {
   $errorcode = "1202";
   $message = "劇場IDが既に登録されています。";
   $init_success = false;
  }
  else {
   //データベース関数のファイルの読み込み
   require_once ('../../'.L_BASE.'/db/gekijo.php');

   $gekijo = new gekijoDb();
   $ret_gekijo = $gekijo->insertGekijo(
    $_POST["gekijo_id"], intval($_POST["gekijo_kind"]), intval($_POST["gekijo_existence"]), $_POST["gekijo_name"], $_POST["gekijo_sname"], $_POST["gekijo_explanation"], $_POST["gekijo_postcode"], $_POST["gekijo_prefectures"], $_POST["gekijo_address1"], $_POST["gekijo_address2"], $_POST["gekijo_address3"], $_POST["gekijo_url"], $_POST["gekijo_tel"], $_POST["gekijo_mail"], $_POST["gekijo_comment"], $_POST["user_id"], $_SESSION['user_id'], 0, 0);

   $gekijo->commit();
   $gekijo->closeDetaBase();

   if(!isset($ret_gekijo) || empty($ret_gekijo)) {
    $errorcode = "1201";
    $message = "劇場IDが既に登録されています。";
    $init_success = false;
    $meibo->rollback();
    $meibo->beginTransaction();

   }
  }

  //セッションIDを変更（セッションハイジャック対策）
  session_regenerate_id(TRUE); 
  $meibo->updateSession( session_id(), $_SESSION['user_id'] );
  $meibo->commit();
  $meibo->closeDetaBase();

 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "theater_regist01\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "theater_regist02\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }

}
else{ // セッション切れ
 $json_data = array(
  'result'=> "error",
  'errorcode'=> "1101",
  'message'=> "セッションエラー。"
 );
 echo json_encode($json_data);
 return;
}

//--------------------------------------------------------
// 劇場登録結果を送信
//--------------------------------------------------------
if ($init_success){
 $json_data = array(
  'result'=> "success"
 );
}else{
 $json_data = array(
  'result'=> "error",
  'errorcode'=> $errorcode,
  'message'=> $message
 );
}

echo json_encode($json_data);
?>
