<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/apicommon.php');

// 不正POSTチェック
if(empty($_POST['gekijo_id'])) {
 echo json_encode(array('result'=> "error"));
 exit();
}

$init_success = false;
$session_change = true;
//--------------------------------------------------------
// セッション(正常なアクセスか判定)チェック
//--------------------------------------------------------
require_once (dirname(__FILE__).'/apisessionchk.php');

// 表示メッセージ
$message = "";
$errorcode = "";

//ユーザー有効
if($init_success){
//--------------------------------------------------------
// 劇場を管理するテーブル(TBL_GEKIJO)の劇場を更新する
//--------------------------------------------------------
 try {
 //データベース関数のファイルの読み込み
  require_once ('../../'.L_BASE.'/db/gekijo.php');

  $gekijo = new gekijoDb();
  $ret_gekijo = $gekijo->updateGekijo(
   $_POST["gekijo_id"], intval($_POST["gekijo_kind"]), intval($_POST["gekijo_existence"]), $_POST["gekijo_name"], $_POST["gekijo_sname"], $_POST["gekijo_explanation"], $_POST["gekijo_postcode"], $_POST["gekijo_prefectures"], $_POST["gekijo_address1"], $_POST["gekijo_address2"], $_POST["gekijo_address3"], $_POST["gekijo_url"], $_POST["gekijo_tel"], $_POST["gekijo_mail"], $_POST["gekijo_comment"], $_POST["user_id"], $_SESSION['user_id'], 0, 0);

  $gekijo->commit();
  $gekijo->closeDetaBase();

  if(!isset($ret_gekijo) || empty($ret_gekijo)) {
   $errorcode = "1203";
   $message = "更新できません。";
   $init_success = false;
  }

 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "theater_update01\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "theater_update02\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }

}
else{ // セッション切れ
 $json_data = array(
  'result'=> "error",
  'errorcode'=> "1101",
  'message'=> "セッションエラー。"
 );
 echo json_encode($json_data);
 return;
}

//--------------------------------------------------------
// 劇場更新結果を送信
//--------------------------------------------------------
if ($init_success){
 $json_data = array(
  'result'=> "success" //"success"error
 );
}else{
 $json_data = array(
  'result'=> "error",
  'errorcode'=> $errorcode,
  'message'=> $message
 );
}
echo json_encode($json_data);
?>
