<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/apicommon.php');

// 不正POSTチェック
if(empty($_POST['user_id'])) {
 echo json_encode("error");
 exit();
}

$init_success = false;
$session_change = false;
//--------------------------------------------------------
// セッション(正常なアクセスか判定)チェック
//--------------------------------------------------------
require_once (dirname(__FILE__).'/apisessionchk.php');

// 表示メッセージ
$message = "";
$errorcode = "";

//ユーザー有効
if($init_success){
//--------------------------------------------------------
// ユーザーを管理するテーブル(TBL_USER)のユーザーを更新
//--------------------------------------------------------
 try {
  session_regenerate_id(TRUE); 
  $meibo = new meiboDb();
  $ret = $meibo->updateUser(
   $_POST["user_id"], password_hash($_POST["password"], PASSWORD_DEFAULT),
   intval($_POST["kind"]), intval($_POST["authority"]), intval($_POST["existence"]), intval($_POST["error_cnt"]),
   $_POST["gekijo_id"], $_POST["comment"], $_SESSION['user_id'], session_id());

  //セッションIDを変更（セッションハイジャック対策）
  session_regenerate_id(TRUE); 
  $meibo->updateSession( session_id(), $_SESSION['user_id'] );

  $meibo->commit();
  $meibo->closeDetaBase();

  if(!isset($ret) || empty($ret)) {
    $errorcode = "2201";
    $message = "更新できません。";
    $init_success = false;
  }
 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "update01\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "update02\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }
}
else{ // セッション切れ
 $json_data = array(
  'result'=> "error",
  'errorcode'=> "2101",
  'message'=> "セッションエラー。"
 );
 echo json_encode($json_data);
 return;
}

//--------------------------------------------------------
// ユーザー登録結果を送信
//--------------------------------------------------------
if ($init_success){
 $json_data = array(
  'result'=> "success"
 );
}else{
 $json_data = array(
  'result'=> "error",
  'errorcode'=> $errorcode,
  'message'=> $message
 );
}
echo json_encode($json_data);

?>
