<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/common.php');

// セッションチェック
// ログインしていない場合はログインページにリダイレクト
require_once (dirname(__FILE__).'/sessionchk.php');

// ページ名
define('PAGE_NAME', 'グループ設定');

?>


<!DOCTYPE html>
<html lang="ja">
<head>
 <meta charset="utf-8">
 <title><?php echo P_TITLE;?> | <?php echo PAGE_NAME;?></title>

 <meta http-equiv="X-UA-Compatible" content="IE=edge">
 <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

 <link rel="stylesheet" type="text/css" href="css/dataTables.bootstrap.min.css"/>
 <link rel="stylesheet" type="text/css" href="css/bootstrap.min.css"/>
 <link href="css/style.css" rel="stylesheet">

</head>
<body>

 <?php include 'inc/header.php'; ?> <!-- ヘッダー共通部 -->
 <?php include 'inc/pagename.php'; ?> <!-- ページ名共通部 -->

 <div class="container-fluid">
  <div class="row">
   <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
   <div class="col-sm-12 col-md-10" style="background-color:white;">
    <div>
     <table id="myTable" class="table table-striped tagle-bordered">
      <thead>
       <tr>
        <th>ID</th>
        <th>名称</th>
        <th>説明</th>
        <th>作成者</th>
        <th>作成日</th>
        <th>更新者</th>
        <th>更新日</th>
        <th></th>
       </tr>
      </thead>
      <tbody>
<?php $message; ?>
      </tbody>
      <tfoot>
       <tr>
        <th>ID</th>
        <th>名称</th>
        <th>説明</th>
        <th>作成者</th>
        <th>作成日</th>
        <th>更新者</th>
        <th>更新日</th>
        <th></th>
       </tr>
      </tfoot>
     </table>
    </div>
    <div style="height:60px">
     <hr>
     <div class="pull-left">
<?php if ($user_authority <= 2): ?>
      <button id="registButton" type="button" class="btn btn-primary">登録</button>
<?php endif; ?>
<?php if ($user_authority <= 1): ?>
      <button id="updateButton" type="button" class="btn btn-success" disabled>更新</button>
<?php endif; ?>
     </div>
<?php if ($user_kind == 0): ?>
     <div class="pull-right">
      <button id="deleteButton" type="button" class="btn btn-danger" disabled>削除</button>
     </div>
<?php endif; ?>
     <br>
    </div>
   </div>
   <div id="form" class="modal fade" tabindex="-1">
    <div class="modal-dialog modal-dialog-centered ">
     <div class="modal-content">
      <div class="modal-header">
       <h4 id="dialogTitle" class="modal-title">登録</h4>
       <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
      </div>
      <div class="modal-body">
       <div class="container-fluid">
        <div class="row">
         <div class="col-lg-12">
          <div id="alert_form"></div>
          <form class="form-horizontal" id="sample-form">
           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputId">グループID (必須)</label>
            <div class="col-sm-8">
             <input type="text" class="form-control ime-disabled" id="inputId" name="inputId" placeholder="半角英数字4文字" />
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputName">グループ名称 (必須)</label>
            <div class="col-sm-8">
             <input type="text" class="form-control ime-disabled" id="inputName" name="inputName" placeholder="グループ名称" />
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputExplanation">グループ説明 (必須)</label>
            <div class="col-sm-8">
             <input type="text" class="form-control ime-disabled" id="inputExplanation" name="inputExplanation" placeholder="グループ説明" />
            </div>
           </div>
          </form>
         </div>
        </div>
       </div>
      </div>
      <div class="modal-footer">
       <div id="inputError" class="float-left" style="color:red; padding:5px;"></div>
       <button id="sendRegistButton" type="button" class="btn btn-primary"><i class="fa fa-check"></i>&nbsp;登録</button>
       <button id="sendUpdateButton" type="button" class="btn btn-primary"><i class="fa fa-check"></i>&nbsp;修正</button>
       <button type="button" class="btn btn-default" data-dismiss="modal"><i class="fa fa-remove"></i>&nbsp;閉じる</button>
      </div>
     </div>
    </div>

    <!-- Modal -->
    <div class="modal fade" id="messageModalSuccess" role="dialog">
     <div class="modal-dialog">
      <!-- Modal content-->
      <div class="modal-content modalmsg-success">
       <div class="modal-header">
        <h4 class="modal-title" id="modalSuccessLabel"></h4>
       </div>
      </div>
     </div>
    </div>

    <!-- Modal -->
    <div class="modal fade" id="messageModalError" role="dialog">
     <div class="modal-dialog">
      <!-- Modal content-->
      <div class="modal-content modalmsg-danger">
       <div class="modal-header">
        <button type="button" class="close"  id="modalErrorClose">
         <span aria-hidden="true">&times;</span>
        </button>
        <h4 class="modal-title" id="modalErrorLabel"></h4>
       </div>
       <div class="modal-body modalmsg-body" id="modalErrorMsg">
       </div>
      </div>
     </div>
    </div>

   </div>
   <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
  </div>
 </div>

 <?php include 'inc/footer.php'; ?> <!-- フッター共通部 -->

</body>
 <script type="text/javascript" src="js/jquery-3.5.1.js"></script>
 <script type="text/javascript" src="js/bootstrap.min.js"></script>
 <script type="text/javascript" src="js/jquery.dataTables.min.js"></script>
 <script type="text/javascript" src="js/dataTables.bootstrap.min.js"></script>
 <script type="text/javascript" src="js/bootbox.min.js"></script>
 <script type="text/javascript" src="js/jquery.validate.js"></script>
 <script type="text/javascript" src="js/validate-ja.js"></script>
 <script type="text/javascript" src="js/group.js"></script>
</html>
