/*!
 * account.js v1.0.0
 */

var activeRowIndex = "";
var formFocus = "#inputUser";
var errorCode = "";
var updateSkip = true;
var registSkip = true;

$(document).ready( function () {
 $('#myTable').DataTable({
  'paging'      : true,
  'pageLength'  : 10,
  'lengthChange': false,
  'searching'   : true,
  'ordering'    : true,
  'info'        : true,
  'autoWidth'   : true,
  "scrollCollapse": true,
  'scrollX'     : true,
  'scrollY'     : '275px',
  'tabIndex'    : -1,
  'order'       : [[ 0, 'asc' ]],
  'colReorder'  : true,
  'serverSide'  : false,
  'ajax'        : {
   'url': './api/init.php',
   'type' : 'POST',
   'data' : function ( d ) {
    d.searchName = $("#searchName").val();
   }
  },
  'columns'     : [
   { 'data' : 'user_id', width: 100 },
   { 'data' : 'kind_name', width: 80  },
   { 'data' : 'authority_name', width: 60  },
   { 'data' : 'existence_name', width: 60  },
   { 'data' : 'error_cnt_name', width: 60  },
   { 'data' : 'gekijo_id', width: 100  },
   { 'data' : 'comment', width: 120  },
  ],
  'language'   : {
   'decimal':        ".",
   'emptyTable':     "表示するデータがありません。",
   'info':           "_START_ ～ _END_ / _TOTAL_ 件中",
   'infoEmpty':      "0 ～ 0 / 0 件",
   'infoFiltered':   "(合計 _MAX_ 件からフィルタリングしています)",
   'infoPostFix':    "",
   'thousands':      ",",
   'lengthMenu':     "1ページ _MENU_ 件を表示する",
   'loadingRecords': "読み込み中...",
   'processing':     "処理中...",
   'search':         "絞り込み:",
   'zeroRecords':    "一致するデータが見つかりません。",
   'paginate': {
       'first':      "最初",
       'last':       "最後",
       'next':       "次",
       'previous':   "前"
   }
  }
 });

 // ページ変更の設定
 $("#myTable").on('draw.dt', function () {
  $("#myTable tr").removeClass("active");

  activeRowIndex = "";
  $("#updateButton").prop("disabled", true);
  $("#deleteButton").prop("disabled", true);
 });

 // テーブル行クリックの設定
 $('#myTable tbody').on("click", "tr", function() {
  if ($(this).find('.dataTables_empty').length == 0) {
   owner = $(this);

   $("#myTable tr").removeClass("active");
   owner.addClass("active");

   $("#updateButton").prop("disabled", false);
   $("#deleteButton").prop("disabled", false);
   activeRowIndex = owner[0]._DT_RowIndex;
  }
 });

 // 検索ボタンクリック時の処理
 $("#searchButton").on("click", function() {
  $('#myTable').DataTable().ajax.url("./api/search.php").load();
  $('#myTable').DataTable().ajax.reload();
 });

 // 登録ボタンクリック時の処理
 $("#registButton").on("click", function() {
  registSkip = false;
  updateSkip = true;
  errorCode = "";

  // ダイアログ表示
  $('#alert_form').removeClass();
  $("#alert_form").html("");

  $('#form').on('show.bs.modal', function (event) {
   if(registSkip) {
    return;
   }

   // コントロール制御
   $("#form #dialogTitle").text("新規登録");
   $("#form #sendRegistButton").show();
   $("#form #sendUpdateButton").hide();
   $("#form #inputUser").prop("disabled", false);
   $("#form #inputAuthority").prop("disabled", false);

   // フォーカス
   setTimeout(function() {
    $(formFocus).focus() ;
    if (errorCode != "") {
     $("#form " + formFocus).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
     $("#form " + formFocus).next( "span" ).addClass( "glyphicon-remove" ).removeClass( "glyphicon-ok" );
    }
   }, 500);
  }).modal({backdrop: 'static', keyboard: true, show: true});
 });

 // 登録送信ボタンクリック時の処理
 $("#sendRegistButton").on("click", function(){
  registSkip = true;
  updateSkip = true;

  var param = {};
  param['user_id'] = $("#inputUser").val();
  param['password'] = $("#inputPass").val();
  param['kind'] = $("#inputKind").val();
  param['authority'] = $("#inputAuthority").val();
  param['existence'] = $("#inputExistence").val();
  param['error_cnt'] = $("#inputError_cnt").val();
  param['gekijo_id'] = $("#inputGekijo_id").val();
  param['comment'] = $("#inputComment").val();

  if ($('#sample-form').valid()) {
   // バリデーションOKの処理
   $.ajax({
    url: "./api/regist.php",
    type: "POST",
    data: param, // JSON.stringify(param),
    success: function(jsonResponse) {
     var data = JSON.parse(jsonResponse);
     formFocus = "#inputUser";
     errorCode = "";
     if(data.result == 'error') {
      errorCode = data.errorcode;

      if(data.errorcode == '2101') {
       window.location.href= "logout";
       return;
      }
      else if(data.errorcode == '2201') {
       formFocus = "#inputUser";
      }
      else {
       formFocus = "#inputUser";
      }
  　  $("#alert_form").html("");
  　  $("#modalErrorLabel").html("登録できません");
  　  $("#modalErrorMsg").html("エラーコード：" + data.errorcode +"<br>"+ data.message);
      $('#messageModalError').modal({
       backdrop: 'static',
       keyboard: true, 
       show: true
      }); 
      return;
     }

     $("#alert_form").html("");

     $("#modalSuccessLabel").html("登録しました");
     $( "#messageModalSuccess" ).modal( "show" ) ;
     setTimeout( function() {
      $( "#messageModalSuccess" ).modal( "hide" ) ;
      $( "#form" ).modal( "hide" );
     }, 2000 );


     // テーブル更新
     $('#myTable').DataTable().ajax.url("./api/search.php").load() ;
    },
    error: function() {
　   $('#alert_form').removeClass().addClass("alert alert-danger");
     $("#alert_form").html("<p>ただいま登録できません</p>");
    }
   });

  } else {
   // バリデーションNGの処理
   $('#alert_form').removeClass().addClass("alert alert-danger");
   $("#alert_form").html("<p>赤く表示された入力内容を訂正して登録してください</p>");
  }
 });

 // 更新ボタンクリック時の処理
 $("#updateButton").on("click", function() {
  registSkip = true;
  updateSkip = true;
  errorCode = "";
  $('#alert_form').removeClass();
  $("#alert_form").html("");

  var selectedRows = $('#myTable').DataTable().rows(activeRowIndex).data();

  var param = {};
  param['user_id'] = selectedRows[0].user_id;

  $.ajax({
   url: "./api/getRecord.php",
   type: "POST",
   data: param, // JSON.stringify(param),
   success: function(jsonResponse) {
    var data = JSON.parse(jsonResponse);
    var cat = data[0];
    // セッション切れ
    if(data.length == 0) {
     window.location.href= "logout";
     return;
    }
    updateSkip = false;

    // ダイアログ表示
    $('#form').on('show.bs.modal', function (event) {
     if(updateSkip) {
      return;
     }

     // 取得したデータのセット
     $("#inputUser").val(cat.user_id);
     $("#inputPass").val("");
     $("#inputKind").val(( '00' + cat.kind ).slice( -2 ));
     $("#inputAuthority").val(( '00' + cat.authority ).slice( -2 ));
     $("#inputExistence").val(( '00' + cat.existence ).slice( -2 ));
     $("#inputError_cnt").val(( '00' + cat.error_cnt ).slice( -2 ));
     $("#inputGekijo_id").val(cat.gekijo_id);
     $("#inputComment").val(cat.comment);
 
     // コントロール制御
     $("#form #dialogTitle").text("更新");
     $("#form #sendRegistButton").hide();
     $("#form #sendUpdateButton").show();
     $("#form #inputUser").prop("disabled", true);
     if(cat.authority == 0) {
      $("#form #inputAuthority").prop("disabled", true);
     }
     else {
      $("#form #inputAuthority").prop("disabled", false);
     }

     // フォーカス
     setTimeout(function() {
      $(formFocus).focus() ;
      if (errorCode != "") {
       $("#form " + formFocus).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
       $("#form " + formFocus).next( "span" ).addClass( "glyphicon-remove" ).removeClass( "glyphicon-ok" );
      }
     }, 500);

    }).modal({backdrop: 'static', keyboard: true, show: true});
 
   },
   error: function() {
    $('#alert_form').removeClass().addClass("alert alert-danger");
    $("#alert_form").html("<p>ただいま登録できません</p>");
   }
  });
 });

 // 更新送信ボタンクリック時の処理
 $("#sendUpdateButton").on("click", function(){
  registSkip = true;
  updateSkip = true;

  var param = {};

  param['user_id'] = $("#inputUser").val();
  param['password'] = $("#inputPass").val();
  param['kind'] = $("#inputKind").val();
  param['authority'] = $("#inputAuthority").val();
  param['existence'] = $("#inputExistence").val();
  param['error_cnt'] = $("#inputError_cnt").val();
  param['gekijo_id'] = $("#inputGekijo_id").val();
  param['comment'] = $("#inputComment").val();

  if ($('#sample-form').valid()) {
   // バリデーションOKの処理

   $.ajax({
    url: "./api/update.php",
    type: "POST",
    data: param, // JSON.stringify(param),
    success: function(jsonResponse) {
     var data = JSON.parse(jsonResponse);
     formFocus = "#inputUser";
     errorCode = "";
     if(data.result == 'error') {
      errorCode = data.errorcode;

      if(data.errorcode == '2101') {
       window.location.href= "logout";
       return;
      }
      else if(data.errorcode == '2201') {
       formFocus = "#inputUser";
      }
      else {
       formFocus = "#inputUser";
      }
  　  $("#alert_form").html("");
  　  $("#modalErrorLabel").html("更新できません");
  　  $("#modalErrorMsg").html("エラーコード：" + data.errorcode +"<br>"+ data.message);
      $('#messageModalError').modal({
       backdrop: 'static',
       keyboard: true, 
       show: true
      }); 
      return;
     }

  　 $("#alert_form").html("");

  　 $("#modalSuccessLabel").html("更新しました");
     $( "#messageModalSuccess" ).modal( "show" ) ;
      setTimeout( function() {
       $( "#messageModalSuccess" ).modal( "hide" ) ;
       $( "#form" ).modal( "hide" );
      }, 2000 );

     // テーブル更新
     $('#myTable').DataTable().ajax.url("./api/search.php").load() ;
    },
    error: function() {
　   $('#alert_form').removeClass().addClass("alert alert-danger");
     $("#alert_form").html("<p>ただいま更新できません</p>");
    }
   });

  } else {
  // バリデーションNGの処理
   $('#alert_form').removeClass().addClass("alert alert-danger");
   $("#alert_form").html("<p>赤く表示された入力内容を訂正して登録してください</p>");
  }
 });

 // 削除ボタンクリック時の処理
 $("#deleteButton").on("click", function(){
  if($('#myTable').DataTable().rows(activeRowIndex).data()[0].kind == 0) {
   bootbox.alert({
    message: "このアカウントは削除できません。",
    size: 'small'
   });
   return;
  }
  bootbox.confirm({
   message: "本当に削除しますか？",
   buttons: {
    confirm: {
     label: '削除',
     className: 'btn-danger'
    },
    cancel: {
     label: '取消',
     className: 'btn-primary'
    }
   },
   callback: function (result) {
    if (result) {
     var selectedRows = $('#myTable').DataTable().rows(activeRowIndex).data();

     var param = {};
     param['user_id'] = selectedRows[0].user_id;
 
     $.ajax({
      url: "./api/delete.php",
      type: "POST",
      data: param, // JSON.stringify(param),
      success: function(jsonResponse) {
       var data = JSON.parse(jsonResponse);
       if(data.result == 'success') {
        $(this).find('.bootbox-body').html('削除しました');
        $(this).find('.bootbox-accept').hide();

        // テーブル更新
        $('#myTable').DataTable().ajax.url("./api/search.php").load() ;
       }
       else {
        // セッション切れ
        window.location.href= "logout";
        return;
       }
      },
      error: function() {
      $("#modalErrorLabel").html("削除できません");
　     $("#modalErrorMsg").html("通信エラー");
       $('#messageModalError').modal({
        backdrop: 'static',
        keyboard: true, 
        show: true
　     }); 
       setTimeout( function() {
        $( "#messageModalError" ).modal( "hide" ) ;
       }, 2000 );
      }
     });
    } else {
    }
   }
  });
 
 });

 // モーダルウインドウ表示処理
 $(document).on('hidden.bs.modal', function () {
  if ($('.modal').is(':visible')) $('body').addClass('modal-open');
 });

 // モーダルウインドウ消去処理
 $("#modalErrorClose").on("click", function(){
  $( "#messageModalError" ).modal( "hide" ) ;

  setTimeout(function(){
   $(formFocus).focus();
   if (errorCode != "") {
    $("#form " + formFocus).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
    $("#form " + formFocus).next( "span" ).addClass( "glyphicon-remove" ).removeClass( "glyphicon-ok" );
   }
  }, 100);
 });

 // 入力チェック処理
 jQuery.validator.addMethod("isUser", function(value, element) {
  return this.optional( element ) || /(?=.*?[a-z])(?=.*?[A-Z])(?=.*?\d)[a-zA-Z\d]{8}/.test( value );
 }, '英大文字、英小文字、数字すべて含む半角８文字入力してください。');

 jQuery.validator.addMethod("isPass", function(value, element) {
  return this.optional( element ) || /(?=.*?[a-z])(?=.*?[A-Z])(?=.*?\d)[a-zA-Z\d]{8,}/.test( value );
 }, '英大文字、英小文字、数字すべて含む半角８文字以上入力してください。');

 jQuery.validator.addMethod("isGekijo", function(value, element) {
  return this.optional( element ) || /(?=.*?[a-z])(?=.*?[A-Z])(?=.*?\d)[a-zA-Z\d]{4}/.test( value );
 }, '英大文字、英小文字、数字すべて含む半角４文字入力してください。');

 $( "#sample-form" ).validate( {
  rules: {
   inputUser: {
    required: true,
    isUser: true,
    maxlength: 8
   },
   inputPass: {
    required: true,
    isPass: true,
    maxlength: 20
   },
   inputKind: {
    required: true
   },
   inputAuthority: {
    required: true
   },
   inputExistence: {
    required: true
   },
   inputError_cnt: {
    required: true
   },
   inputGekijo_id: {
    required: true,
    isGekijo: true,
    maxlength: 4
   },
   inputComment: {
    maxlength: 150
   }
  },
  messages: {
   inputUser: {
    required: "ユーザーID（必須）を入力してください。",
    maxlength: "８文字で入力してください。"
   },
   inputPass: {
    required: "パスワード（必須）を入力してください。",
    maxlength: "２０文字以内で入力してください。"
   },
   inputKind: {
    required: "ユーザー種別（必須）を選択してください。"
   },
   inputAuthority: {
    required: "ユーザー権限（必須）を選択してください。"
   },
   inputExistence: {
    required: "ユーザー状態（必須）を選択してください。"
   },
   inputError_cnt: {
    required: "ユーザー状態（必須）を選択してください。"
   },
   inputGekijo_id: {
    required: "所属する劇場IDを入力してください。",
    maxlength: "４文字で入力してください。"
   },
   inputComment: {
    maxlength: "１５０文字以内で入力してください。"
   }
  },
  errorElement: "em",
  errorPlacement: function ( error, element ) {
   // Add the `help-block` class to the error element
   error.addClass( "help-block" );

   // Add `has-feedback` class to the parent div.form-group
   // in order to add icons to inputs
   element.parents( ".col-sm-8" ).addClass( "has-feedback" );

   if ( element.prop( "type" ) === "checkbox" ) {
    error.insertAfter( element.parent( "label" ) );
   } else {
    error.insertAfter( element );
   }

   // Add the span element, if doesn't exists, and apply the icon classes to it.
   if ( !element.next( "span" )[ 0 ] ) {
    $( "<span class='glyphicon glyphicon-remove form-control-feedback'></span>" ).insertAfter( element );
   }

  },
  success: function ( label, element ) {
   // Add the span element, if doesn't exists, and apply the icon classes to it.
   if ( !$( element ).next( "span" )[ 0 ] ) {
    $( "<span class='glyphicon glyphicon-ok form-control-feedback'></span>" ).insertAfter( $( element ) );
   }
  },
  highlight: function ( element, errorClass, validClass ) {
   $( element ).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
   $( element ).next( "span" ).addClass( "glyphicon-remove" ).removeClass( "glyphicon-ok" );
  },
  unhighlight: function (element, errorClass, validClass) {
   $( element ).parents( ".col-sm-8" ).addClass( "has-success" ).removeClass( "has-error" );
   $( element ).next( "span" ).addClass( "glyphicon-ok" ).removeClass( "glyphicon-remove" );
  }
 });

 // ビジーwaitを使う方法
 function sleep(waitMsec) {
  var startMsec = new Date();
 
  // 指定ミリ秒間だけループさせる（CPUは常にビジー状態）
  while (new Date() - startMsec < waitMsec);
 }

});
