/*!
 * administration.js v1.0.0
 */

var activeRowIndex = "";
var formFocus = "#inputAid";
var errorCode = "";
var updateSkip = true;
var registSkip = true;

var updateRecordId = 0;
$(document).ready( function () {
 $('#myTable').DataTable({
  'paging'      : true,
  'pageLength'  : 10,
  'lengthChange': false,
  'searching'   : true,
  'ordering'    : true,
  'info'        : true,
  'autoWidth'   : true,
  "scrollCollapse": true,
  'scrollX'     : true,
  'scrollY'     : '275px',
  'tabIndex'    : -1,
  'order'       : [[ 0, 'asc' ]],
  'colReorder'  : true,
  'serverSide'  : false,
  'ajax'        : {
   'url': './api/admin_init.php',
   'type' : 'POST',
   'data' : function ( d ) {
    d.searchName = $("#searchName").val();
   }
  },
  'columns'     : [
   { 'data' : 'gekijo_id', width: 40 },
   { 'data' : 'a_id', width: 40 },
   { 'data' : 'a_name', width: 300  },
   { 'data' : 'count', width: 40  },
   { 'data' : 'countAll', width: 40  },
   { 'data' : 'existence_name', width: 40  },
   { 'data' : 'a_start', width: 120  },
   { 'data' : 'a_end', width: 120  },
   { 'data' : 'id', width: 0 },
  ],
  'columnDefs': [ 
   { 'targets': [8], 'visible': false },
  ],
  'language'   : {
   'decimal':        ".",
   'emptyTable':     "表示するデータがありません。",
   'info':           "_START_ ～ _END_ / _TOTAL_ 件中",
   'infoEmpty':      "0 ～ 0 / 0 件",
   'infoFiltered':   "(合計 _MAX_ 件からフィルタリングしています)",
   'infoPostFix':    "",
   'thousands':      ",",
   'lengthMenu':     "1ページ _MENU_ 件を表示する",
   'loadingRecords': "読み込み中...",
   'processing':     "処理中...",
   'search':         "絞り込み:",
   'zeroRecords':    "一致するデータが見つかりません。",
   'paginate': {
    'first':      "最初",
    'last':       "最後",
    'next':       "次",
    'previous':   "前"
   }
  }
 });

 // ページ変更の設定
 $("#myTable").on('draw.dt', function () {
  $("#myTable tr").removeClass("active");

  activeRowIndex = "";
  $("#updateButton").prop("disabled", true);
  $("#deleteButton").prop("disabled", true);
  $("#dispButton").prop("disabled", true);
  $("#resultButton").prop("disabled", true);
  $("#reportButton").prop("disabled", true);

 });

 // テーブル行クリックの設定
 $('#myTable tbody').on("click", "tr", function() {
  if ($(this).find('.dataTables_empty').length == 0) {
   owner = $(this);
   $("#myTable tr").removeClass("active");
   owner.addClass("active");

   $("#updateButton").prop("disabled", false);
   $("#deleteButton").prop("disabled", false);
   $("#dispButton").prop("disabled", false);
   $("#resultButton").prop("disabled", false);
   $("#reportButton").prop("disabled", false);
   activeRowIndex = owner[0]._DT_RowIndex;

  }
 });

 // 検索ボタンクリック時の処理
 $("#searchButton").on("click", function() {
  $('#myTable').DataTable().ajax.url("./api/admin_search.php").load();
  $('#myTable').DataTable().ajax.reload();
 });

 // 登録ボタンクリック時の処理
 $("#registButton").on("click", function() {
  registSkip = false;
  updateSkip = true;
  errorCode = "";

  // ダイアログ表示
  $('#alert_form').removeClass();
  $("#alert_form").html("");

  $('#form').on('show.bs.modal', function (event) {
   if(registSkip) {
    return;
   }

   inputClear();
   // コントロール制御
   $("#form #dialogTitle").text("新規登録");
   $("#form #sendRegistButton").show();
   $("#form #sendUpdateButton").hide();
 
   // フォーカス
   setTimeout(function() {
    $(formFocus).focus() ;
    if (errorCode != "") {
     $("#form " + formFocus).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
     $("#form " + formFocus).next( "span" ).addClass( "glyphicon-remove" ).removeClass( "glyphicon-ok" );
    }
   }, 500);
 
  }).modal({backdrop: 'static', keyboard: true, show: true});
 });
 
 // 登録送信ボタンクリック時の処理
 $("#sendRegistButton").on("click", function(){
  registSkip = true;
  updateSkip = true;

  var param = {};

  param['gekijo_id'] = $("#inputGid").val();
  param['a_id'] = $("#inputAid").val();
  param['a_name'] = $("#inputAname").val();
  param['a_explanation'] = $("#inputAexplanation").val();
  param['a_existence'] = $("#inputAexistence").val();
  param['a_start'] = $("#inputAstart").val();
  param['a_end'] = $("#inputAend").val();

  var q_idArray = new Array();
  var data= null;
  $('.inputQid').each(function(){
   data= {
    qid:$(this).val() ,
    req:true
   };
   q_idArray.push(data);
  });
  var qctr = 0;
  $('.inputReq').each(function(){
   q_idArray[qctr]['req'] = $(this).prop('checked');
   qctr = qctr + 1;
  });
  param['a_qid'] = q_idArray;

  if ($('#sample-form').valid()) {
   // バリデーションOKの処理

   $.ajax({
    url: "./api/admin_regist.php",
    type: "POST",
    data: param, // JSON.stringify(param),
    success: function(jsonResponse) {
     var data = JSON.parse(jsonResponse);
     formFocus = "#inputAid";
     errorCode = "";
     if(data.result == 'error') {
      errorCode = data.errorcode;

      if(data.errorcode == '5101') {
       window.location.href= "logout";
       return;
      }
      else if(data.errorcode == '5201') {
       formFocus = "#inputAid";
      }
      else if(data.errorcode == '5202') {
       formFocus = "#inputQid";
      }
      else if(data.errorcode == '5203') {
       formFocus = "#inputQid";
      }
      else if(data.errorcode == '5204') {
       formFocus = "#inputQid";
      }
      else {
       formFocus = "#inputAid";
      }
      $("#alert_form").html("");
      $("#modalErrorLabel").html("登録できません");
      $("#modalErrorMsg").html("エラーコード：" + data.errorcode +"<br>"+ data.message);
      $('#messageModalError').modal({
       backdrop: 'static',
       keyboard: true, 
       show: true
      }); 
      return;
     }
     $("#alert_form").html("");
     $("#modalSuccessLabel").html("登録しました");
     $( "#messageModalSuccess" ).modal( "show" ) ;
     setTimeout( function() {
      $( "#messageModalSuccess" ).modal( "hide" ) ;
      $( "#form" ).modal( "hide" );
     }, 2000 );

     // テーブル更新
     $('#myTable').DataTable().ajax.url("./api/admin_search.php").load() ;
    },
    error: function() {
     $('#alert_form').removeClass().addClass("alert alert-danger");
     $("#alert_form").html("<p>ただいま登録できません</p>");
    }
   });

  } else {
   // バリデーションNGの処理
   $('#alert_form').removeClass().addClass("alert alert-danger");
   $("#alert_form").html("<p>赤く表示された入力内容を訂正して登録してください</p>");
  }
 });

 // 更新ボタンクリック時の処理
 $("#updateButton").on("click", function() {
  registSkip = true;
  updateSkip = true;
  errorCode = "";
  $('#alert_form').removeClass();
  $("#alert_form").html("");
  var selectedRows = $('#myTable').DataTable().rows(activeRowIndex).data();
  var param = {};
  param['id'] = selectedRows[0].id;

  $.ajax({
   url: "./api/adminRecord.php",
   type: "POST",
   data: param, // JSON.stringify(param),
   success: function(jsonResponse) {
    var data = JSON.parse(jsonResponse);
    var cat = data[0];
    // セッション切れ
    if(data.length == 0) {
     window.location.href= "logout";
     return;
    }
    updateSkip = false;

    // ダイアログ表示
    $('#form').on('show.bs.modal', function (event) {
     if(updateSkip) {
      return;
     }
     inputClear();

     // 取得したデータのセット
     $("#inputGid").val(cat.gekijo_id);
     $("#inputAid").val(cat.a_id);
     $("#inputAname").val(cat.a_name);
     $("#inputAexplanation").val(cat.a_explanation);
     $("#inputAexistence").val(( '00' + cat.a_existence ).slice( -2 ));
     $("#inputAstart").val(cat.a_start);
     $("#inputAend").val(cat.a_end);

     if($('#demo-area .unit').length == 1){

      var q_idArray = new Array();
      q_idArray = cat.a_qid;

      for (let i = 0; i < q_idArray.length; i++) {
       if(i == 0) {
        $('.inputQid').each(function(){
         $(this).val(q_idArray[i].qid);
        });
        $('.inputReq').each(function(){
           $(this).prop('checked', q_idArray[i].req);
        });
       }
       else {
        inputPlus(q_idArray[i]);
       }
      }

     }

     // コントロール制御
     $("#form #dialogTitle").text("更新");
     $("#form #sendRegistButton").hide();
     $("#form #sendUpdateButton").show();

     // フォーカス
     setTimeout(function() {
      $(formFocus).focus() ;
      if (errorCode != "") {
       $("#form " + formFocus).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
       $("#form " + formFocus).next( "span" ).addClass( "glyphicon-remove" ).removeClass( "glyphicon-ok" );
      }
     }, 500);

    }).modal({backdrop: 'static', keyboard: true, show: true});
 
   },
   error: function() {
    $('#alert_form').removeClass().addClass("alert alert-danger");
    $("#alert_form").html("<p>ただいま登録できません</p>");
   }
  });
 });

 // 更新送信ボタンクリック時の処理
 $("#sendUpdateButton").on("click", function(){
  registSkip = true;
  updateSkip = true;
  var selectedRows = $('#myTable').DataTable().rows(activeRowIndex).data();
  var param = {};
  param['id'] = selectedRows[0].id;
  param['gekijo_id'] = $("#inputGid").val();
  param['a_id'] = $("#inputAid").val();
  param['a_name'] = $("#inputAname").val();
  param['a_explanation'] = $("#inputAexplanation").val();
  param['a_existence'] = $("#inputAexistence").val();
  param['a_start'] = $("#inputAstart").val();
  param['a_end'] = $("#inputAend").val();
  var q_idArray = new Array();
  var data= null;
  $('.inputQid').each(function(){
   data= {
    qid:$(this).val() ,
    req:true
   };
   q_idArray.push(data);
  });
  var qctr = 0;
  $('.inputReq').each(function(){
   q_idArray[qctr]['req'] = $(this).prop('checked');
   qctr = qctr + 1;
  });
  param['a_qid'] = q_idArray;

  if ($('#sample-form').valid()) {
   // バリデーションOKの処理
   $.ajax({
    url: "./api/admin_update.php",
    type: "POST",
    data: param,
    success: function(jsonResponse) {
     var data = JSON.parse(jsonResponse);
     formFocus = "#inputAid";
     errorCode = "";
     if(data.result == 'error') {
      errorCode = data.errorcode;

      if(data.errorcode == '5101') {
       window.location.href= "logout";
       return;
      }
      else if(data.errorcode == '5201') {
       formFocus = "#inputAid";
      }
      else if(data.errorcode == '5202') {
       formFocus = "#inputQid";
      }
      else if(data.errorcode == '5203') {
       formFocus = "#inputQid";
      }
      else if(data.errorcode == '5204') {
       formFocus = "#inputQid";
      }
      else {
       formFocus = "#inputAid";
      }
      $("#alert_form").html("");
      $("#modalErrorLabel").html("更新できません");
      $("#modalErrorMsg").html("エラーコード：" + data.errorcode +"<br>"+ data.message);
      $('#messageModalError').modal({
       backdrop: 'static',
       keyboard: true, 
       show: true
      }); 
       return;
     }

     $("#alert_form").html("");

     $("#modalSuccessLabel").html("更新しました");
     $( "#messageModalSuccess" ).modal( "show" ) ;
     setTimeout( function() {
      $( "#messageModalSuccess" ).modal( "hide" ) ;
      $( "#form" ).modal( "hide" );
     }, 2000 );

     // テーブル更新
     $('#myTable').DataTable().ajax.url("./api/admin_search.php").load() ;
    },
    error: function() {
　　 $('#alert_form').removeClass().addClass("alert alert-danger");
     $("#alert_form").html("<p>ただいま更新できません</p>");
    }
   });
  } else {
     // バリデーションNGの処理
   $('#alert_form').removeClass().addClass("alert alert-danger");
   $("#alert_form").html("<p>赤く表示された入力内容を訂正して登録してください</p>");
  }

 });

 // 削除ボタンクリック時の処理
 $("#deleteButton").on("click", function(){
  bootbox.confirm({
   message: "本当に削除しますか？",
   buttons: {
    confirm: {
     label: '削除',
     className: 'btn-danger'
    },
    cancel: {
     label: '取消',
     className: 'btn-primary'
    }
   },
   callback: function (result) {
    if (result) {
     var selectedRows = $('#myTable').DataTable().rows(activeRowIndex).data();

     var param = {};
     param['id'] = selectedRows[0].id;

     $.ajax({
      url: "./api/admin_delete.php",
      type: "POST",
      data: param, // JSON.stringify(param),
      success: function(jsonResponse) {
       var data = JSON.parse(jsonResponse);
       if(data.result == 'success') {
        $(this).find('.bootbox-body').html('削除しました');
        $(this).find('.bootbox-accept').hide();

        // テーブル更新
        $('#myTable').DataTable().ajax.url("./api/admin_search.php").load() ;
       }
       else {
        // セッション切れ
        window.location.href= "logout";
        return;
       }
      },
      error: function() {
　     $("#modalErrorLabel").html("削除できません");
       $("#modalErrorMsg").html("通信エラー");
       $('#messageModalError').modal({
        backdrop: 'static',
        keyboard: true, 
         show: true
       }); 
       setTimeout( function() {
        $( "#messageModalError" ).modal( "hide" ) ;
       }, 2000 );
      }
     });
    } else {
    }
   }
  });
 });

 // 削除ボタンクリック時の処理
 $("#dispButton").on("click", function(){
  var selectedRows = $('#myTable').DataTable().rows(activeRowIndex).data();
  window.open(document.getElementById("hidden3").value+'?pname='+document.getElementById("hidden4").value+'&gid='+selectedRows[0].gekijo_id+'&aid='+selectedRows[0].a_id+'&rid=TEST');
 });

 // ダウンロードボタンクリック時の処理
 $("#resultButton").on("click", function(){
　var selectedRows = $('#myTable').DataTable().rows(activeRowIndex).data();
  window.open('./q_result?gid='+selectedRows[0].gekijo_id+'&aid='+selectedRows[0].a_id);
 });

 // 項目ボタンクリック時の処理
 $("#listButton").on("click", function(){
  window.open('./q_list');
 });

 // 結果ボタンクリック時の処理
 $("#reportButton").on("click", function(){
  var selectedRows = $('#myTable').DataTable().rows(activeRowIndex).data();
  window.open('./q_report?gid='+selectedRows[0].gekijo_id+'&aid='+selectedRows[0].a_id);
 });

 // モーダルウインドウ表示処理
 $(document).on('hidden.bs.modal', function () {
  if ($('.modal').is(':visible')) $('body').addClass('modal-open');
 });

 // モーダルウインドウ消去処理
 $("#modalErrorClose").on("click", function(){
  $( "#messageModalError" ).modal( "hide" ) ;

  setTimeout(function(){
   $(formFocus).focus();
   if (errorCode != "") {
    $("#form " + formFocus).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
    $("#form " + formFocus).next( "span" ).addClass( "glyphicon-remove" ).removeClass( "glyphicon-ok" );
   }
  }, 100);
 });

 // 入力チェック消去処理
 jQuery.validator.addMethod("isUser", function(value, element) {
  return this.optional( element ) || /(?=.*?[a-z])(?=.*?[A-Z])(?=.*?\d)[a-zA-Z\d]{4}/.test( value );
 }, '半角英大小文字、数字すべて含む半角４文字入力してください。');

 jQuery.validator.addMethod("isPass", function(value, element) {
  return this.optional( element ) || /(?=.*?[a-z])(?=.*?[A-Z])(?=.*?\d)[a-zA-Z\d]{8,}/.test( value );
 }, '英大文字、英小文字、数字すべて含む半角８文字以上入力してください。');

 jQuery.validator.addMethod("isId", function(value, element) {
  return this.optional( element ) || /^([a-zA-Z0-9]{4,})$/.test( value );
 }, '半角英数字４文字を入力してください。');

 $( "#sample-form" ).validate( {
  rules: {
   inputGid: {
    required: true,
    isUser: true,
    maxlength: 4
   },
   inputAid: {
    required: true,
    isId: true,
    maxlength: 4
   },
   inputAname: {
    required: true,
    maxlength: 150
   },
   inputAexplanation: {
    maxlength: 150
   },
   inputAexistence: {
    required: true
   },
   inputAstart: {
    required: true
   },
   inputAend: {
    required: true
   }
  },
  messages: {
   inputGid: {
    required: "劇場ID（必須）を入力してください。",
    maxlength: "４文字で入力してください。"
   },
   inputAid: {
    required: "アンケートID（必須）を入力してください。",
    maxlength: "４文字で入力してください。"
   },
   inputAname: {
    required: "アンケート名称（必須）を入力してください。",
    maxlength: "１５０文字以内で入力してください。"
   },
   inputAexplanation: {
    maxlength: "１５０文字以内で入力してください。"
   },
   inputAexistence: {
    required: "アンケート状態（必須）を選択してください。"
   },
   inputAstart: {
    required: "アンケート開始日時（必須）を入力してください。"
   },
   inputAend: {
    required: "アンケート終了日時（必須）を入力してください。"
   }
  },
  errorElement: "em",
  errorPlacement: function ( error, element ) {
   // Add the `help-block` class to the error element
   error.addClass( "help-block" );

   // Add `has-feedback` class to the parent div.form-group
   // in order to add icons to inputs
   element.parents( ".col-sm-8" ).addClass( "has-feedback" );

   if ( element.prop( "type" ) === "checkbox" ) {
    error.insertAfter( element.parent( "label" ) );
   } else {
    error.insertAfter( element );
   }

   // Add the span element, if doesn't exists, and apply the icon classes to it.
   if ( !element.next( "span" )[ 0 ] ) {
    $( "<span class='glyphicon glyphicon-remove form-control-feedback'></span>" ).insertAfter( element );
   }

  },
  success: function ( label, element ) {
   // Add the span element, if doesn't exists, and apply the icon classes to it.
   if ( !$( element ).next( "span" )[ 0 ] ) {
    $( "<span class='glyphicon glyphicon-ok form-control-feedback'></span>" ).insertAfter( $( element ) );
   }
  },
  highlight: function ( element, errorClass, validClass ) {
   $( element ).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
   $( element ).next( "span" ).addClass( "glyphicon-remove" ).removeClass( "glyphicon-ok" );
  },
  unhighlight: function (element, errorClass, validClass) {
   $( element ).parents( ".col-sm-8" ).addClass( "has-success" ).removeClass( "has-error" );
   $( element ).next( "span" ).addClass( "glyphicon-ok" ).removeClass( "glyphicon-remove" );
  }
 });

 // ビジーwaitを使う方法
 function sleep(waitMsec) {
  var startMsec = new Date();
 
  // 指定ミリ秒間だけループさせる（CPUは常にビジー状態）
  while (new Date() - startMsec < waitMsec);
 }

 $('[data-toggle="tooltip"]').tooltip();

});

var minCount = 1;
var maxCount = 50;

// インプットエリアを追加
function inputPlus(q_id) {
 var inputCount = $('#demo-area .unit').length;
 if (inputCount < maxCount){
  var element = $('#demo-area .unit:last-child').clone(true);
  var inputList = element[0].querySelectorAll('input[type="text"]');
  for (var i = 0; i < inputList.length; i++) {
   if(!q_id) {
    inputList[i].value = "";
   }
   else {
    inputList[i].value = q_id.qid;
   }
  }
  inputList = element[0].querySelectorAll('input[type="checkbox"]');
  for (var i = 0; i < inputList.length; i++) {
   if(!q_id) {
    $(inputList[i]).prop('checked', false);
   }
   else {
    $(inputList[i]).prop('checked', q_id.req);
   }
  }

  $('#demo-area .unit').parent().append(element);
 }
}

$('#demo-plus').on('click', function(){
 inputPlus("");
});

$('.demo-minus').on('click', function(){
 var inputCount = $('#demo-area .unit').length;
 if (inputCount > minCount){
  $(this).parents('.unit').remove();
 }
});

// インプットエリアをクリア
function inputClear() {
 if(document.getElementById("hidden1").value != "2") {
  $("#inputGid").val("");
 }
 $("#inputAid").val("");
 $("#inputAname").val("");
 $("#inputAexplanation").val("");
 $("#inputQexistence").val("00");
 $("#inputAstart").val("");
 $("#inputAend").val("");
 $('.inputQid').each(function(){
  $(this).val("");
 });
 $('.inputReq').each(function(){
  $(this).val(true);
 });

 var inputCount = $('#demo-area .unit').length;
 for (let i = inputCount; i > minCount; i--) {
  $('#demo-area .unit')[i-1].remove();
 }
}

jQuery.datetimepicker.setLocale('ja');

jQuery('#inputAstart').datetimepicker({
 i18n:{
  ja:{
   months:[
    "1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月",
   ],
   dayOfWeek:[
    "日","月","火","水","木","金","土",
   ]
  }
 },

 format:'Y-m-d H:i:s',
 lang:'ja'
});

jQuery('#inputAend').datetimepicker({
 i18n:{
  ja:{
   months:[
    "1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月",
   ],
   dayOfWeek:[
    "日","月","火","水","木","金","土",
   ]
  }
 },

 format:'Y-m-d H:i:s',
 lang:'ja'
});
