/*!
 * group.js v1.0.0
 */

var activeRowIndex = "";
var formFocus = "#inputQid";
var errorCode = "";
var updateSkip = true;
var registSkip = true;

var updateRecordId = 0;
$(document).ready( function () {
 $('#myTable').DataTable({
  'paging'      : true,
  'pageLength'  : 10,
  'lengthChange': false,
  'searching'   : true,
  'ordering'    : true,
  'info'        : true,
  'autoWidth'   : true,
  "scrollCollapse": true,
  'scrollX'     : true,
  'scrollY'     : '275px',
  'tabIndex'    : -1,
  'order'       : [[ 0, 'asc' ]],
  'colReorder'  : true,
  'serverSide'  : false,
  'ajax'        : {
   'url': './api/setting_init.php',
   'type' : 'POST',
   'data' : function ( d ) {
    d.searchName = $("#searchName").val();
   }
  },
  'columns'     : [
   { 'data' : 'q_id', width: 40 },
   { 'data' : 'q_name', width: 120  },
   { 'data' : 'q_sentence', width: 600  },
   { 'data' : 'group_id', width: 60  },
   { 'data' : 'id', width: 0 },
  ],
  'columnDefs': [ 
   { 'targets': [4], 'visible': false },
  ],
  'language'   : {
   'decimal':        ".",
   'emptyTable':     "表示するデータがありません。",
   'info':           "_START_ ～ _END_ / _TOTAL_ 件中",
   'infoEmpty':      "0 ～ 0 / 0 件",
   'infoFiltered':   "(合計 _MAX_ 件からフィルタリングしています)",
   'infoPostFix':    "",
   'thousands':      ",",
   'lengthMenu':     "1ページ _MENU_ 件を表示する",
   'loadingRecords': "読み込み中...",
   'processing':     "処理中...",
   'search':         "絞り込み:",
   'zeroRecords':    "一致するデータが見つかりません。",
   'paginate': {
    'first':      "最初",
    'last':       "最後",
    'next':       "次",
    'previous':   "前"
   }
  }
 });

 // ページ変更の設定
 $("#myTable").on('draw.dt', function () {
  $("#myTable tr").removeClass("active");

  activeRowIndex = "";
  $("#updateButton").prop("disabled", true);
  $("#deleteButton").prop("disabled", true);
 });

 // テーブル行クリックの設定
 $('#myTable tbody').on("click", "tr", function() {
  if ($(this).find('.dataTables_empty').length == 0) {
   owner = $(this);

   $("#myTable tr").removeClass("active");
   owner.addClass("active");

   $("#updateButton").prop("disabled", false);
   $("#deleteButton").prop("disabled", false);
   activeRowIndex = owner[0]._DT_RowIndex;
  }
 });

 // 検索ボタンクリック時の処理
 $("#searchButton").on("click", function() {
  $('#myTable').DataTable().ajax.url("./api/setting_search.php").load();
  $('#myTable').DataTable().ajax.reload();
 });

 // 登録ボタンクリック時の処理
 $("#registButton").on("click", function() {
  registSkip = false;
  updateSkip = true;
  errorCode = "";
  // ダイアログ表示
  $('#alert_form').removeClass();
  $("#alert_form").html("");

  $('#form').on('show.bs.modal', function (event) {
   if(registSkip) {
    return;
   }

   inputClear();
   // コントロール制御
   $("#form #dialogTitle").text("新規登録");
   $("#form #sendRegistButton").show();
   $("#form #sendUpdateButton").hide();
   $("#form #inputQid").prop("disabled", false);
 
   // フォーカス
   setTimeout(function() {
    $(formFocus).focus() ;
    if (errorCode != "") {
     $("#form " + formFocus).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
     $("#form " + formFocus).next( "span" ).addClass( "glyphicon-remove" ).removeClass( "glyphicon-ok" );
    }
   }, 500);
  }).modal({backdrop: 'static', keyboard: true, show: true});
 });

 // 登録送信ボタンクリック時の処理
 $("#sendRegistButton").on("click", function(){
  registSkip = true;
  updateSkip = true;
  var param = {};
  param['q_id'] = $("#inputQid").val();
  param['group_id'] = $("#inputGid").val();
  param['q_name'] = $("#inputQname").val();
  param['q_sentence'] = $("#inputQsentence").val();
  param['q_explanation'] = $("#inputQexplanation").val();
  param['q_kind'] = $("#inputQkind").val();

  var q_selectArray = new Array();
  $('.inputQselect').each(function(){
   q_selectArray.push($(this).val());
  });
  param['q_select'] = q_selectArray;
  param['q_check'] = $("#inputQcheck").val();
  param['q_minlength'] = $("#inputQminlength").val();
  param['q_maxlength'] = $("#inputQmaxlength").val();
  param['q_checkorg'] = $("#inputQcheckorg").val();
  param['q_checkorgmsg'] = $("#inputQcheckorgmsg").val();
  param['q_unit'] = $("#inputQunit").val();

  if ($('#sample-form').valid()) {
   // バリデーションOKの処理
   $.ajax({
    url: "./api/setting_regist.php",
    type: "POST",
    data: param, // JSON.stringify(param),
    success: function(jsonResponse) {
     var data = JSON.parse(jsonResponse);
     formFocus = "#inputQid";
     errorCode = "";
     if(data.result == 'error') {
      errorCode = data.errorcode;

      if(data.errorcode == '4101') {
       window.location.href= "logout";
       return;
      }
      else if(data.errorcode == '4201') {
       formFocus = "#inputQid";
      }
      else {
       formFocus = "#inputQid";
      }
  　  $("#alert_form").html("");
  　  $("#modalErrorLabel").html("登録できません");
  　  $("#modalErrorMsg").html("エラーコード：" + data.errorcode +"<br>"+ data.message);
      $('#messageModalError').modal({
       backdrop: 'static',
       keyboard: true, 
       show: true
      }); 
      return;
     }

     $("#alert_form").html("");

     $("#modalSuccessLabel").html("登録しました");
     $( "#messageModalSuccess" ).modal( "show" ) ;
     setTimeout( function() {
      $( "#messageModalSuccess" ).modal( "hide" ) ;
      $( "#form" ).modal( "hide" );
     }, 2000 );

     // テーブル更新
     $('#myTable').DataTable().ajax.url("./api/setting_search.php").load() ;
    },
    error: function() {
　   $('#alert_form').removeClass().addClass("alert alert-danger");
     $("#alert_form").html("<p>ただいま登録できません</p>");
    }
   });
  } else {
   // バリデーションNGの処理
   $('#alert_form').removeClass().addClass("alert alert-danger");
   $("#alert_form").html("<p>赤く表示された入力内容を訂正して登録してください</p>");
  }
 });

 // 更新ボタンクリック時の処理
 $("#updateButton").on("click", function() {
  registSkip = true;
  updateSkip = true;
  errorCode = "";
  $('#alert_form').removeClass();
  $("#alert_form").html("");

  var selectedRows = $('#myTable').DataTable().rows(activeRowIndex).data();
  var param = {};
  param['id'] = selectedRows[0].id;

  $.ajax({
   url: "./api/settingRecord.php",
   type: "POST",
   data: param, // JSON.stringify(param),
   success: function(jsonResponse) {
    var data = JSON.parse(jsonResponse);
    var cat = data[0];
     // セッション切れ
    if(data.length == 0) {
      window.location.href= "logout";
      return;
    }
    updateSkip = false;

    // ダイアログ表示
    $('#form').on('show.bs.modal', function (event) {
     if(updateSkip) {
      return;
     }
     inputClear();

     // 取得したデータのセット
     $("#inputQid").val(cat.q_id);
     $("#inputGid").val(cat.group_id);
     $("#inputQname").val(cat.q_name);
     $("#inputQsentence").val(cat.q_sentence);
     $("#inputQexplanation").val(cat.q_explanation);
     $("#inputQkind").val(( '00' + cat.q_kind ).slice( -2 ));

     if($('#demo-area .unit').length == 1){

      var q_selectArray = new Array();
      q_selectArray = cat.q_select;

      for (let i = 0; i < q_selectArray.length; i++) {
       if(i == 0) {
        $('.inputQselect').each(function(){
         $(this).val(q_selectArray[i]);
        });
       }
       else {
        inputPlus(q_selectArray[i]);
       }
      }
     }

     $("#inputQcheck").val(( '00' + cat.q_check ).slice( -2 ));
     $("#inputQminlength").val(cat.q_minlength);
     $("#inputQmaxlength").val(cat.q_maxlength);
     $("#inputQcheckorg").val(cat.q_checkorg);
     $("#inputQcheckorgmsg").val(cat.q_checkorgmsg);
     $("#inputQunit").val(cat.q_unit);
 
     // コントロール制御
     $("#form #dialogTitle").text("更新");
     $("#form #sendRegistButton").hide();
     $("#form #sendUpdateButton").show();

     // フォーカス
     setTimeout(function() {
      $(formFocus).focus() ;
      if (errorCode != "") {
       $("#form " + formFocus).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
       $("#form " + formFocus).next( "span" ).addClass( "glyphicon-remove" ).removeClass( "glyphicon-ok" );
      }
     }, 500);
    }).modal({backdrop: 'static', keyboard: true, show: true});
   },
   error: function() {
    $('#alert_form').removeClass().addClass("alert alert-danger");
    $("#alert_form").html("<p>ただいま登録できません</p>");
   }
  });
 });

 // 更新送信ボタンクリック時の処理
 $("#sendUpdateButton").on("click", function(){
  registSkip = true;
  updateSkip = true;
  var selectedRows = $('#myTable').DataTable().rows(activeRowIndex).data();

  var param = {};
  param['id'] = selectedRows[0].id;
  param['q_id'] = $("#inputQid").val();
  param['group_id'] = $("#inputGid").val();
  param['q_name'] = $("#inputQname").val();
  param['q_sentence'] = $("#inputQsentence").val();
  param['q_explanation'] = $("#inputQexplanation").val();
  param['q_kind'] = $("#inputQkind").val();

  var q_selectArray = new Array();
  $('.inputQselect').each(function(){
   q_selectArray.push($(this).val());
  });
  param['q_select'] = q_selectArray;
  param['q_check'] = $("#inputQcheck").val();
  param['q_minlength'] = $("#inputQminlength").val();
  param['q_maxlength'] = $("#inputQmaxlength").val();
  param['q_checkorg'] = $("#inputQcheckorg").val();
  param['q_checkorgmsg'] = $("#inputQcheckorgmsg").val();
  param['q_unit'] = $("#inputQunit").val();

  if ($('#sample-form').valid()) {
   // バリデーションOKの処理
   $.ajax({
    url: "./api/setting_update.php",
    type: "POST",
    data: param, // JSON.stringify(param),
    success: function(jsonResponse) {
     var data = JSON.parse(jsonResponse);
     formFocus = "#inputQid";
     errorCode = "";
     if(data.result == 'error') {
      errorCode = data.errorcode;

      if(data.errorcode == '4101') {
       window.location.href= "logout";
       return;
      }
      else if(data.errorcode == '4201') {
       formFocus = "#inputQid";
      }
      else {
       formFocus = "#inputQid";
      }
  　   $("#alert_form").html("");
  　   $("#modalErrorLabel").html("更新できません");
  　   $("#modalErrorMsg").html("エラーコード：" + data.errorcode +"<br>"+ data.message);
       $('#messageModalError').modal({
        backdrop: 'static',
        keyboard: true, 
        show: true
       }); 
       return;
     }

  　 $("#alert_form").html("");

  　 $("#modalSuccessLabel").html("更新しました");
     $( "#messageModalSuccess" ).modal( "show" ) ;
     setTimeout( function() {
      $( "#messageModalSuccess" ).modal( "hide" ) ;
      $( "#form" ).modal( "hide" );
     }, 2000 );

     // テーブル更新
     $('#myTable').DataTable().ajax.url("./api/setting_search.php").load() ;
    },
    error: function() {
　   $('#alert_form').removeClass().addClass("alert alert-danger");
     $("#alert_form").html("<p>ただいま更新できません</p>");
    }
   });
  } else {
   // バリデーションNGの処理
   $('#alert_form').removeClass().addClass("alert alert-danger");
   $("#alert_form").html("<p>赤く表示された入力内容を訂正して登録してください</p>");
  }
 });

 // 削除ボタンクリック時の処理
 $("#deleteButton").on("click", function(){
  bootbox.confirm({
   message: "本当に削除しますか？",
   buttons: {
    confirm: {
     label: '削除',
     className: 'btn-danger'
    },
    cancel: {
     label: '取消',
     className: 'btn-primary'
    }
   },
   callback: function (result) {
    if (result) {
     var selectedRows = $('#myTable').DataTable().rows(activeRowIndex).data();

     var param = {};
     param['id'] = selectedRows[0].id;
 
     $.ajax({
      url: "./api/setting_delete.php",
      type: "POST",
      data: param, // JSON.stringify(param),
      success: function(jsonResponse) {
       var data = JSON.parse(jsonResponse);
       if(data.result == 'success') {
        $(this).find('.bootbox-body').html('削除しました');
        $(this).find('.bootbox-accept').hide();

          // テーブル更新
        $('#myTable').DataTable().ajax.url("./api/setting_search.php").load() ;
       }
       else {
         // セッション切れ
         window.location.href= "logout";
         return;
       }
      },
      error: function() {
 　    $("#modalErrorLabel").html("削除できません");
       $("#modalErrorMsg").html("通信エラー");
       $('#messageModalError').modal({
        backdrop: 'static',
        keyboard: true, 
        show: true
       }); 
       setTimeout( function() {
        $( "#messageModalError" ).modal( "hide" ) ;
       }, 2000 );
      }
     });
    } else {
    }
   }
  });
 });

 // モーダルウインドウ表示処理
 $(document).on('hidden.bs.modal', function () {
  if ($('.modal').is(':visible')) $('body').addClass('modal-open');
 });

 // モーダルウインドウ消去処理
 $("#modalErrorClose").on("click", function(){
  $( "#messageModalError" ).modal( "hide" ) ;

  setTimeout(function(){
   $(formFocus).focus();
   if (errorCode != "") {
    $("#form " + formFocus).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
    $("#form " + formFocus).next( "span" ).addClass( "glyphicon-remove" ).removeClass( "glyphicon-ok" );
   }
  }, 100);
 });

 // 入力チェック処理
 jQuery.validator.addMethod("isUser", function(value, element) {
  return this.optional( element ) || /(?=.*?[a-z])(?=.*?[A-Z])(?=.*?\d)[a-zA-Z\d]{8}/.test( value );
 }, '英大文字、英小文字、数字すべて含む半角８文字入力してください。');

 jQuery.validator.addMethod("isPass", function(value, element) {
  return this.optional( element ) || /(?=.*?[a-z])(?=.*?[A-Z])(?=.*?\d)[a-zA-Z\d]{8,}/.test( value );
 }, '英大文字、英小文字、数字すべて含む半角８文字以上入力してください。');

 jQuery.validator.addMethod("isId", function(value, element) {
  return this.optional( element ) || /^([a-zA-Z0-9]{4,})$/.test( value );
 }, '半角英数字４文字を入力してください。');

 $( "#sample-form" ).validate( {
  rules: {
   inputQid: {
    required: true,
    isId: true,
    maxlength: 4
   },
   inputGid: {
    required: true,
    isId: true,
    maxlength: 4
   },
   inputQname: {
    required: true,
    maxlength: 150
   },
   inputQsentence: {
    required: true,
    maxlength: 150
   },
   inputQexplanation: {
    maxlength: 150
   },
   inputQkind: {
    required: true
   },
   inputQselect: {
    maxlength: 150
   },
   inputQcheck: {
    required: true
   },
   inputQminlength: {
    digits: true,
    maxlength: 150
   },
   inputQmaxlength: {
    digits: true,
    maxlength: 150
   },
   inputQcheckorg: {
    maxlength: 150
   },
   inputQcheckorgmsg: {
    maxlength: 150
   },
   inputQunit: {
    maxlength: 150
   }
  },
  messages: {
   inputQid: {
    required: "設問ID（必須）を入力してください。",
    maxlength: "４文字で入力してください。"
   },
   inputGid: {
    required: "設問ID（必須）を入力してください。",
    maxlength: "４文字で入力してください。"
   },
   inputQname: {
    required: "設問名称（必須）を入力してください。",
    maxlength: "１５０文字以内で入力してください。"
   },
   inputQsentence: {
    required: "設問文（必須）を入力してください。",
    maxlength: "１５０文字以内で入力してください。"
   },
   inputQexplanation: {
    maxlength: "１５０文字以内で入力してください。"
   },
   inputQkind: {
    required: "回答形式（必須）を選択してください。"
   },
   inputQselect: {
    maxlength: "１５０文字以内で入力してください。"
   },
   inputQcheck: {
    required: "入力チェック方法を選択してください。"
   },
   inputQminlength: {
    digits: "半角数字で入力してください。",
    maxlength: "１５０文字以内で入力してください。"
   },
   inputQmaxlength: {
    digits:  "半角数字で入力してください。",
    maxlength: "１５０文字以内で入力してください。"
   },
   inputQcheckorg: {
    maxlength: "１５０文字以内で入力してください。"
   },
   inputQcheckorgmsg: {
    maxlength: "１５０文字以内で入力してください。"
   },
   inputQunit: {
    maxlength: "１５０文字以内で入力してください。"
   }
  },
  errorElement: "em",
  errorPlacement: function ( error, element ) {
   // Add the `help-block` class to the error element
   error.addClass( "help-block" );

   // Add `has-feedback` class to the parent div.form-group
   // in order to add icons to inputs
   element.parents( ".col-sm-8" ).addClass( "has-feedback" );

   if ( element.prop( "type" ) === "checkbox" ) {
    error.insertAfter( element.parent( "label" ) );
   } else {
    error.insertAfter( element );
   }

   // Add the span element, if doesn't exists, and apply the icon classes to it.
   if ( !element.next( "span" )[ 0 ] ) {
    $( "<span class='glyphicon glyphicon-remove form-control-feedback'></span>" ).insertAfter( element );
   }

  },
  success: function ( label, element ) {
   // Add the span element, if doesn't exists, and apply the icon classes to it.
   if ( !$( element ).next( "span" )[ 0 ] ) {
    $( "<span class='glyphicon glyphicon-ok form-control-feedback'></span>" ).insertAfter( $( element ) );
   }
  },
  highlight: function ( element, errorClass, validClass ) {
   $( element ).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
   $( element ).next( "span" ).addClass( "glyphicon-remove" ).removeClass( "glyphicon-ok" );
  },
  unhighlight: function (element, errorClass, validClass) {

   $( element ).parents( ".col-sm-8" ).addClass( "has-success" ).removeClass( "has-error" );
   $( element ).next( "span" ).addClass( "glyphicon-ok" ).removeClass( "glyphicon-remove" );
  }
 });

 // ビジーwaitを使う方法
 function sleep(waitMsec) {
  var startMsec = new Date();
 
  // 指定ミリ秒間だけループさせる（CPUは常にビジー状態）
  while (new Date() - startMsec < waitMsec);
 }

});

var minCount = 1;
var maxCount = 50;

// インプットエリアを追加
function inputPlus(txt) {
 var inputCount = $('#demo-area .unit').length;
 if (inputCount < maxCount){
  var element = $('#demo-area .unit:last-child').clone(true);
  var inputList = element[0].querySelectorAll('input[type="text"]');
  for (var i = 0; i < inputList.length; i++) {
    inputList[i].value = txt; //"";
  }

  $('#demo-area .unit').parent().append(element);
 }
}

$('#demo-plus').on('click', function(){
 inputPlus("");
});

$('.demo-minus').on('click', function(){
 var inputCount = $('#demo-area .unit').length;
 if (inputCount > minCount){
  $(this).parents('.unit').remove();
 }
});

// インプットエリアをクリア
function inputClear() {
 $("#inputQid").val("");
 $("#inputGid").val("");
 $("#inputQname").val("");
 $("#inputQsentence").val("");
 $("#inputQexplanation").val("");
 $("#inputQkind").val("01");
 $('.inputQselect').each(function(){
   $(this).val("");
 });
 $("#inputQcheck").val("00");
 $("#inputQminlength").val("");
 $("#inputQmaxlength").val("");
 $("#inputQcheckorg").val("");
 $("#inputQcheckorgmsg").val("");
 $("#inputQunit").val("");

 var inputCount = $('#demo-area .unit').length;
 for (let i = inputCount; i > minCount; i--) {
   $('#demo-area .unit')[i-1].remove();
 }
}
