/*!
 * theater.js v1.0.0
 */

var activeRowIndex = "";
var formFocus = "#inputId";
var errorCode = "";
var updateSkip = true;
var registSkip = true;

$(document).ready( function () {
 $('#myTable').DataTable({
  'paging'      : true,
  'pageLength'  : 10,
  'lengthChange': false,
  'searching'   : true,
  'ordering'    : true,
  'info'        : true,
  'autoWidth'   : true,
  "scrollCollapse": true,
  'scrollX'     : true,
  'scrollY'     : '275px',
  'tabIndex'    : -1,
  'order'       : [[ 0, 'asc' ]],
  'colReorder'  : true,
  'serverSide'  : false,
  'ajax'        : {
   'url': './api/theater_init.php',
   'type' : 'POST',
   'data' : function ( d ) {
    d.searchName = $("#searchName").val();
   }
  },
  'columns'     : [
   { 'data' : 'gekijo_id', width: 60 },
   { 'data' : 'user_id', width: 60  },
   { 'data' : 'gekijo_sname', width: 200  },
   { 'data' : 'gekijo_name', width: 350  },
   { 'data' : 'existence_name', width: 60  },
  ],
  'language'   : {
   'decimal':        ".",
   'emptyTable':     "表示するデータがありません。",
   'info':           "_START_ ～ _END_ / _TOTAL_ 件中",
   'infoEmpty':      "0 ～ 0 / 0 件",
   'infoFiltered':   "(合計 _MAX_ 件からフィルタリングしています)",
   'infoPostFix':    "",
   'thousands':      ",",
   'lengthMenu':     "1ページ _MENU_ 件を表示する",
   'loadingRecords': "読み込み中...",
   'processing':     "処理中...",
   'search':         "絞り込み:",
   'zeroRecords':    "一致するデータが見つかりません。",
   'paginate': {
    'first':      "最初",
    'last':       "最後",
    'next':       "次",
    'previous':   "前"
   }
  }
 });

 // ページ変更の設定
 $("#myTable").on('draw.dt', function () {
  $("#myTable tr").removeClass("active");

  activeRowIndex = "";
  $("#updateButton").prop("disabled", true);
  $("#deleteButton").prop("disabled", true);
 });

 // テーブル行クリックの設定
 $('#myTable tbody').on("click", "tr", function() {
  if ($(this).find('.dataTables_empty').length == 0) {

   owner = $(this);

   $("#myTable tr").removeClass("active");
   owner.addClass("active");

   $("#updateButton").prop("disabled", false);
   $("#deleteButton").prop("disabled", false);
   activeRowIndex = owner[0]._DT_RowIndex;
  }
 });

 // 検索ボタンクリック時の処理
 $("#searchButton").on("click", function() {
  $('#myTable').DataTable().ajax.url("./api/search.php").load();
  $('#myTable').DataTable().ajax.reload();
 });

 // 登録ボタンクリック時の処理
 $("#registButton").on("click", function() {
  registSkip = false;
  updateSkip = true;
  errorCode = "";

  // ダイアログ表示
  $('#alert_form').removeClass();
  $("#alert_form").html("");

  $('#form').on('show.bs.modal', function (event) {
  if(registSkip) {
   return;
  }

  // コントロール制御
  $("#form #dialogTitle").text("新規登録");
  $("#form #sendRegistButton").show();
  $("#form #sendUpdateButton").hide();
  $("#form #inputId").prop("disabled", false);
  $("#form #inputUser").prop("disabled", false);
  $("#form #inputKind").prop("disabled", false);
 
  // フォーカス
  setTimeout(function() {
   $(formFocus).focus() ;
   if (errorCode != "") {
    $("#form " + formFocus).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
    $("#form " + formFocus).next( "span" ).addClass( "glyphicon-remove" ).removeClass( "glyphicon-ok" );
   }
  }, 500);

  }).modal({backdrop: 'static', keyboard: true, show: true});


 });

 // 登録送信ボタンクリック時の処理
 $("#sendRegistButton").on("click", function(){
  registSkip = true;
  updateSkip = true;

  var param = {};
  param['gekijo_id'] = $("#inputId").val();
  param['user_id'] = $("#inputUser").val();
  param['gekijo_kind'] = $("#inputKind").val();
  param['gekijo_existence'] = $("#inputExistence").val();
  param['gekijo_name'] = $("#inputName").val();
  param['gekijo_sname'] = $("#inputSname").val();
  param['gekijo_postcode'] = $("#inputPostcode").val();
  param['gekijo_prefectures'] = $("#inputPrefectures").val();
  param['gekijo_address1'] = $("#inputAddress1").val();
  param['gekijo_address2'] = $("#inputAddress2").val();
  param['gekijo_address3'] = $("#inputAddress3").val();
  param['gekijo_url'] = $("#inputUrl").val();
  param['gekijo_tel'] = $("#inputTel").val();
  param['gekijo_mail'] = $("#inputMail").val();
  param['gekijo_explanation'] = $("#inputExplanation").val();
  param['gekijo_comment'] = $("#inputComment").val();

  if ($('#sample-form').valid()) {
   // バリデーションOKの処理
   $.ajax({
    url: "./api/theater_regist.php",
    type: "POST",
    data: param, // JSON.stringify(param),
    success: function(jsonResponse) {
     var data = JSON.parse(jsonResponse);
     formFocus = "#inputId";
     errorCode = "";
     if(data.result == 'error') {
      errorCode = data.errorcode;

      if(data.errorcode == '1101') {
       window.location.href= "logout";
       return;
      }
      else if(data.errorcode == '1201' || data.errorcode == '1202') {
       formFocus = "#inputId";
      }
      else if(data.errorcode == '1301') {
       formFocus = "#inputAddress2";
      }
      else {
       formFocus = "#inputId";
      }
  　  $("#alert_form").html("");
  　  $("#modalErrorLabel").html("登録できません");
  　  $("#modalErrorMsg").html("エラーコード：" + data.errorcode +"<br>"+ data.message);
      $('#messageModalError').modal({
       backdrop: 'static',
       keyboard: true, 
       show: true
      }); 
      return;
     }

  　 $("#alert_form").html("");

     $("#modalSuccessLabel").html("登録しました");
     $( "#messageModalSuccess" ).modal( "show" ) ;
     setTimeout( function() {
      $( "#messageModalSuccess" ).modal( "hide" ) ;
      $( "#form" ).modal( "hide" );
     }, 2000 );

     // テーブル更新
     $('#myTable').DataTable().ajax.url("./api/theater_search.php").load() ;
    },
    error: function() {
　   $('#alert_form').removeClass().addClass("alert alert-danger");
     $("#alert_form").html("<p>ただいま登録できません</p>");
    }
   });
  } else {
   // バリデーションNGの処理
   $('#alert_form').removeClass().addClass("alert alert-danger");
   $("#alert_form").html("<p>赤く表示された入力内容を訂正して登録してください</p>");
  }

 });

 // 更新ボタンクリック時の処理
 $("#updateButton").on("click", function() {
  registSkip = true;
  updateSkip = true;
  errorCode = "";

  $('#alert_form').removeClass();
  $("#alert_form").html("");

  var selectedRows = $('#myTable').DataTable().rows(activeRowIndex).data();

  var param = {};
  param['gekijo_id'] = selectedRows[0].gekijo_id;

  $.ajax({
   url: "./api/theaterRecord.php",
   type: "POST",
   data: param, // JSON.stringify(param),
   success: function(jsonResponse) {
    var data = JSON.parse(jsonResponse);
    var cat = data[0];
    // セッション切れ
    if(data.length == 0) {
     window.location.href= "logout";
     return;
    }
    updateSkip = false;
    // ダイアログ表示
    $('#form').on('show.bs.modal', function (event) {
     if(updateSkip) {
       return;
     }

     // 取得したデータのセット
     $("#inputId").val(cat.gekijo_id);
     $("#inputUser").val(cat.user_id);
     $("#inputKind").val(( '00' + cat.gekijo_kind ).slice( -2 ));
     $("#inputExistence").val(( '00' + cat.gekijo_existence ).slice( -2 ));
     $("#inputName").val(cat.gekijo_name);
     $("#inputSname").val(cat.gekijo_sname);
     $("#inputPostcode").val(cat.gekijo_postcode);
     $("#inputPrefectures").val(cat.gekijo_prefectures);
     $("#inputAddress1").val(cat.gekijo_address1);
     $("#inputAddress2").val(cat.gekijo_address2);
     $("#inputAddress3").val(cat.gekijo_address3);
     $("#inputUrl").val(cat.gekijo_url);
     $("#inputTel").val(cat.gekijo_tel);
     $("#inputMail").val(cat.gekijo_mail);
     $("#inputExplanation").val(cat.gekijo_explanation);
     $("#inputComment").val(cat.gekijo_comment);

     // コントロール制御
     $("#form #dialogTitle").text("更新");
     $("#form #sendRegistButton").hide();
     $("#form #sendUpdateButton").show();
     $("#form #inputId").prop("disabled", true);
     $("#form #inputUser").prop("disabled", true);
     $("#form #inputKind").prop("disabled", true);

     // フォーカス
     setTimeout(function() {
      $(formFocus).focus() ;
      if (errorCode != "") {
       $("#form " + formFocus).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
       $("#form " + formFocus).next( "span" ).addClass( "glyphicon-remove" ).removeClass( "glyphicon-ok" );
      }
     }, 500);

    }).modal({backdrop: 'static', keyboard: true, show: true});
   },
   error: function() {
　  $('#alert_form').removeClass().addClass("alert alert-danger");
    $("#alert_form").html("<p>ただいま登録できません</p>");
   }
  });
 });

 // 更新送信ボタンクリック時の処理
 $("#sendUpdateButton").on("click", function(){
  registSkip = true;
  updateSkip = true;

  var param = {};

  param['gekijo_id'] = $("#inputId").val();
  param['user_id'] = $("#inputUser").val();
  param['gekijo_kind'] = $("#inputKind").val();
  param['gekijo_existence'] = $("#inputExistence").val();
  param['gekijo_name'] = $("#inputName").val();
  param['gekijo_sname'] = $("#inputSname").val();
  param['gekijo_postcode'] = $("#inputPostcode").val();
  param['gekijo_prefectures'] = $("#inputPrefectures").val();
  param['gekijo_address1'] = $("#inputAddress1").val();
  param['gekijo_address2'] = $("#inputAddress2").val();
  param['gekijo_address3'] = $("#inputAddress3").val();

  param['gekijo_url'] = $("#inputUrl").val();
  param['gekijo_tel'] = $("#inputTel").val();
  param['gekijo_mail'] = $("#inputMail").val();
  param['gekijo_explanation'] = $("#inputExplanation").val();
  param['gekijo_comment'] = $("#inputComment").val();

  if ($('#sample-form').valid()) {
   // バリデーションOKの処理
   $.ajax({
    url: "./api/theater_update.php",
    type: "POST",
    data: param, // JSON.stringify(param),
    success: function(jsonResponse) {
     var data = JSON.parse(jsonResponse);
     formFocus = "#inputId";
     errorCode = "";
     if(data.result == 'error') {
      errorCode = data.errorcode;

      if(data.errorcode == '1101') {
       window.location.href= "logout";
       return;
      }
      else if(data.errorcode == '1201' || data.errorcode == '1202' || data.errorcode == '1203') {
       formFocus = "#inputId";
      }
      else if(data.errorcode == '1301') {
       formFocus = "#inputAddress2";
      }
      else {
       formFocus = "#inputId";
      }
  　  $("#alert_form").html("");
  　  $("#modalErrorLabel").html("更新できません");
  　  $("#modalErrorMsg").html("エラーコード：" + data.errorcode +"<br>"+ data.message);
      $('#messageModalError').modal({
       backdrop: 'static',
       keyboard: true, 
       show: true
      }); 
      return;
     }

  　 $("#alert_form").html("");

  　 $("#modalSuccessLabel").html("更新しました");
     $( "#messageModalSuccess" ).modal( "show" ) ;
     setTimeout( function() {
      $( "#messageModalSuccess" ).modal( "hide" ) ;
      $( "#form" ).modal( "hide" );
     }, 2000 );

     // テーブル更新
     $('#myTable').DataTable().ajax.url("./api/theater_search.php").load() ;
    },
    error: function() {
　   $('#alert_form').removeClass().addClass("alert alert-danger");
     $("#alert_form").html("<p>ただいま更新できません</p>");
    }
   });
  } else {
   // バリデーションNGの処理
   $('#alert_form').removeClass().addClass("alert alert-danger");
   $("#alert_form").html("<p>赤く表示された入力内容を訂正して登録してください</p>");
  }
 });

 // 削除ボタンクリック時の処理
 $("#deleteButton").on("click", function(){

  if($('#myTable').DataTable().rows(activeRowIndex).data()[0].gekijo_kind == 0) {
   bootbox.alert({
    message: "このアカウントは削除できません。",
    size: 'small'
   });
   return;
  }

  bootbox.confirm({
   message: "本当に削除しますか？",
   buttons: {
    confirm: {
     label: '削除',
     className: 'btn-danger'
    },
    cancel: {
     label: '取消',
     className: 'btn-primary'
    }
   },
   callback: function (result) {
    if (result) {
     var selectedRows = $('#myTable').DataTable().rows(activeRowIndex).data();

     var param = {};
     param['gekijo_id'] = selectedRows[0].gekijo_id;
 
     $.ajax({
      url: "./api/theater_delete.php",
      type: "POST",
      data: param, // JSON.stringify(param),
      success: function(jsonResponse) {
       var data = JSON.parse(jsonResponse);
       if(data.result == 'success') {
        $(this).find('.bootbox-body').html('削除しました');
        $(this).find('.bootbox-accept').hide();


        // テーブル更新
        $('#myTable').DataTable().ajax.url("./api/theater_search.php").load() ;
       }
       else {
        // セッション切れ
        window.location.href= "logout";
        return;
       }
      },
      error: function() {
 　    $("#modalErrorLabel").html("削除できません");
      $("#modalErrorMsg").html("通信エラー");
       $('#messageModalError').modal({
        backdrop: 'static',
        keyboard: true, 
        show: true
      }); 
       setTimeout( function() {
        $( "#messageModalError" ).modal( "hide" ) ;
       }, 2000 );
      }
     });
    } else {
    }
   }
  });
 });

 // モーダルウインドウ表示処理
 $(document).on('hidden.bs.modal', function () {
  if ($('.modal').is(':visible')) $('body').addClass('modal-open');
 });
 
 // モーダルウインドウ消去処理
 $("#modalErrorClose").on("click", function(){
  $( "#messageModalError" ).modal( "hide" ) ;

  setTimeout(function(){
   $(formFocus).focus();
   if (errorCode != "") {
    $("#form " + formFocus).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
    $("#form " + formFocus).next( "span" ).addClass( "glyphicon-remove" ).removeClass( "glyphicon-ok" );
   }
  }, 100);
 });

 // 入力チェック処理
 jQuery.validator.addMethod("isPass", function(value, element) {
  return this.optional( element ) || /(?=.*?[a-z])(?=.*?[A-Z])(?=.*?\d)[a-zA-Z\d]{4}/.test( value );
 }, '英大文字、英小文字、数字すべて含む半角４文字です。');

 jQuery.validator.addMethod("isTel", function(value, element) {
  return this.optional( element ) || /\d{2,4}-\d{3,4}-\d{3,4}/.test( value );
 }, 'ハイフンを含む数字を入力してください。');

 jQuery.validator.addMethod("isMail", function(value, element) {
  return this.optional( element ) || /^[a-zA-Z]{1}[0-9a-zA-Z]+[\w\.-]+@[\w\.-]+\.\w{2,}$/.test( value );
 }, 'メールアドレスを正しく入力してください。');

 $( "#sample-form" ).validate( {
  rules: {
   inputId: {
    required: true,
    isPass: true,
    maxlength: 4
   },
   inputUser: {
    required: true,
    isPass: true,
    maxlength: 4
   },
   inputKind: {
    required: true
   },
   inputExistence: {
    required: true
   },
   inputName: {
    required: true,
    minlength: 2
   },
   inputSname: {
    required: true,
    minlength: 2
   },
   inputPostcode: {
    required: true,
    digits: true,
    maxlength: 7,
    minlength: 7
   },
   inputPrefectures: {
    required: true
   },
   inputAddress1: {
    required: true,
    minlength: 1
   },
   inputAddress2: {
    required: true,
    minlength: 1
   },
   inputAddress3: {
    maxlength: 150
   },
   inputUrl: {
    url: true
   },
   inputTel: {
    isTel: true
   },
   inputMail: {
    email: true
   },
   inputExplanation: {
    maxlength: 150
   },
   inputComment: {
    maxlength: 150
   }
  },
  messages: {
   inputId: {
    required: "劇場ID（必須）を入力してください。",
    maxlength: "４文字で入力してください。"
   },
   inputUser: {
    required: "ユーザーID（必須）を入力してください。",
    maxlength: "４文字で入力してください。"
   },
   inputKind: {
    required: "ユーザー種別（必須）を選択してください。"
   },
   inputExistence: {
    required: "劇場状態（必須）を選択してください。"
   },
   inputName: {
    required: "劇場の正式名称（必須）を入力してください。",
    minlength: "２文字以上入力してください。"
   },
   inputSname: {
    required: "劇場の略称（必須）を入力してください。",
    minlength: "２文字以上入力してください。"
   },
   inputPostcode: {
    required: "郵便番号（必須）を入力してください。",
    digits: "数字７文字を入力してください。",
    maxlength: "数字７文字を入力してください。",
    minlength: "数字７文字を入力してください。"
   },
   inputPrefectures: {
    required: "都道府県名（必須）を選択してください。"
   },
   inputAddress1: {
    required: "市区町村名（必須）を入力してください。",
    minlength: "１文字以上入力してください。"
   },
   inputAddress2: {
    required: "住所を番地まで（必須）を入力してください。",
    minlength: "１文字以上入力してください。"
   },
   inputAddress3: {
    maxlength: "１５０文字以内で入力してください。"
   },
   inputUrl: {
    url: "http(s)://で始まるＵＲＬを入力してください。"
   },
   inputMail: {
    email: "メールアドレスを正しく入力してください。"
   },
   inputExplanation: {
    maxlength: "１５０文字以内で入力してください。"
   },
   inputComment: {
    maxlength: "１５０文字以内で入力してください。"
   }
  },
  errorElement: "em",
  errorPlacement: function ( error, element ) {
   // Add the `help-block` class to the error element
   error.addClass( "help-block" );

   // Add `has-feedback` class to the parent div.form-group
   // in order to add icons to inputs
   element.parents( ".col-sm-8" ).addClass( "has-feedback" );

   if ( element.prop( "type" ) === "checkbox" ) {
    error.insertAfter( element.parent( "label" ) );
   } else {
    error.insertAfter( element );
   }

   // Add the span element, if doesn't exists, and apply the icon classes to it.
   if ( !element.next( "span" )[ 0 ] ) {
    $( "<span class='glyphicon glyphicon-remove form-control-feedback'></span>" ).insertAfter( element );
   }

  },
  success: function ( label, element ) {
   // Add the span element, if doesn't exists, and apply the icon classes to it.
   if ( !$( element ).next( "span" )[ 0 ] ) {
    $( "<span class='glyphicon glyphicon-ok form-control-feedback'></span>" ).insertAfter( $( element ) );
   }
  },
  highlight: function ( element, errorClass, validClass ) {
   $( element ).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
   $( element ).next( "span" ).addClass( "glyphicon-remove" ).removeClass( "glyphicon-ok" );
  },
  unhighlight: function (element, errorClass, validClass) {
   $( element ).parents( ".col-sm-8" ).addClass( "has-success" ).removeClass( "has-error" );
   $( element ).next( "span" ).addClass( "glyphicon-ok" ).removeClass( "glyphicon-remove" );
  }
 });

 // ビジーwaitを使う方法
 function sleep(waitMsec) {
  var startMsec = new Date();
 
  // 指定ミリ秒間だけループさせる（CPUは常にビジー状態）
  while (new Date() - startMsec < waitMsec);
 }

});
