<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/common.php');

//セッション名を指定
session_name(SESSION_NAME);
//セッション開始
session_start();

//--------------------------------------------------------
// ログインしていない場合は強制的にログインページにリダイレクト
//--------------------------------------------------------
if (!isset($_SESSION['user_id'])) {
 header("Location: login");
 exit();
}

//セッション変数をクリア
$_SESSION = array();

//クッキーに登録されているセッションidの情報を削除
if (ini_get("session.use_cookies")) {
 setcookie(session_name(), '', time() - 42000, '/');
}

//セッションを破棄
session_destroy();

// ページ名
define('PAGE_NAME', 'ログアウト');

?>

<!DOCTYPE html>
<html lang="ja">
<head>
 <meta charset="UTF-8">
 <title><?php echo P_TITLE;?> | <?php echo PAGE_NAME;?></title>
 <meta http-equiv="X-UA-Compatible" content="IE=edge">
 <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
 <link href="css/bootstrap.min.css" rel="stylesheet">
 <link href="css/style.css" rel="stylesheet">
</head>
<body>

 <?php include 'inc/header.php'; ?> <!-- ヘッダー共通部 -->

 <div class="container-fluid">
  <div class="row">
   <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
   <div class="col-sm-12 col-md-10" style="background-color:white;">
    <br>
    <br>
    <legend>ログアウトページ</legend>
    <h3>ログアウトしました。</h3>
    <h4>もう一度ログインする場合はログインボタンをクリックしてください。</h4>
    <a href="login" class="btn btn-primary">ログイン</a>
   </div>
   <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
  </div>
 </div>

 <?php include 'inc/footer.php'; ?> <!-- フッター共通部 -->

 <script type="text/javascript" src="js/jquery-3.5.1.js"></script>
 <script type="text/javascript" src="js/bootstrap.min.js"></script>

</body>
</html>
