<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/common.php');

// セッションチェック
// ログインしていない場合はログインページにリダイレクト
require_once (dirname(__FILE__).'/sessionchk.php');

// ページ名
define('PAGE_NAME', 'アンケート項目一覧');

// 表示メッセージ
$html = "";
$script = "";
$rules = "";

$data_group = array();
$data_setting = array();

//--------------------------------------------------------
// データベースから設問を読み込む
//--------------------------------------------------------
try {
 //データベース関数のファイルの読み込み
 require_once ('../'.L_BASE.'/db/q_setting.php');

 $q_setting = new q_settingDb();
 $ret_group = $q_setting->selectQgroup();
 $ret_setting = $q_setting->selectQsetting();
 $q_setting->closeDetaBase();

}catch(ErrorException $ex){
 if(DEBUG_LEVEL != "0"){
  error_log("[". date('Y-m-d H:i:s') . "]". "q_list01\n","3","debug.log");
  error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
 }
}catch(PDOException $ex){
 if(DEBUG_LEVEL != "0"){
  error_log("[". date('Y-m-d H:i:s') . "]". "q_list02\n","3","debug.log");
  error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
 }
}

//--------------------------------------------------------
// 読み込んだ設問グループ
//--------------------------------------------------------
foreach ($ret_group as $key => $value){
 $data_group[$key] = array(
  "group_id"=> $value['group_id'],
  "group_explanation"=>$value['group_explanation']
 );
}

//--------------------------------------------------------
// 読み込んだ設問
//--------------------------------------------------------
foreach ($ret_setting as $key => $value){
 $data_setting[$key] = array(
  "id"=> $value['id'],
  "q_id"=> $value['q_id'],
  "q_name"=>$value['q_name'],
  "q_sentence"=>$value['q_sentence'],
  "q_explanation"=>$value['q_explanation'],
  "q_kind"=>$value['q_kind'],
  "q_select"=>json_decode($value['q_select']),
  "q_check"=>$value['q_check'],
  "q_minlength"=>$value['q_minlength'],
  "q_maxlength"=>$value['q_maxlength'],
  "q_checkorg"=>$value['q_checkorg'],
  "q_checkorgmsg"=>$value['q_checkorgmsg'],
  "q_unit"=>$value['q_unit'],
  "group_id"=>$value['group_id']
 );
}

//--------------------------------------------------------
// 表示項目を設定
//--------------------------------------------------------
$inputName = "field";
foreach($data_group as $group=>$values) {
$html .= "<h3>".$values['group_explanation']."</h3>" ;
 foreach($data_setting as $key=>$value) {
  if($value['group_id'] == $values['group_id']){
$html .= "<h4><span style='color:red'>".$value['q_id']."</span>: ".$value['q_sentence']."</h4>";
$html .= '<div class="form-group">';
$html .= '  <label class="col-sm-4 control-label" for="'.$inputName.$value['q_id'].'">'.$value['q_explanation'].'</label>';
$html .= '  <div class="col-sm-8  form-inline">';
   switch($value['q_kind']) {
    case  1: //単一選択ドロップダウン
$html .= '   <select id="'.$inputName.$value['q_id'].'" name="'.$inputName.$value['q_id'].'" class="form-control">';
     foreach($value['q_select'] as $no=>$val) {
$html .= '    <option value="'.$no.'">'.$val.'</option>';
     }
$html .= '   </select>';
    break;
    case 21: //単一選択ラジオボタン
     foreach($value['q_select'] as $no=>$val) {
$html .= '    <label class="radio-inline"><input type="radio" name="'.$inputName.$value['q_id'].'[]" value="'.$no.'"><small>'.$val.'</small></label>';
     }
$html .= '    <div id="'.$inputName.$value['q_id'].'_error"></div>';
    break;
    case 23: //単一選択ラジオボタン段階評価
     foreach($value['q_select'] as $no=>$val) {
$html .= '    <label class="radio-inline"><input type="radio" name="'.$inputName.$value['q_id'].'[]" value="'.$no.'"><small>'.$val.'</small></label>';
     }
$html .= '    <div id="'.$inputName.$value['q_id'].'_error" class="col-xs-8"  ></div>';
    break;
    case 31: //複数選択チェックボックス
     foreach($value['q_select'] as $no=>$val) {
$html .= '    <label class="radio-inline"><input type="checkbox" name="'.$inputName.$value['q_id'].'[]" value="'.$no.'"><small>'.$val.'</small></label>';
     }
$html .= '    <div id="'.$inputName.$value['q_id'].'_error"></div>';
    break;
    case 22: //単一選択ラジオボタンとその他記述
     foreach($value['q_select'] as $no=>$val) {
$html .= '	<label class="radio-inline"><input type="radio" name="'.$inputName.$value['q_id'].'[]" value="'.$no.'"><small>'.$val.'</small></label>';
     }
$html .= '    <div id="'.$inputName.$value['q_id'].'_error"></div>';
$html .= '   <input type="text" class="form-control ime-disabled" id="'.$inputName.$value['q_id'].'" name="'.$inputName.$value['q_id'].'" placeholder="'.$value['q_unit'].'" />';
    break;
    case 32: //複数選択チェックボックスとその他記述
     foreach($value['q_select'] as $no=>$val) {
$html .= '	<label class="checkbox-inline"><input type="checkbox" name="'.$inputName.$value['q_id'].'[]" value="'.$no.'"><small>'.$val.'</small></label>';
     }
$html .= '    <div id="'.$inputName.$value['q_id'].'_error"></div>';
$html .= '   <input type="text" class="form-control ime-disabled" id="'.$inputName.$value['q_id'].'" name="'.$inputName.$value['q_id'].'" placeholder="'.$value['q_unit'].'" />';
    break;
    case 91: //自由記述一行
$html .= '   <input type="text" class="form-control ime-disabled" id="'.$inputName.$value['q_id'].'" name="'.$inputName.$value['q_id'].'" placeholder="'.$value['q_unit'].'" />';
    break;
    case 99: //自由記述複数行
$html .= '   <textarea class="form-control ime-disabled" id="'.$inputName.$value['q_id'].'" name="'.$inputName.$value['q_id'].'" rows="3" placeholder="'.$value['q_unit'].'"  /></textarea>';
    break;
    default:
    break;
   }
$html .= ' </div>';
$html .= '</div>';

   if($rules != "") { //最初のルールじゃなければ
$rules .= ',';
$messages .= ',';
   }

   if(($value['q_kind'] >= 20) && ($value['q_kind'] <= 39)) {
$rules .= '"'.$inputName.$value["q_id"].'[]" :{';
$messages .= '"'.$inputName.$value["q_id"].'[]" :{';
   }
   else {
$rules .= $inputName.$value["q_id"].' :{';
$messages .= $inputName.$value["q_id"].' :{';
   }

// 入力チェック
// 0:無し　1:半角数字　2:半角英数字　3:半角英字　4:電話番号　5:メール　6:URL　7:日付　8:独自ルール
   switch($value['q_check']) {
    case  0: //無し
$rules .= ' required: true, ';
$messages .= 'required: "必須を入力してください。"';
    if($value['q_kind'] == 1) {
$rules .= ' isZero: true, ';
$messages .= ',isZero: "必須を選択してください。"';
    }
    break;
    case  1: //半角数字
$rules .= ' required: true, ';
$rules .= ' number: true, ';
$messages .= ' required: "必須を入力してください。"';
$messages .= ',number: "半角数字で入力してください。"';
    break;
    case  2: //半角英数字
$rules .= ' required: true, ';
$rules .= ' isHalf: true, ';
$messages .= ' required: "必須を入力してください。"';
$messages .= ',isHalf: "半角英数字で入力してください。"';
    break;
    case  3: //半角英字
$rules .= ' required: true, ';
$rules .= ' isAalpha: true, ';
$messages .= ' required: "必須を入力してください。"';
$messages .= ',isAalpha: "半角英字で入力してください。"';
    break;
    case  4: //電話番号
$rules .= ' required: true, ';
$rules .= ' isTel: true, ';
$messages .= ' required: "必須を入力してください。"';
$messages .= ',isTel: "電話番号をハイフン付きで入力してください。"';
    break;
    case  5: //メール
$rules .= ' required: true, ';
$rules .= ' email: true,';
$messages .= ' required: "必須を入力してください。" ';
$messages .= ',email: "メールアドレスのフォーマットで入力してください。"';
    break;
    case  6: //URL
$rules .= ' required: true, ';
$rules .= ' url: true, ';
$messages .= ' required: "必須を入力してください。"';
$messages .= ',url: "URLのフォーマットで入力してください。"';
    break;
    case  7: //日付
$rules .= ' required: true, ';
$rules .= ' date: true, ';
$messages .= ' required: "必須を入力してください。"';
$messages .= ',date: "日付を入力してください。"';
    break;
    case  8: //郵便番号

$rules .= ' required: true, ';
$rules .= ' digits: true, ';
$rules .= ' maxlength: 7, ';
$rules .= ' minlength: 7, ';
$messages .= ' required: "必須を入力してください。"';
$messages .= ',digits: "数字７文字を入力してください。"';
$messages .= ',maxlength: "数字７文字を入力してください。"';
$messages .= ',minlength: "数字７文字を入力してください。"';

    break;
    case 99: //独自ルール

$script .= 'jQuery.validator.addMethod("is'.$value['q_id'].'", function(value, element) {';
$script .= '  return this.optional( element ) || /'.$value['q_checkorg'].'/.test( value );';
$script .= '}, "'.$value['q_checkorgmsg'].'");';

$rules .= ' required: true, ';
$rules .= ' is'.$value['q_id'].': true,';
$messages .= ' required: "必須を入力してください。" ';
$messages .= ',is'.$value['q_id'].': "'.$value['q_checkorgmsg'].'"';

    break;
    default:
    break;
   }
   if ( $value["q_minlength"] != 0 ){
$rules .= ' minlength: '.$value["q_minlength"].', ';
$messages .= ',minlength: "'.$value["q_minlength"].'文字以上で入力してください。"';
   }
   if ( $value["q_maxlength"] != 0 ){
$rules .= ' maxlength: '.$value["q_maxlength"].', ';
$messages .= ',maxlength: "'.$value["q_maxlength"].'文字以下で入力してください。"';
   }

$rules .= '}';
$messages .= '}';

  } // end if
 } // end foreach
} // end foreach

?>

<!DOCTYPE html>
<html lang="ja">
<head>
 <meta charset="utf-8">
 <title><?php echo P_TITLE;?> | <?php echo PAGE_NAME;?></title>

 <meta http-equiv="X-UA-Compatible" content="IE=edge">
 <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

 <link rel="stylesheet" type="text/css" href="css/bootstrap.min.css"/>
 <link href="css/style.css" rel="stylesheet">

</head>
<body>

 <?php include 'inc/header.php'; ?> <!-- ヘッダー共通部 -->
 <?php include 'inc/pagename.php'; ?> <!-- ページ名共通部 -->

 <div class="container-fluid">
  <div class="row">
   <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
   <div class="col-sm-12 col-md-10" style="background-color:white;">
    <form class="form-horizontal" id="myform">

<?php echo $html; ?>

    </form>
   </div>
   <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
  </div>
 </div>

 <?php include 'inc/footer.php'; ?> <!-- フッター共通部 -->

</body>
 <script type="text/javascript" src="js/jquery-3.5.1.js"></script>
 <script type="text/javascript" src="js/bootstrap.min.js"></script>
 <script type="text/javascript" src="js/jquery.validate.js"></script>
 <script type="text/javascript" src="js/validate-ja.js"></script>
 <script type="text/javascript">
$(document).ready( function () {

 jQuery.validator.addMethod("isTel", function(value, element) {
  return this.optional( element ) || /\d{2,4}-\d{3,4}-\d{3,4}/.test( value );
 }, "ハイフンを含む数字を入力してください。");

 jQuery.validator.addMethod("isMail", function(value, element) {
  return this.optional( element ) || /^[a-zA-Z]{1}[0-9a-zA-Z]+[\w\.-]+@[\w\.-]+\.\w{2,}$/.test( value );
 }, "メールアドレスを正しく入力してください。");

 jQuery.validator.addMethod("isHalf", function(value, element) {
  return this.optional( element ) || /^[0-9A-Za-z]+$/.test( value );
 }, "半角英数字で入力してください。");

 jQuery.validator.addMethod("isAalpha", function(value, element) {
  return this.optional( element ) || /[A-Za-z]{8}/.test( value );
 }, "半角英字で入力してください。");

 jQuery.validator.addMethod("isZero", function(value, element) {
   // お決まりの定型文
   // 検証対象の要素にこのルールが設定されているか
   if ( this.optional( element ) ) {
    return true;
   }
   if (value == 0) {
    return false;
   }
   return true;
  }, "必須を選択してください。");

<?php echo $script; ?>

 $('#myform').validate({ //initialize the plugin 
  rules: {
<?php echo $rules; ?>
  },
  messages: {
<?php echo $messages; ?>
  },
  errorElement: "em",
  errorPlacement: function ( error, element ) {
   // Add the `help-block` class to the error element
   error.addClass( "help-block" );
   // Add `has-feedback` class to the parent div.form-group
   // in order to add icons to inputs
   element.parents( ".col-sm-8" ).addClass( "has-feedback" );
   if (( element.prop( "type" ) === "checkbox" ) ||
    ( element.prop( "type" ) === "radio" )) {
    var _error = "#"+element[0].name.replace('[]', '')+'_error'
    error.insertAfter( _error );
   } else {
    error.insertAfter( element );
   }
   // Add the span element, if doesn't exists, and apply the icon classes to it.
   if ( !element.next( "span" )[ 0 ] ) {
   }
  },
  success: function ( label, element ) {
   // Add the span element, if doesn't exists, and apply the icon classes to it.
   if ( !$( element ).next( "span" )[ 0 ] ) {
   }
  },
  highlight: function ( element, errorClass, validClass ) {
   $( element ).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
  },
  unhighlight: function (element, errorClass, validClass) {
   $( element ).parents( ".col-sm-8" ).addClass( "has-success" ).removeClass( "has-error" );
  }

 }); 

 $("input:checkbox").attr("checked",false);
}); 

$("#checkButton").on("click", function(){
 $('#myform').valid();
});

 </script>

</html>
