<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/common.php');

// 不正POSTチェック
if(empty($_GET['gid']) || empty($_GET['aid'])) {
  exit();
}

// セッションチェック
// ログインしていない場合はログインページにリダイレクト
require_once (dirname(__FILE__).'/sessionchk.php');

// ページ名
define('PAGE_NAME', 'アンケート結果');

// 表示メッセージ
$html = "";
$script = "";
$rules = "";

$aid = $_GET['aid'];
$gid = $_GET['gid'];

//--------------------------------------------------------
// 劇場IDとアンケートIDでアンケートの存在をチェック
//--------------------------------------------------------
try {
 //データベース関数のファイルの読み込み
 require_once ('../'.L_BASE.'/db/q_admin.php');

 $q_admin = new q_adminDb();
 $ret_admin = $q_admin->selectAadmin2($gid, $aid);
 $q_admin->closeDetaBase();

 if(count($ret_admin) == 0){
  exit();
 }

}catch(ErrorException $ex){
 if(DEBUG_LEVEL != "0"){
  error_log("[". date('Y-m-d H:i:s') . "]". "q_report01\n","3","debug.log");
  error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
 }
}catch(PDOException $ex){
 if(DEBUG_LEVEL != "0"){
  error_log("[". date('Y-m-d H:i:s') . "]". "q_report02\n","3","debug.log");
  error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
 }
}

// 表示メッセージ
$nowDay = new DateTime();
$title1 = $ret_admin[0]["a_name"];
$startDay = new DateTime($ret_admin[0]["a_start"]);
$endDay = new DateTime($ret_admin[0]["a_end"]);

$result_name = 'q_result?gid='.$gid.'+&aid='.$aid;
$html = "";
$script = "";
$script_ajax = "";

$inputName = "in";
$outputName = "out";
$a_qid = json_decode($ret_admin[0]['a_qid'],true);

//--------------------------------------------------------
// アンケートの設問と回答を表示
//--------------------------------------------------------
//データベース関数のファイルの読み込み
require_once ('../'.L_BASE.'/db/q_setting.php');

$q_setting = new q_settingDb();
$q_no = 0;
foreach ($a_qid as $key => $value){
 $q_no += 1;
 try {
   $ret_setting = $q_setting->selectQsetting2($value['qid']);
 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "q_report03\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "q_report04\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }

 $q_select = json_decode($ret_setting[0]['q_select'],true);

 $formData[$ret_setting[0]['q_id']] = array("kind" => $ret_setting[0]['q_kind'], "answer" => array());
$form .= '<div class="row">';
$form .= '<div class="col-lg-12">';
$form .= '<div class="form-group">';
$form .= '<label class="col-sm-5">'.$q_no." : ".$ret_setting[0]['q_name'].'</label>';
$form .= '<label class="col-sm-7" id="'.$outputName.$ret_setting[0]['q_id'].'" name="inputAnswer[]"></label>';
$form .= '</div>'; //form-group
$form .= '</div>'; //col-lg-12
$form .= '</div>'; //row

 // 入力必須なら無選択件数はゼロ
 if ( $value['req'] ){
$html .= "<h4 class='requiredItem'>".$q_no." : ".$ret_setting[0]['q_sentence']."</h4>";
 }
 else {
$html .= "<h4>".$q_no." : ".$ret_setting[0]['q_sentence']."</h4>";
 }
$html .= '<div class="form-group">';
$html .= '  <label class="col-sm-4 control-label" for="'.$inputName.$ret_setting[0]['q_id'].'">'.$ret_setting[0]['q_explanation'].'</label>';
$html .= '  <div class="col-sm-8  form-inline">';

 // 選択数と選択ラベルタイトルをキープ → グラフに表示
 $chart_kind = 0;
 switch($ret_setting[0]['q_kind']) {
  case  1: //単一選択ドロップダウン
   $chart_kind = 1;
$html .= '   <select id="'.$inputName.$ret_setting[0]['q_id'].'" name="'.$inputName.$ret_setting[0]['q_id'].'" class="form-control">';
   foreach($q_select as $no=>$val) {
$html .= '    <option value="'.$no.'">'.$val.'</option>';
   }
$html .= '   </select>';
   break;
  case 21: //単一選択ラジオボタン
   $chart_kind = 1;
   foreach($q_select as $no=>$val) {
$html .= '    <label class="radio-inline"><input type="radio" name="'.$inputName.$ret_setting[0]['q_id'].'[]" value="'.(string)((int)$no+1).'"><small>'.$val.'</small></label>';
   }
$html .= '    <div id="'.$inputName.$ret_setting[0]['q_id'].'_error"></div>';
   break;
  case 23: //単一選択ラジオボタン段階評価
   $chart_kind = 1;
   foreach($q_select as $no=>$val) {
$html .= '    <label class="radio-inline"><input type="radio" name="'.$inputName.$ret_setting[0]['q_id'].'[]" value="'.(string)((int)$no+1).'"><small>'.$val.'</small></label>';   }
$html .= '    <div id="'.$inputName.$ret_setting[0]['q_id'].'_error" class="col-xs-8"  ></div>';
   break;
  case 31: //複数選択チェックボックス
   $chart_kind = 1;
   foreach($q_select as $no=>$val) {
$html .= '    <label class="radio-inline"><input type="checkbox" name="'.$inputName.$ret_setting[0]['q_id'].'[]" value="'.(string)((int)$no+1).'"><small>'.$val.'</small></label>';
   }
$html .= '    <div id="'.$inputName.$ret_setting[0]['q_id'].'_error"></div>';
   break;
  case 22: //単一選択ラジオボタンとその他記述
   $chart_kind = 1;
   foreach($q_select as $no=>$val) {
$html .= '	<label class="radio-inline"><input type="radio" name="'.$inputName.$ret_setting[0]['q_id'].'[]" id="'.$inputName.$ret_setting[0]['q_id'].(string)((int)$no+1).'" value="'.(string)((int)$no+1).'"><small>'.$val.'</small></label>';
   }
$html .= '    <div id="'.$inputName.$ret_setting[0]['q_id'].'_error"></div>';
$html .= '   <input type="text" class="form-control ime-disabled" id="'.$inputName.$ret_setting[0]['q_id'].'" name="'.$inputName.$ret_setting[0]['q_id'].'" placeholder="'.$ret_setting[0]['q_unit'].'" />';
   break;
  case 32: //複数選択チェックボックスとその他記述
   $chart_kind = 1;
   foreach($q_select as $no=>$val) {
$html .= '	<label class="checkbox-inline"><input type="checkbox" name="'.$inputName.$ret_setting[0]['q_id'].'[]" value="'.(string)((int)$no+1).'"><small>'.$val.'</small></label>';
   }
$html .= '    <div id="'.$inputName.$ret_setting[0]['q_id'].'_error"></div>';
$html .= '   <input type="text" class="form-control ime-disabled" id="'.$inputName.$ret_setting[0]['q_id'].'" name="'.$inputName.$ret_setting[0]['q_id'].'" placeholder="'.$ret_setting[0]['q_unit'].'" />';
   break;
  case 91: //自由記述一行
$html .= '   <input type="text" class="form-control ime-disabled" id="'.$inputName.$ret_setting[0]['q_id'].'" name="'.$inputName.$ret_setting[0]['q_id'].'" placeholder="'.$ret_setting[0]['q_unit'].'" />';
   break;
  case 99: //自由記述複数行
$html .= '   <textarea class="form-control ime-disabled" id="'.$inputName.$ret_setting[0]['q_id'].'" name="'.$inputName.$ret_setting[0]['q_id'].'" rows="3" placeholder="'.$ret_setting[0]['q_unit'].'" /></textarea>';
   break;
  default:
   break;
 }

$html .= ' </div>';
$html .= '</div>';
$html .= '<div id="list'.$ret_setting[0]['q_id'].'"></div>';
$html .= '<br>';
 if($chart_kind == 1) {
  $html .= '<div><canvas id="myChart'.$ret_setting[0]['q_id'].'" width="400"></canvas></div>';
 }
$html .= '<div id="qid'.$ret_setting[0]['q_id'].'"></div>';
$html .= '<br>';

 // 複数非同期を順番に処理
 // ajax パラメータ
$ajax_param = "param".$ret_setting[0]['q_id'];
$script .= "var ".$ajax_param." = {};";
$script .= $ajax_param."['gid'] = '".$gid."';";
$script .= $ajax_param."['aid'] = '".$aid."';";
$script .= $ajax_param."['qid'] = '".$ret_setting[0]['q_id']."';";

$script .= "var jquery".$ajax_param.' = {type: "POST", url: "./api/admin_report.php", data: '.$ajax_param.'};';

 if($script_ajax ==""){ // 初回
  $script_ajax .= "ajax_exec(jquery".$ajax_param.")";
 }
 else {
  $script_ajax .= ".then(ajax_exec(jquery".$ajax_param."), error)";
 }

} // foreach
$q_setting->closeDetaBase();
$script_ajax .= ";";

?>

<!DOCTYPE html>
<html lang="ja">
<head>
 <meta charset="utf-8">
 <title><?php echo P_TITLE;?> | <?php echo PAGE_NAME;?></title>

 <meta http-equiv="X-UA-Compatible" content="IE=edge">
 <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

 <link rel="stylesheet" type="text/css" href="css/bootstrap.min.css"/>
 <link href="css/style.css" rel="stylesheet">
<style>
th,td {
    border: solid 1px;          /* 枠線指定 */
}
 
table {
    border-collapse:  collapse; /* セルの線を重ねる */
    width:  100%;               /* 幅指定 */
}
 
th {
    text-align: left;           /* 文字の揃え位置指定 */
}
 
td {
    text-align:  center;        /* 文字の揃え位置指定 */
}
</style>
</head>
<body>

 <header style="background-color:white">
  <div class="container-fluid">
   <div class="row">
    <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
    <div class="col-sm-12 col-md-10" style="background-color:white;">
     <div class="pull-left">
      <h2><?php echo $title1 ?> 結果</h2>
      <small><?php echo "アンケート期間は".$ret_admin[0]["a_start"].'から'.$ret_admin[0]["a_end"]."まで。" ?></small>
     </div>
     <div class="pull-right" style="margin-top: 3px;">
      <a href="<?php echo $result_name ?>" class="btn btn-danger">ダウンロード</a><br><br>
     </div>
    </div>
    <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
   </div>
  </div>
 </header>
 <div class="container-fluid">
  <div class="row">
   <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
   <div class="col-sm-12 col-md-10" style="background-color:white;">
    <legend class='requiredBefore'>印のついた項目は入力必須です。</legend>
   </div>
   <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
  </div>
 </div>

 <div class="container-fluid">
  <div class="row">
   <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
   <div class="col-sm-12 col-md-10" style="background-color:white;">
    <form class="form-horizontal" id="myform">

<?php echo $html; ?>

    </form>
   </div>
   <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
  </div>
 </div>

 <?php include 'inc/footer.php'; ?> <!-- フッター共通部 -->

</body>
 <script type="text/javascript" src="js/jquery-3.5.1.js"></script>
 <script type="text/javascript" src="js/bootstrap.min.js"></script>
 <script src="//cdnjs.cloudflare.com/ajax/libs/Chart.js/2.9.3/Chart.js"></script>
 <script src="//github.com/nagix/chartjs-plugin-colorschemes/releases/download/v0.2.0/chartjs-plugin-colorschemes.min.js"></script>
 <script type="text/javascript">
$(window).on('load', function() {
<?php echo $script; ?>

 // ％を小数点1位まで表示
 function orgRound(value, base) {
  return Math.round(value / base * 1000) / 10;
 }

 // 画面を更新する処理
 function appendList(data) {
  var datakind = data.kind - 0;
  switch (datakind){
   case 22: //単一選択ラジオボタンとその他記述
   case 32: //複数選択チェックボックスとその他記述
    var qidstring = '#qid'+data.qid;
    $(qidstring).append('<h3>その他記述</h3>');
    var tablestring = '<table>';
    $.each(data.other, function(num, data_list) {
     $(qidstring).append('<tr><th>'+data_list+'</th></tr>');
    });
    tablestring += '</table>';
    $(qidstring).append(tablestring);

   case  1: //単一選択ドロップダウン
   case 21: //単一選択ラジオボタン
   case 31: //複数選択チェックボックス
    var qidstring = '#list'+data.qid;
    $(qidstring).append('<h3>回答数 : '+data.data[0].count+'件</h3>');
    var tablestring = '<table><tr>';
    $.each(data.q_array, function(num, data) {
     tablestring += '<th>'+data+'</th>';
    });
    tablestring += '</tr><tr>';

    $.each(data.data[0].a_array, function(num, adata) {
     tablestring += '<td>'+adata+'</td>';
    });
    tablestring += '</tr></table>';
    $(qidstring).append(tablestring);
    break;

   case 91: //自由記述一行
   case 99: //自由記述複数行
    var qidstring = '#qid'+data.qid;
    $(qidstring).append('<h3>記述内容</h3>');
    var tablestring = '<table>';
    $.each(data.other, function(num, data_list) {
     $(qidstring).append('<tr><th>'+data_list+'</th></tr>');
    });
    tablestring += '</table>';
    $(qidstring).append(tablestring);
    return;
    break;
   default:
    return;
   break;
  }

  var Graph_pattern = 'radar' ;
  var scales_on = false;


  if ((datakind == 1 || datakind == 21 || datakind == 22) && data.qnos.length <= 10 && data.data.length > 1){
   Graph_pattern = 'horizontalBar' ;
   scales_on = true;

   var labels = [];
   var datasets = [];
   var dataarray = new Array(data.qnos.length);
   for(let y = 0; y < data.qnos.length; y++) {
    dataarray[y] = new Array(data.data[0].a_array.length).fill(0);
   }

   var labelcount = 0;
   $.each(data.data, function(num, data_list) {
    labels.push(data_list.title); 
    var a_count = 0;
    $.each(data_list.a_array, function(num, adata) {
     dataarray[a_count][labelcount] = orgRound(adata,data_list.count); 
     a_count += 1;
    });
    labelcount += 1;
   });

   var labelcount = 0;
   $.each(data.q_array, function(num, data) {
    var dataset = {};
    dataset.label = data;
    dataset.data = dataarray[labelcount];
    datasets.push(dataset);
    labelcount += 1;
   });


  }
  else { //レーダーチャート
   if ((datakind == 1 || datakind == 21 || datakind == 22) && data.qnos.length <= 10){
    Graph_pattern = 'pie' ;
   }
   else {
    Graph_pattern = 'radar' ;
   }
   var labels = [];
   $.each(data.q_array, function(num, data) {
    labels.push(data); 
   });

   var datasets = [];
   $.each(data.data, function(num, data_list) {
    var datas = [];
    $.each(data_list.a_array, function(num, adata) {
     datas.push(orgRound(adata,data_list.count)); 
    });
    var dataset = {};
    dataset.label = data_list.title;
    dataset.data = datas;

    datasets.push(dataset);
   });
  }

  const gdata = {
   labels: labels,
   datasets: datasets
  };

  const scales = {
   xAxes: [{
    stacked: true //積み上げ棒グラフにする設定
   }],
   yAxes: [{
    stacked: true //積み上げ棒グラフにする設定
    ,xbarThickness: 10 //棒グラフの幅
   }]
  };

  var config = {
   type: Graph_pattern, //'radar',bar pie doughnut 
   data: gdata,
   options: {
    responsive: true,
    plugins: {
     title: {
      display: true,
      text: data.qid
     },
     colorschemes: {
      scheme: 'tableau.ClassicMedium10' //tableau.Classic20
     }
    },

    tooltips: {
     callbacks: {
      title: function (tooltipItem, data) {
       return data.labels[tooltipItem[0].index];
      },
      label: function (tooltipItem, data) {
       return data.datasets[tooltipItem.datasetIndex].label
        + ": "
        + data.datasets[tooltipItem.datasetIndex].data[tooltipItem.index];
        + " %"; //ここで単位を付けます
      }
     }
    }

   }
  };

  if(scales_on) config.options.scales = scales;
  var ctx = document.getElementById("myChart"+data.qid);
  var myChart = new Chart(ctx, config);
 }

 // エラー処理
 function error(error) {
 }

 // ajax実行
 function ajax_exec(param) {
  var deferred = $.Deferred();
  $.ajax(param).done(function(data, testStatus, jqXHR) {
   // 受信処理
   var rdata = JSON.parse(data);
   if(rdata.result == 'success') {
    // qid,kind,data を受け取り描画　qidで描画divを分ける kindで描画グラフをわける
    appendList(rdata.data);
   }
   deferred.resolve();
  }).fail(function(jqXHR, textStatus, errorThrown) {
   deferred.reject(jqXHR.responseText);
  });
  return deferred.promise();
 };

<?php echo $script_ajax; ?>

});

$(document).ready(function(){
});
 </script>
</html>

