<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/common.php');

// 不正POSTチェック
if(empty($_GET['gid']) || empty($_GET['aid'])) {
  exit();
}

// セッションチェック
// ログインしていない場合はログインページにリダイレクト
require_once (dirname(__FILE__).'/sessionchk.php');

// ページ名
define('PAGE_NAME', 'アンケート結果');

// 表示メッセージ
$html = "";
$script = "";
$rules = "";

//--------------------------------------------------------
// アンケート結果CSVファイルを作成
//--------------------------------------------------------
$load_name = $_GET['gid'].$_GET['aid']. date('ymd') . '.csv';
// CSVヘッダ
header('Cache-Control: public');
header('Pragma: public');
header('Content-Type: text/octet-stream');
header('Content-Disposition: attachment; filename=' . $load_name);

// アンケート回答を読み込む
try {
 //データベース関数のファイルの読み込み
 require_once ('../'.L_BASE.'/db/q_admin.php');

 $q_admin = new q_adminDb();
 $ret_answer = $q_admin->selectAnswer($_GET['gid'],$_GET['aid']);
 $q_admin->closeDetaBase();

}catch(ErrorException $ex){
 if(DEBUG_LEVEL != "0"){
  error_log("[". date('Y-m-d H:i:s') . "]". "q_result01\n","3","debug.log");
  error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
 }
}catch(PDOException $ex){
 if(DEBUG_LEVEL != "0"){
  error_log("[". date('Y-m-d H:i:s') . "]". "q_result02\n","3","debug.log");
  error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
 }
}

// アンケート回答を整形
$data_answer = array();
foreach ($ret_answer as $key => $value){
 $data_answer[$key] = array(
  "rid"=> $value['r_id'],
  "creation_dt"=>$value['creation_dt']
 );
 $answer = json_decode($value['answer']);
 foreach ($answer as $key1 => $value1){
  foreach ($value1 as $key2 => $value2){
   $data_answer[$key][$key2.":記述"] = '"'.(string)($value2->other).'"';
   $sid = '"';
   $slabel = '"';
   $dataTrue = false;
   foreach ((array)($value2->sid) as $key3 => $value3){
    $sid .= $value3.",";
    $dataTrue = true;
   }
   if($dataTrue) {
    $sid = substr($sid, 0, -1);
   }
   $dataTrue = false;
   foreach ((array)($value2->slabel) as $key3 => $value3){
    $slabel .= $value3.",";
    $dataTrue = true;
   }
   if($dataTrue) {
    $slabel = substr($slabel, 0, -1);
   }
   $sid .= '"';
   $slabel .= '"';
   $data_answer[$key][$key2.":選択"] = $sid;
   $data_answer[$key][$key2.":文字"] = $slabel;
  }
 }
}

// アンケート回答をCSV形式に変換
$title = true;
if (! empty($data_answer)) {
 foreach($data_answer as $linesKey => $linesVal) {
  $titleData = "";
  $lineData = "";
  $dataTrue = false;
  foreach($linesVal as $key => $val) {
   $titleData .= $key.",";
   $lineData .= $val.",";
   $dataTrue = true;
  }
  if($dataTrue) {
   $titleData = substr($titleData, 0, -1);
   $lineData = substr($lineData, 0, -1);
  }
  // SJISに設定
  if($title) {
   // タイトル行（1行目）
   echo mb_convert_encoding($titleData. "\r\n", 'SJIS-WIN', 'UTF-8');
   $title = false;
  }
  echo mb_convert_encoding($lineData. "\r\n", 'SJIS-WIN', 'UTF-8');
 }
}
exit;

?>

