<?php
//入力値に不正なデータがないかなどをチェックする関数
function checkInput($var){
 if(is_array($var)){
  return array_map('checkInput', $var);
 }else{
  if(preg_match('/\0/', $var)){  //NULLバイト攻撃対策
   die('不正な入力です。');
  }
  if(!mb_check_encoding($var, 'UTF-8')){ //文字エンコードのチェック
   die('不正な入力です。');
  }	
  //改行、タブ以外の制御文字のチェック
  if(preg_match('/\A[\r\n\t[:^cntrl:]]*\z/u', $var) == 0){  
   die('不正な入力です。制御文字は使用できません。');
  }	
  return $var;
 }
}
 
//エスケープ処理を行う関数
function h($str){
 if(is_array($str)){
  //$strが配列の場合、h()関数をそれぞれの要素について呼び出す
  return array_map('h', $str);    
 }else{
  return htmlspecialchars($str, ENT_QUOTES, 'UTF-8');
 }
}
?>
