<?php
//セッション名を指定
session_name(SESSION_NAME);
//セッション開始
session_start();

//データベース関数のファイルの読み込み
require_once ('../'.L_BASE.'/db/meibo.php');
//検証及びエスケープ処理の関数のファイルの読み込み
require_once 'session_validation.php';

//セッションIDを初期化
$cookie_session_id = NULL;

//クッキーからセッションIDを取得
if (isset($_COOKIE[session_name()])){
 $cookie_session_id = h($_COOKIE[session_name()]) ;
}

//セッションIDを変更（セッションハイジャック対策）
session_regenerate_id(TRUE); 

// 表示メッセージ
header("Content-type: text/html; charset=utf-8");
$message = "";

//--------------------------------------------------------
// ログインしていない場合は強制的にログインページにリダイレクト
//--------------------------------------------------------
$login_retry = true;

if (isset($cookie_session_id)) {
 try {

  $meibo = new meiboDb();
  $meibo->createMeibotbl(); // テーブル作成
  $ret = $meibo->selectSession($cookie_session_id);
  $meibo->closeDetaBase();

  if (isset($ret[0]) && !empty($ret[0]) && (count($ret) > 0) && isset($_SESSION['user_id'])) {
   // DBにセッション有
   // セッション比較
   if ($_SESSION['user_id'] == $ret[0]['user_id']) {
    // DBのセッションID同一でユーザー同一なら
    // セッションIDを更新
    $meibo = new meiboDb();
    $meibo->updateSession( session_id(), $_SESSION['user_id'] );
    $meibo->commit();
    $meibo->closeDetaBase();

    $user_id = $ret[0]['user_id']; //ユーザーID
    $user_kind = $ret[0]['kind']; //ユーザー種別　0:システム管理者（メンテ用）　1:管理者　2:劇場管理者
    $user_authority = $ret[0]['authority']; //管理権限　0:閲覧のみ  1:すべて　2:一部　3:追加のみ
    $user_gekijo_id = $ret[0]['gekijo_id']; //劇場ID

    $login_retry = false;
   }
  }
 }catch(ErrorException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "sessionchk01\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }catch(PDOException $ex){
  if(DEBUG_LEVEL != "0"){
   error_log("[". date('Y-m-d H:i:s') . "]". "sessionchk02\n","3","debug.log");
   error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
  }
 }
}

if($login_retry) {
 // ログインページへ
 header("Location: login");
 exit();
}

?>
