<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/common.php');

// セッションチェック
// ログインしていない場合はログインページにリダイレクト
require_once (dirname(__FILE__).'/sessionchk.php');

// ページ名
define('PAGE_NAME', '劇場管理');

?>

<!DOCTYPE html>
<html lang="ja">
<head>
 <meta charset="utf-8">
 <title><?php echo P_TITLE;?> | <?php echo PAGE_NAME;?></title>

 <meta http-equiv="X-UA-Compatible" content="IE=edge">
 <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

 <link rel="stylesheet" type="text/css" href="css/dataTables.bootstrap.min.css"/>
 <link rel="stylesheet" type="text/css" href="css/bootstrap.min.css"/>
 <link href="css/style.css" rel="stylesheet">

</head>
<body>

 <?php include 'inc/header.php'; ?> <!-- ヘッダー共通部 -->
 <?php include 'inc/pagename.php'; ?> <!-- ページ名共通部 -->

 <div class="container-fluid">
  <div class="row">
   <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
   <div class="col-sm-12 col-md-10" style="background-color:white;">
    <div>
     <table id="myTable" class="table table-striped tagle-bordered">
      <thead>
       <tr>
        <th>劇場ID</th>
        <th>担当者</th>
        <th>略称</th>
        <th>正式名称</th>
        <th>状態</th>
       </tr>
      </thead>
      <tbody>
<?php $message; ?>
      </tbody>
      <tfoot>
       <tr>
        <th>劇場ID</th>
        <th>担当者</th>
        <th>略称</th>
        <th>正式名称</th>
        <th>状態</th>
       </tr>
      </tfoot>
     </table>
    </div>
    <div style="height:60px">
     <hr>
     <div class="pull-left">
<?php if ($user_kind == 0 || ($user_kind == 1 && $user_authority <= 2)): ?>
      <button id="registButton" type="button" class="btn btn-primary">登録</button>
<?php endif; ?>
<?php if (($user_kind == 0) || ($user_authority <= 1)): ?>
      <button id="updateButton" type="button" class="btn btn-success" disabled>更新</button>
<?php endif; ?>
     </div>
<?php if ($user_kind == 0): ?>
     <div class="pull-right">
      <button id="deleteButton" type="button" class="btn btn-danger" disabled>削除</button>
     </div>
<?php endif; ?>
     <br>
    </div>
   </div>

   <div id="form" class="modal fade" tabindex="-1">
    <div class="modal-dialog modal-dialog-centered ">
     <div class="modal-content">
      <div class="modal-header">
       <h4 id="dialogTitle" class="modal-title">登録</h4>
       <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
      </div>
      <div class="modal-body">
       <div class="container-fluid">
        <div class="row">
         <div class="col-lg-12">
          <div id="alert_form"></div>

          <form class="form-horizontal" id="sample-form">
           <div class="form-group">
<?php if ($user_kind == 2): ?>
            <label class="col-sm-4 control-label" for="inputId">劇場ID (不可)</label>
<?php else: ?>
            <label class="col-sm-4 control-label" for="inputId">劇場ID (必須)</label>
<?php endif; ?>
            <div class="col-sm-8">
             <input type="text" class="form-control ime-disabled" id="inputId" name="inputId" placeholder="半角英大・小・数字混在、4文字" />
            </div>
           </div>

           <div class="form-group">
<?php if ($user_kind == 2): ?>
            <label class="col-sm-4 control-label" for="inputUser">担当者 (不可)</label>
<?php else: ?>
            <label class="col-sm-4 control-label" for="inputUser">担当者 (必須)</label>
<?php endif; ?>
            <div class="col-sm-8">
             <input type="text" class="form-control ime-disabled" id="inputUser" name="inputUser" placeholder="半角英大・小・数字混在、4文字" />
            </div>
           </div>

           <div class="form-group">
<?php if ($user_kind == 2): ?>
            <label class="col-sm-4 control-label" for="inputKind">種別 (不可)</label>
<?php else: ?>
            <label class="col-sm-4 control-label" for="inputKind">種別 (必須)</label>
<?php endif; ?>
            <div class="col-sm-8">
             <select id="inputKind" name="inputKind" class="form-control">
<?php if ($user_kind == 0): ?>
              <option value="00">システム管理者</option>
              <option value="01">管理者</option>
<?php endif; ?>
              <option value="02">劇場管理者</option>
             </select>
            </div>
           </div>

           <div class="form-group">
<?php if ($user_kind == 2): ?>
            <label class="col-sm-4 control-label" for="inputExistence">状態 (不可)</label>
<?php else: ?>
            <label class="col-sm-4 control-label" for="inputExistence">状態 (必須)</label>
<?php endif; ?>
            <div class="col-sm-8">
<?php if ($user_kind == 2): ?>
             <select id="inputExistence" name="inputExistence" class="form-control" disabled>
<?php else: ?>
             <select id="inputExistence" name="inputExistence" class="form-control">
<?php endif; ?>
<?php if ($user_kind == 0 || ($user_kind == 1 && $user_authority <= 1)): ?>
              <option value="00">有効</option>
              <option value="01">停止</option>
<?php else: ?>
              <option value="00" disabled>有効</option>
              <option value="01" disabled>停止</option>
<?php endif; ?>
<?php if ($user_kind == 0 || ($user_kind == 1 && $user_authority == 0)): ?>
              <option value="02">削除</option>
<?php else: ?>
              <option value="02" disabled>削除</option>
<?php endif; ?>
             </select>
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputName">正式名称 (必須)</label>
            <div class="col-sm-8">
             <input type="text" class="form-control ime-disabled" id="inputName" name="inputName" placeholder="劇場正式名称" />
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputSname">略称 (必須)</label>
            <div class="col-sm-8">
             <input type="text" class="form-control ime-disabled" id="inputSname" name="inputSname" placeholder="劇場略称" />
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputPostcode">郵便番号 (必須)</label>
            <div class="col-sm-8">
             <input type="text" class="form-control ime-disabled" id="inputPostcode" name="inputPostcode" placeholder="1234567" onKeyUp="AjaxZip3.zip2addr(this,'','inputPrefectures','inputAddress1','inputAddress2');">
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputPrefectures">都道府県 (必須)</label>
            <div class="col-sm-8">
             <select id="inputPrefectures" name="inputPrefectures"  class="form-control p-region-id">
              <option value="">-- 都道府県 --</option>
              <option value="北海道">北海道</option>
              <option value="青森県">青森県</option>
              <option value="岩手県">岩手県</option>
              <option value="宮城県">宮城県</option>
              <option value="秋田県">秋田県</option>
              <option value="山形県">山形県</option>
              <option value="福島県">福島県</option>
              <option value="茨城県">茨城県</option>
              <option value="栃木県">栃木県</option>
              <option value="群馬県">群馬県</option>
              <option value="埼玉県">埼玉県</option>
              <option value="千葉県">千葉県</option>
              <option value="東京都">東京都</option>
              <option value="神奈川県">神奈川県</option>
              <option value="新潟県">新潟県</option>
              <option value="富山県">富山県</option>
              <option value="石川県">石川県</option>
              <option value="福井県">福井県</option>
              <option value="山梨県">山梨県</option>
              <option value="長野県">長野県</option>
              <option value="岐阜県">岐阜県</option>
              <option value="静岡県">静岡県</option>
              <option value="愛知県">愛知県</option>
              <option value="三重県">三重県</option>
              <option value="滋賀県">滋賀県</option>
              <option value="京都府">京都府</option>
              <option value="大阪府">大阪府</option>
              <option value="兵庫県">兵庫県</option>
              <option value="奈良県">奈良県</option>
              <option value="和歌山県">和歌山県</option>
              <option value="鳥取県">鳥取県</option>
              <option value="島根県">島根県</option>
              <option value="岡山県">岡山県</option>
              <option value="広島県">広島県</option>
              <option value="山口県">山口県</option>
              <option value="徳島県">徳島県</option>
              <option value="香川県">香川県</option>
              <option value="愛媛県">愛媛県</option>
              <option value="高知県">高知県</option>
              <option value="福岡県">福岡県</option>
              <option value="佐賀県">佐賀県</option>
              <option value="長崎県">長崎県</option>
              <option value="熊本県">熊本県</option>
              <option value="大分県">大分県</option>
              <option value="宮崎県">宮崎県</option>
              <option value="鹿児島県">鹿児島県</option>
              <option value="沖縄県">沖縄県</option>
             </select>
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputAddress1">市区町村 (必須)</label>
            <div class="col-sm-8">
             <input type="text" id="inputAddress1" name="inputAddress1" class="form-control ime-disabled p-locality" placeholder="市区町村" />
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputAddress2">住所番地まで (必須)</label>
            <div class="col-sm-8">
             <input type="text" id="inputAddress2" name="inputAddress2" class="form-control ime-disabled p-street-address" placeholder="住所番地まで" />
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputAddress3">以降の住所 (任意)</label>
            <div class="col-sm-8">
             <input type="text" id="inputAddress3" name="inputAddress3" class="form-control ime-disabled p-extended-address" placeholder="以降の住所" />
            </div>
           </div>
           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputUrl">劇場サイトURL (任意)</label>
            <div class="col-sm-8">
             <input type="text" name="inputUrl" class="form-control ime-disabled" id="inputUrl" placeholder="https://aaa.com" />
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputTel">電話番号 (任意)</label>
            <div class="col-sm-8">
             <input type="text" name="inputTel" class="form-control ime-disabled" id="inputTel" placeholder="111-222-3333" />
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputMail">メールアドレス (任意)</label>
            <div class="col-sm-8">
             <input type="text" name="inputMail" class="form-control ime-disabled" id="inputMail" placeholder="メールアドレス" />
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputExplanation">説明 (任意)</label>
            <div class="col-sm-8">
             <input type="text" class="form-control ime-disabled" id="inputExplanation" name="inputExplanation" placeholder="劇場説明" />
            </div>
           </div>

           <div class="form-group">
            <label class="col-sm-4 control-label" for="inputComment">自由記述コメント (任意)</label>
            <div class="col-sm-8">
             <input type="text" name="inputComment" class="form-control ime-disabled" id="inputComment" placeholder="自由記述コメント" />
            </div>
           </div>
          </form>
         </div>
        </div>
       </div>
      </div>
      <div class="modal-footer">
       <div id="inputError" class="float-left" style="color:red; padding:5px;"></div>
        <button id="sendRegistButton" type="button" class="btn btn-primary"><i class="fa fa-check"></i>&nbsp;登録</button>
        <button id="sendUpdateButton" type="button" class="btn btn-primary"><i class="fa fa-check"></i>&nbsp;修正</button>
        <button type="button" class="btn btn-default" data-dismiss="modal"><i class="fa fa-remove"></i>&nbsp;閉じる</button>
       </div>
      </div>
     </div>

     <!-- Modal -->
     <div class="modal fade" id="messageModalSuccess" role="dialog">
      <div class="modal-dialog">
       <!-- Modal content-->
       <div class="modal-content modalmsg-success">
        <div class="modal-header">
         <h4 class="modal-title" id="modalSuccessLabel"></h4>
        </div>
       </div>
      </div>
     </div>

     <!-- Modal -->
     <div class="modal fade" id="messageModalError" role="dialog">
      <div class="modal-dialog">
       <!-- Modal content-->
       <div class="modal-content modalmsg-danger">
        <div class="modal-header">
         <button type="button" class="close"  id="modalErrorClose">
          <span aria-hidden="true">&times;</span>
         </button>
         <h4 class="modal-title" id="modalErrorLabel"></h4>
        </div>
        <div class="modal-body modalmsg-body" id="modalErrorMsg">
        </div>
       </div>
      </div>
     </div>
    </div>
    <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
   </div>
  </div>
 </div>

 <?php include 'inc/footer.php'; ?> <!-- フッター共通部 -->

</body>
 <script type="text/javascript" src="js/jquery-3.5.1.js"></script>
 <script type="text/javascript" src="js/bootstrap.min.js"></script>
 <script type="text/javascript" src="js/jquery.dataTables.min.js"></script>
 <script type="text/javascript" src="js/dataTables.bootstrap.min.js"></script>
 <script type="text/javascript" src="js/bootbox.min.js"></script>
 <script type="text/javascript" src="js/jquery.validate.js"></script>
 <script type="text/javascript" src="js/validate-ja.js"></script>
 <script type="text/javascript" src="js/theater.js"></script>
 <script type="text/javascript" src="js/ajaxzip3.js"></script>
</html>
