<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/apicommon.php');

// 不正POSTチェック
if(empty($_POST['cid']) || empty($_POST['gid']) || empty($_POST['aid']) ||  empty($_POST['rid']) || empty($_POST['answer'])) {
  $json_data = array(
   'result'=> "error",
   'errorcode'=> "9101",
   'message'=> "不正なデータです。"
  );
  echo json_encode($json_data);
  exit();
}

//--------------------------------------------------------
// アンケート回答処理開始
//--------------------------------------------------------
try {
 $cookieData = $_POST['cid'];
 $gid = $_POST['gid'];
 $aid = $_POST['aid'];
 $rid = $_POST['rid'];
 $answer = $_POST['answer'];

 // データベース関数のファイルの読み込み
 require_once ('../../'.L_BASE.'/db/accesslog.php');
//--------------------------------------------------------
// 回答権限をチェック
//--------------------------------------------------------
 $accesslog = new accesslogDb();
 $ret_AccessLog = $accesslog->selectAccessLog($cookieData);
 $accesslog->closeDetaBase();
 if(count($ret_AccessLog) == 0){
  //DBエラー異常
  $json_data = array(
   'result'=> "error",
   'errorcode'=> "9106",
   'message'=> "不正なデータです。"
  );
  echo json_encode($json_data);
  exit();
 }
 if(($ret_AccessLog[0]["kind"] == 3) &&
    !((DEBUG_LEVEL == "2") && ($rid == "TEST"))) { // 開発モードで回答テスト
  //回答済み
  $json_data = array(
   'result'=> "error",
   'errorcode'=> "9108",
   'message'=> "回答済みです。"
  );
  echo json_encode($json_data);
  exit();
 }

 //データベース関数のファイルの読み込み
 require_once ('../../'.L_BASE.'/db/q_admin.php');
 $a_admin = new q_adminDb();
 $ret_admin = $a_admin->selectAadmin2($gid, $aid);
 if(count($ret_admin) != 0){
  $nowDay = new DateTime();
  $startDay = new DateTime($ret_admin[0]["a_start"]);
  $endDay = new DateTime($ret_admin[0]["a_end"]);
  if (($startDay > $nowDay) && ($endDay < $nowDay)) {
   //期限切れ
   $a_admin->closeDetaBase();
   $json_data = array(
    'result'=> "error",
    'errorcode'=> "9102",
    'message'=> "回答期限外です。"
   );
   echo json_encode($json_data);
   exit();
  }
  if ($ret_admin[0]["a_existence"] == 0) {
//--------------------------------------------------------
// アンケート回答をデータベースに追加
//--------------------------------------------------------
   $ret = $a_admin->insertAnswer($gid, $aid, $rid, $cookieData, $answer, NULL, NULL, NULL, NULL, NULL);
   $a_admin->commit();
   $a_admin->closeDetaBase();
   if(!isset($ret) || empty($ret)) {
   //DBエラークッキー不正
    $json_data = array(
     'result'=> "error",
     'errorcode'=> "9103",
     'message'=> "不正なデータです。"
    );
    echo json_encode($json_data);
    exit();
   }
  }
  else {
   //停止中または削除
   $a_admin->closeDetaBase();
   $json_data = array(
    'result'=> "error",
    'errorcode'=> "9104",
    'message'=> "メンテナンス中です。"
   );
   echo json_encode($json_data);
   exit();
  }
 }
 else {
  //アンケートなし不正
  $a_admin->closeDetaBase();
  $json_data = array(
   'result'=> "error",
   'errorcode'=> "9105",
   'message'=> "不正なデータです。"
  );
  echo json_encode($json_data);
  exit();
 }
 // 回答済みに設定
 $accesslog = new accesslogDb();
 $ret = $accesslog->updateKind($cookieData,3); // 3:回答済
 $accesslog->commit();
 $accesslog->closeDetaBase();

 if(!isset($ret) || empty($ret)) {
  //DBエラー異常
  $json_data = array(
   'result'=> "error",
   'errorcode'=> "9107",
   'message'=> "不正なデータです。"
  );
  echo json_encode($json_data);
  exit();
 }
}catch(ErrorException $ex){
 if(DEBUG_LEVEL != "0"){
  error_log("[". date('Y-m-d H:i:s') . "]". "answer01\n","3","debug.log");
  error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
 }
}catch(PDOException $ex){
 if(DEBUG_LEVEL != "0"){
  error_log("[". date('Y-m-d H:i:s') . "]". "answer02\n","3","debug.log");
  error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
 }
}

echo json_encode(array('result'=> "success"));
?>
