<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/apicommon.php');

// 不正POSTチェック
if(empty($_POST['cid']) || empty($_POST['gid']) || empty($_POST['aid']) || empty($_POST['rid'])) {
 $json_data = array(
  'result'=> "error",
  'errorcode'=> "9201",
  'message'=> "不正なデータです。"
 );
 echo json_encode($json_data);
 exit();
}

//--------------------------------------------------------
// アクセスログを更新
//--------------------------------------------------------
// データベース関数のファイルの読み込み
require_once ('../../'.L_BASE.'/db/accesslog.php');

try {
 $accesslog = new accesslogDb();
 $cookieData = $_POST['cid'];
 $ret_AccessLog = $accesslog->selectAccessLog($cookieData);
 if(count($ret_AccessLog) == 0){
  $accesslog->closeDetaBase();
  $json_data = array(
   'result'=> "error",
   'errorcode'=> "9202",
   'message'=> "不正なデータです。"
  );
  echo json_encode($json_data);
  exit();
 }
 if(($ret_AccessLog[0]["kind"] == 3) &&
    !((DEBUG_LEVEL == "2") && ($_POST['rid'] == "TEST"))) { // 開発モードで回答テスト
  //回答済み
  $json_data = array(
   'result'=> "error",
   'errorcode'=> "9208",
   'message'=> "回答済みです。"
  );
  echo json_encode($json_data);
  exit();
 }

 $ret = $accesslog->updateKind($cookieData,1); // エラー回数更新
 $accesslog->commit();
 $accesslog->closeDetaBase();

 if(!isset($ret) || empty($ret)) {
  $json_data = array(
   'result'=> "error",
   'errorcode'=> "9203",
   'message'=> "不正なデータです。"
  );
  echo json_encode($json_data);
  exit();
 }

}catch(ErrorException $ex){
 if(DEBUG_LEVEL != "0"){
  error_log("[". date('Y-m-d H:i:s') . "]". "log_update01\n","3","debug.log");
  error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
 }
}catch(PDOException $ex){
 if(DEBUG_LEVEL != "0"){
  error_log("[". date('Y-m-d H:i:s') . "]". "log_update02\n","3","debug.log");
  error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
 }
}
echo json_encode(array('result'=> "success"));
?>
