<?php
// 環境定義ファイル・稼働モード時の動作を設定
require_once (dirname(__FILE__).'/common.php');

// 0:不正アクセス 1:クッキー設定不可 2:回答期限済 98:メンテナンス中 99:回答済み
define('INVALID', 0);
define('COOKIE', 1);
define('EXPIRATION', 2);
define('SUSPENSION', 3);
define('DELETED', 4);
define('MAINTENANCE', 98);
define('ANSWERED', 99);

$init_success = false;
$aid = "";
$gid = "";
$rid = "";
$gjo_id = "";
$kind = INVALID;

//--------------------------------------------------------
// メンテナンス中
//--------------------------------------------------------
if((DEBUG_LEVEL == "2") && ($_GET['rid'] != "TEST")) { // 開発モードで回答テスト以外
 $kind = MAINTENANCE;
 echo "ただいまメンテナンス中です。";
 return;
}
//--------------------------------------------------------
// 劇場IDとアンケートIDでアンケートの存在をチェック
//--------------------------------------------------------
//もしGETされていたら
if(isset($_GET)) {
 if((isset($_GET['pname']) && $_GET['pname'] != '')
  &&(isset($_GET['gid']) && $_GET['gid'] != '')
  &&(isset($_GET['aid']) && $_GET['aid'] != '')
  &&(isset($_GET['rid']) && $_GET['rid'] != '')){

  $aid = $_GET['aid'];
  $gid = $_GET['gid'];
  $rid = $_GET['rid'];

  if($_GET['pname'] == P_NAME) {
   //劇場IDとアンケートIDでアンケートの存在をチェック
   try {
    //データベース関数のファイルの読み込み
    require_once ('../'.L_BASE.'/db/q_admin.php');

    $q_admin = new q_adminDb();
    $ret_admin = $q_admin->selectAadmin2($gid, $aid);
    $q_admin->closeDetaBase();

    if(count($ret_admin) != 0){
     $nowDay = new DateTime();
     $startDay = new DateTime($ret_admin[0]["a_start"]);
     $endDay = new DateTime($ret_admin[0]["a_end"]);
     if ((($startDay <= $nowDay) && ($endDay > $nowDay))
      && ($ret_admin[0]["a_existence"] == 0)) {
      $init_success = true;
     }
     else if((DEBUG_LEVEL == "2") && ($_GET['rid'] == "TEST")) {
      // 開発モードで回答テストの場合はアンケート期間外でもOK
      $init_success = true;
     }
     else {
      if($ret_admin[0]["a_existence"] != 0) {
       $kind = EXPIRATION + $ret_admin[0]["a_existence"];
      }
      else {
       $kind = EXPIRATION;
      }
     }
    }
    else {
     $kind = INVALID;
    }

   }catch(ErrorException $ex){
    if(DEBUG_LEVEL != "0"){
     error_log("[". date('Y-m-d H:i:s') . "]". "index01\n","3","debug.log");
     error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
    }
   }catch(PDOException $ex){
    if(DEBUG_LEVEL != "0"){
     error_log("[". date('Y-m-d H:i:s') . "]". "index02\n","3","debug.log");
     error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
    }
   }

  }
  else {
   $kind = INVALID;
  }
 }
}

//--------------------------------------------------------
// アクセスログを更新
//--------------------------------------------------------
//データベース関数のファイルの読み込み
require_once ('../'.L_BASE.'/db/accesslog.php');

$accesslog = new accesslogDb();

//URL有効
if($init_success){

 $cookieName = P_NAME."-".$gid.$aid;

 //初訪問なら
 if(empty($_COOKIE[$cookieName])){
  //クッキーを設定
  $cookieData = accesslogDb::generate();
  // クッキー重複なら一度だけリトライ
  if(count($accesslog->selectAccessLog($cookieData)) != 0){
   if(DEBUG_LEVEL != "0"){
    error_log("[". date('Y-m-d H:i:s') . "] indexクッキー重複:". $cookieData."\n","3","./debug.log");
   }
   $cookieData = accesslogDb::generate();
  }

  $theDay = new DateTime($ret_admin[0]["a_end"]);
  if(setcookie($cookieName,$cookieData,$theDay->format('U'),'/','', TRUE, TRUE)){
   //クッキーを設定成功
   //アクセスログにインサート
   $accesslog->insertAccessLog($aid, $gid, $rid, $cookieData);
   $accesslog->commit();
  }
  else {
   //クッキーを設定失敗
   $init_success = false;
   $kind = COOKIE;
  }
 }
 //再訪問なら
 else {
  $cookieData = $_COOKIE[$cookieName];
  $ret_AccessLog = $accesslog->selectAccessLog($cookieData);
  if(count($ret_AccessLog) != 0){
   if(($ret_AccessLog[0]["kind"] == 3) &&
      !((DEBUG_LEVEL == "2") && ($rid == "TEST"))) { // 開発モードで回答テスト
    //回答済み
    $init_success = false;
    $kind = ANSWERED;
   }
   else {
    $accesslog->updateAccessLog($cookieData, $ret_AccessLog[0]["visitCount"] + 1);
    $accesslog->commit();
   }
  }
  else {
   //DBにクッキーなし
   $init_success = false;
   $kind = COOKIE;
  }
 }

}

if(!$init_success){
 //不正アクセスとしてDBに書き込む
 $accesslog->insertInvalidLog($aid, $gid, $rid, $kind);
 $accesslog->commit();
 $accesslog->closeDetaBase();
 if($kind == INVALID) {
  echo "不正なアクセスです。";
  return;
 }

}

$accesslog->closeDetaBase();

//--------------------------------------------------------
// アンケートページ作成処理
//--------------------------------------------------------
// 表示メッセージ
header("Content-type: text/html; charset=utf-8");
$html = "";
$script = "";
$rules = "";
$messages = "";
$form = "";
$formData = array();

$title1 = $ret_admin[0]["a_name"];
$title2 = $ret_admin[0]["a_explanation"];

//データベース関数のファイルの読み込み
require_once ('../'.L_BASE.'/db/gekijo.php');

$gekijo = new gekijoDb();
$ret_gekijo = $gekijo->selectGekijo($gid);
$gekijo->closeDetaBase();

$gekijo_name = $ret_gekijo[0]["gekijo_name"];
$gekijo_address = $ret_gekijo[0]["gekijo_prefectures"].$ret_gekijo[0]["gekijo_address1"].$ret_gekijo[0]["gekijo_address2"].$ret_gekijo[0]["gekijo_address3"];
$gekijo_url = $ret_gekijo[0]["gekijo_url"];
$gekijo_tel = $ret_gekijo[0]["gekijo_tel"];
$gekijo_mail = $ret_gekijo[0]["gekijo_mail"];

$footer_text = "<strong>".$gekijo_name."</strong>";
if($gekijo_url != "") {
 $footer_text .= "</br>URL&nbsp;:&nbsp;".$gekijo_url ;
}
if($gekijo_mail != "") {
 $footer_text .= "</br>Mail&nbsp;:&nbsp;".$gekijo_mail ;
}

if($init_success){
 // アンケート表示処理
 $inputName = "in";
 $outputName = "out";
 $a_qid = json_decode($ret_admin[0]['a_qid'],true);

 //データベース関数のファイルの読み込み
 require_once ('../'.L_BASE.'/db/q_setting.php');

 $q_setting = new q_settingDb();
$html .= "<h4 class='requiredBefore'>印のついた項目は入力必須です。</h4>";

 $q_no = 0;
 foreach ($a_qid as $key => $value){
  $q_no += 1;

  try {
   $ret_setting = $q_setting->selectQsetting2($value['qid']);

  }catch(ErrorException $ex){
   if(DEBUG_LEVEL != "0"){
    error_log("[". date('Y-m-d H:i:s') . "]". "index03\n","3","debug.log");
    error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
   }
  }catch(PDOException $ex){
   if(DEBUG_LEVEL != "0"){
    error_log("[". date('Y-m-d H:i:s') . "]". "index04\n","3","debug.log");
    error_log(print_r($ex->getMessage(),true)."\n","3","debug.log");
   }
  }

  $q_select = json_decode($ret_setting[0]['q_select'],true);

  $formData[$ret_setting[0]['q_id']] = array("kind" => $ret_setting[0]['q_kind'], "answer" => array());
$form .= '<div class="row">';
$form .= '<div class="col-lg-12">';
$form .= '<div class="form-group">';
$form .= '<label class="col-sm-5">'.$q_no." : ".$ret_setting[0]['q_name'].'</label>';
$form .= '<label class="col-sm-7" id="'.$outputName.$ret_setting[0]['q_id'].'" name="inputAnswer[]"></label>';
$form .= '</div>'; //form-group
$form .= '</div>'; //col-lg-12
$form .= '</div>'; //row

 if ( $value['req'] ){
$html .= "<h4 class='requiredItem'>".$q_no." : ".$ret_setting[0]['q_sentence']."</h4>";
 }
 else {
$html .= "<h4>".$q_no." : ".$ret_setting[0]['q_sentence']."</h4>";
 }
$html .= '<div class="form-group">';
$html .= '  <label class="col-sm-4 control-label" for="'.$inputName.$ret_setting[0]['q_id'].'">'.$ret_setting[0]['q_explanation'].'</label>';
$html .= '  <div class="col-sm-8  form-inline">';

  switch($ret_setting[0]['q_kind']) {
   case  1: //単一選択ドロップダウン
$html .= '   <select id="'.$inputName.$ret_setting[0]['q_id'].'" name="'.$inputName.$ret_setting[0]['q_id'].'" class="form-control">';
    foreach($q_select as $no=>$val) {
$html .= '    <option value="'.$no.'">'.$val.'</option>';
    }
$html .= '   </select>';
    break;
   case 21: //単一選択ラジオボタン
    foreach($q_select as $no=>$val) {
$html .= '    <label class="radio-inline"><input type="radio" name="'.$inputName.$ret_setting[0]['q_id'].'[]" value="'.(string)((int)$no+1).'"><small>'.$val.'</small></label>';
    }
$html .= '    <div id="'.$inputName.$ret_setting[0]['q_id'].'_error"></div>';
    break;
   case 23: //単一選択ラジオボタン段階評価
    foreach($q_select as $no=>$val) {
$html .= '    <label class="radio-inline"><input type="radio" name="'.$inputName.$ret_setting[0]['q_id'].'[]" value="'.(string)((int)$no+1).'"><small>'.$val.'</small></label>';
    }
$html .= '    <div id="'.$inputName.$ret_setting[0]['q_id'].'_error" class="col-xs-8"  ></div>';
    break;
   case 31: //複数選択チェックボックス
    foreach($q_select as $no=>$val) {
$html .= '    <label class="radio-inline"><input type="checkbox" name="'.$inputName.$ret_setting[0]['q_id'].'[]" value="'.(string)((int)$no+1).'"><small>'.$val.'</small></label>';
    }
$html .= '    <div id="'.$inputName.$ret_setting[0]['q_id'].'_error"></div>';
    break;
   case 22: //単一選択ラジオボタンとその他記述
    foreach($q_select as $no=>$val) {
$html .= '	<label class="radio-inline"><input type="radio" name="'.$inputName.$ret_setting[0]['q_id'].'[]" id="'.$inputName.$ret_setting[0]['q_id'].(string)((int)$no+1).'" value="'.(string)((int)$no+1).'"><small>'.$val.'</small></label>';
    }
$html .= '    <div id="'.$inputName.$ret_setting[0]['q_id'].'_error"></div>';
$html .= '   <input type="text" class="form-control ime-disabled" id="'.$inputName.$ret_setting[0]['q_id'].'" name="'.$inputName.$ret_setting[0]['q_id'].'" placeholder="'.$ret_setting[0]['q_unit'].'" />';
    break;
   case 32: //複数選択チェックボックスとその他記述
    foreach($q_select as $no=>$val) {
$html .= '	<label class="checkbox-inline"><input type="checkbox" name="'.$inputName.$ret_setting[0]['q_id'].'[]" value="'.(string)((int)$no+1).'"><small>'.$val.'</small></label>';
    }
$html .= '    <div id="'.$inputName.$ret_setting[0]['q_id'].'_error"></div>';
$html .= '   <input type="text" class="form-control ime-disabled" id="'.$inputName.$ret_setting[0]['q_id'].'" name="'.$inputName.$ret_setting[0]['q_id'].'" placeholder="'.$ret_setting[0]['q_unit'].'" />';
    break;
   case 91: //自由記述一行
$html .= '   <input type="text" class="form-control ime-disabled" id="'.$inputName.$ret_setting[0]['q_id'].'" name="'.$inputName.$ret_setting[0]['q_id'].'" placeholder="'.$ret_setting[0]['q_unit'].'" />';
    break;
   case 99: //自由記述複数行
$html .= '   <textarea class="form-control ime-disabled" id="'.$inputName.$ret_setting[0]['q_id'].'" name="'.$inputName.$ret_setting[0]['q_id'].'" rows="3" placeholder="'.$ret_setting[0]['q_unit'].'" /></textarea>';
    break;
   default:
    break;
  }
$html .= ' </div>';
$html .= '</div>';

  if($rules != "") { //最初のルールじゃなければ
$rules .= ',';
$messages .= ',';
  }

  if(($ret_setting[0]['q_kind'] >= 20) && ($ret_setting[0]['q_kind'] <= 39)) {
$rules .= '"'.$inputName.$ret_setting[0]["q_id"].'[]" :{';
$messages .= '"'.$inputName.$ret_setting[0]["q_id"].'[]" :{';
  }
  else {
$rules .= $inputName.$ret_setting[0]["q_id"].' :{';
$messages .= $inputName.$ret_setting[0]["q_id"].' :{';
  }

  if ( $value['req'] ){
$rules .= ' required: true, ';
   if($ret_setting[0]['q_kind'] == 1) {
$rules .= ' isZero: true, ';
   }
  }

// 0:無し　1:半角数字　2:半角英数字　3:半角英字　4:電話番号　5:メール　6:URL　7:日付　8:独自ルール
  switch($ret_setting[0]['q_check']) {
   case  0: //無し
$messages .= 'required: "必須を入力してください。"';
    if($ret_setting[0]['q_kind'] == 1) {
$messages .= ',isZero: "必須を選択してください。"';
    }
    break;
   case  1: //半角数字
$rules .= ' number: true, ';
$messages .= ' required: "必須を入力してください。"';
$messages .= ',number: "半角数字で入力してください。"';
    break;
   case  2: //半角英数字
$rules .= ' isHalf: true, ';
$messages .= ' required: "必須を入力してください。"';
$messages .= ',isHalf: "半角英数字で入力してください。"';
    break;
   case  3: //半角英字
$rules .= ' isAalpha: true, ';
$messages .= ' required: "必須を入力してください。"';
$messages .= ',isAalpha: "半角英字で入力してください。"';
    break;
   case  4: //電話番号
$rules .= ' isTel: true, ';
$messages .= ' required: "必須を入力してください。"';
$messages .= ',isTel: "電話番号をハイフン付きで入力してください。"';
    break;
   case  5: //メール
$rules .= ' email: true,';
$messages .= ' required: "必須を入力してください。" ';
$messages .= ',email: "メールアドレスのフォーマットで入力してください。"';
    break;
   case  6: //URL
$rules .= ' url: true, ';
$messages .= ' required: "必須を入力してください。"';
$messages .= ',url: "URLのフォーマットで入力してください。"';
    break;
   case  7: //日付
$rules .= ' date: true, ';
$messages .= ' required: "必須を入力してください。"';
$messages .= ',date: "日付を入力してください。"';
    break;
   case  8: //郵便番号
$rules .= ' digits: true, ';
$rules .= ' maxlength: 7, ';
$rules .= ' minlength: 7, ';
$messages .= ' required: "必須を入力してください。"';
$messages .= ',digits: "数字７文字を入力してください。"';
$messages .= ',maxlength: "数字７文字を入力してください。"';
$messages .= ',minlength: "数字７文字を入力してください。"';
    break;
   case 99: //独自ルール

$script .= 'jQuery.validator.addMethod("is'.$ret_setting[0]['q_id'].'", function(value, element) {';
$script .= '  return this.optional( element ) || /'.$ret_setting[0]['q_checkorg'].'/.test( value );';
$script .= '}, "'.$ret_setting[0]['q_checkorgmsg'].'");';

$rules .= ' is'.$ret_setting[0]['q_id'].': true,';
$messages .= ' required: "必須を入力してください。" ';
$messages .= ',is'.$ret_setting[0]['q_id'].': "'.$ret_setting[0]['q_checkorgmsg'].'"';

    break;
   default:
    break;
  }

  if ( $ret_setting[0]["q_minlength"] != 0 ){
$rules .= ' minlength: '.$ret_setting[0]["q_minlength"].', ';
$messages .= ',minlength: "'.$ret_setting[0]["q_minlength"].'文字以上で入力してください。"';
  }
  if ( $ret_setting[0]["q_maxlength"] != 0 ){
$rules .= ' maxlength: '.$ret_setting[0]["q_maxlength"].', ';
$messages .= ',maxlength: "'.$ret_setting[0]["q_maxlength"].'文字以下で入力してください。"';
  }

$rules .= '}';
$messages .= '}';

 } // foreach
 $q_setting->closeDetaBase();

}
else{

 switch($kind) {
  case  INVALID:
   $html.= "無効なアクセスです。<br/>\n";
   break;
  case  COOKIE:
   $html.= "クッキーの設定を許可してください。<br/>\n";
   break;
  case  EXPIRATION:
   $html.= "アンケート期間は".$ret_admin[0]["a_start"].'から'.$ret_admin[0]["a_end"]."まで。<br/>\n";
   break;
  case  SUSPENSION:
   $html.= "このアンケートは停止中です。<br/>\n";
   break;
  case  DELETED:
   $html.= "このアンケートは削除されました。<br/>\n";
   break;
  case  ANSWERED:
   $html.= "このアンケートは回答済みです。<br/>\n";
   break;
  default:
  break;
 }

}

?>
<!DOCTYPE html>
<html lang="ja">
<head>
 <meta charset="UTF-8">
 <title><?php echo $title1 ?></title>
 <meta name="robots" content="noindex,nofollow,noarchive" />
 <meta http-equiv="X-UA-Compatible" content="IE=edge">
 <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

 <link rel="stylesheet" type="text/css" href="css/bootstrap.min.css"/>
 <link href="css/style.css" rel="stylesheet">
</head>
<body>
 <div class="content">
  <header style="background-color:white">
   <div class="container-fluid">
    <div class="row">
     <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
     <div class="col-sm-12 col-md-10" style="background-color:white;">
      <div class="pull-left">
       <h2><?php echo $title1 ?></h2>
       <small><?php echo "アンケート期間は".$ret_admin[0]["a_start"].'から'.$ret_admin[0]["a_end"]."まで。" ?></small>
      </div>
     </div>
     <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
    </div>
   </div>
  </header>

  <div class="container-fluid">
   <div class="row">
    <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
    <div class="col-sm-12 col-md-10" style="background-color:white;">
     <legend><?php echo $title2 ?></legend>
    </div>
    <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
   </div>
  </div>

  <div class="container-fluid">
   <div class="row">
    <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
    <div class="col-sm-12 col-md-10" style="background-color:white;">
     <form class="form-horizontal" id="myform">

<?php echo $html; ?>

     </form>
    </div>
    <div class="col-sm-0 col-md-1" style="background-color:white;"></div>
   </div>
  </div>

<?php if ($init_success): ?>
  <div style="height:60px">
   <hr>
   <div class="center-block text-center">
    <button id="checkButton" type="button" class="btn btn-primary">次へ</button>
   </div>
  </div>
<?php endif; ?>
  <br>

  <div id="form" class="modal fade" tabindex="-1">
   <div class="modal-dialog modal-dialog-centered ">
    <div class="modal-content">
     <div class="modal-header">
      <h4 id="dialogTitle" class="modal-title">入力内容確認</h4>
      <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
     </div> <!--modal-header-->
     <div class="modal-body">
      <div class="container-fluid">
       <div class="row">
        <div class="col-lg-12">
         <form class="form-horizontal" id="sample-form">

<?php echo $form; ?>

         </form>
        </div> <!--col-lg-12-->
       </div> <!--row-->
      </div> <!--container-fluid-->
     </div> <!--modal-body-->
     <div class="modal-footer">
      <button id="sendRegistButton" type="button" class="btn btn-primary"><i class="fa fa-check"></i>送信</button>
      <button type="button" class="btn btn-default" data-dismiss="modal"><i class="fa fa-remove"></i>戻る</button>
     </div> <!--modal-footer-->
    </div> <!--modal-content-->
   </div> <!--modal-dialog modal-dialog-centered-->
  </div> <!--form-->
  </br>
 </div> <!--content-->

 <?php include 'inc/footer.php'; ?> <!-- フッター共通部 -->

</body>
 <script type="text/javascript" src="js/jquery-3.5.1.js"></script>
 <script type="text/javascript" src="js/bootstrap.min.js"></script>
 <script type="text/javascript" src="js/jquery.validate.js"></script>
 <script type="text/javascript" src="js/validate-ja.js"></script>
 <script type="text/javascript">
var sendData= new Array();
$(document).ready( function () {

 jQuery.validator.addMethod("isTel", function(value, element) {
  return this.optional( element ) || /\d{2,4}-\d{3,4}-\d{3,4}/.test( value );
 }, "ハイフンを含む数字を入力してください。");

 jQuery.validator.addMethod("isMail", function(value, element) {
  return this.optional( element ) || /^[a-zA-Z]{1}[0-9a-zA-Z]+[\w\.-]+@[\w\.-]+\.\w{2,}$/.test( value );
 }, "メールアドレスを正しく入力してください。");

 jQuery.validator.addMethod("isHalf", function(value, element) {
  return this.optional( element ) || /^[0-9A-Za-z]+$/.test( value );
 }, "半角英数字で入力してください。");

 jQuery.validator.addMethod("isAalpha", function(value, element) {
  return this.optional( element ) || /[A-Za-z]{8}/.test( value );
 }, "半角英字で入力してください。");

 jQuery.validator.addMethod("isZero", function(value, element) {
  // お決まりの定型文
  // 検証対象の要素にこのルールが設定されているか
  if ( this.optional( element ) ) {
   return true;
  }
  if (value == 0) {
   return false;
  }
  return true;
 }, "必須を選択してください。");

<?php echo $script; ?>

 $('#myform').validate({
  rules: {
<?php echo $rules; ?>
  },
  messages: {
<?php echo $messages; ?>
  },
  errorElement: "em",
  errorPlacement: function ( error, element ) {
   error.addClass( "help-block" );
   element.parents( ".col-sm-8" ).addClass( "has-feedback" );
   if (( element.prop( "type" ) === "checkbox" ) ||
    ( element.prop( "type" ) === "radio" )) {
    var _error = "#"+element[0].name.replace('[]', '')+'_error';
    error.insertAfter( _error );
   } else {
    error.insertAfter( element );
   }
   if ( !element.next( "span" )[ 0 ] ) {
   }
  },
  success: function ( label, element ) {
   if ( !$( element ).next( "span" )[ 0 ] ) {
   }
  },
  highlight: function ( element, errorClass, validClass ) {
   $( element ).parents( ".col-sm-8" ).addClass( "has-error" ).removeClass( "has-success" );
  },
  unhighlight: function (element, errorClass, validClass) {
   $( element ).parents( ".col-sm-8" ).addClass( "has-success" ).removeClass( "has-error" );
  }
  ,focusInvalid: false,
  invalidHandler: function(form, validator) {
   var errors = validator.numberOfInvalids();
   if (errors) {
    /* 最初のエラーにスクロール */
    $('html, body').animate({
     scrollTop: $(validator.errorList[0].element).offset().top-100
     }, 500);
   }
  } 
 }); 

 $("input:checkbox").attr("checked",false);
}); 

$("#checkButton").on("click", function(){

 if($('#myform').valid()) {
  // バリデーションOKの処理
  sendData= new Array();
<?php

echo 'var data= null;'."\n";
echo 'var otherStr = ""'."\n";
echo 'var ids= [];'."\n";
echo 'var labels= [];'."\n";

foreach ($formData as $key => $value){
  // 取得したデータのセット
echo 'data= null;'."\n";
echo 'otherStr = ""'."\n";
echo 'ids= [];'."\n";
echo 'labels= [];'."\n";

 switch($value["kind"]) {
  case  1: //単一選択ドロップダウン
echo 'var str1 = $("#'.$inputName.$key.' option:selected").text();';
echo 'if($("#'.$inputName.$key.'").val() == 0) {'."\n";
echo 'str1 = "無回答";'."\n";
echo '}'."\n";

echo '$("#'.$outputName.$key.'").text(str1);'."\n";
echo '	ids.push($("#'.$inputName.$key.'").val());';
echo '	labels.push(str1);';
   break;
  case 21: //単一選択ラジオボタン
echo 'var str21 = ""'."\n";
echo 'if($("input:radio[name='."'".$inputName.$key."[]']:checked".'").length > 0) {'."\n";
echo 'str21 = $("input:radio[name='."'".$inputName.$key."[]']:checked".'")[0].parentNode.textContent;';

echo '$("#'.$outputName.$key.'").text(str21);'."\n";
echo '	ids.push($("input:radio[name='."'".$inputName.$key."[]']:checked".'").val());';

echo '}'."\n";
echo 'else{'."\n";
echo 'str21 = "無回答" ;';
echo '$("#'.$outputName.$key.'").text(str21);'."\n";
echo '	ids.push("0");'."\n";
echo '}'."\n";
echo '	labels.push(str21);'."\n";

   break;

  case 22: //単一選択ラジオボタンとその他記述
echo 'var str22 = ""'."\n";
echo 'var other22 = false;';
echo 'if($("input:radio[name='."'".$inputName.$key."[]']:checked".'").length > 0) {'."\n";
echo 'str22 = $("input:radio[name='."'".$inputName.$key."[]']:checked".'")[0].parentNode.textContent;';
echo ' ids.push($("input:radio[name='."'".$inputName.$key."[]']:checked".'").val());';

echo 'if(str22 == "その他") {'."\n";
echo 'other22 = true;';
echo '}'."\n";
echo '}'."\n";
echo 'else{'."\n";
echo ' str22 = "無回答" ;';
echo ' ids.push("0");'."\n";
echo '}'."\n";

echo 'var otherStr = ""'."\n";
echo 'if(other22) {'."\n";
echo 'otherStr = $("#'.$inputName.$key.'").val().substr( 0, 20 );'."\n";
echo '$("#'.$outputName.$key.'").text(str22+"("+otherStr+")");'."\n";
echo '}'."\n";
echo 'else {'."\n";
echo '$("#'.$outputName.$key.'").text(str22);'."\n";
echo '}'."\n";

echo '	labels.push(str22);';

   break;
  case 31: //複数選択チェックボックス
echo 'var str31 = [];';
echo 'str31.length = 0;';

echo 'if($("input:checkbox[name='."'".$inputName.$key."[]']:checked".'").length > 0) {'."\n";

echo '$("input:checkbox[name='."'".$inputName.$key."[]']:checked".'").each(function() {';
echo '	str31.push($(this)[0].parentNode.textContent);';
echo '	ids.push($(this)[0].value);';
echo '	labels.push($(this)[0].parentNode.textContent);';

echo '});';

echo '}'."\n";
echo 'else{'."\n";
echo ' str31 = "無回答" ;';
echo ' ids.push("0");'."\n";
echo '	labels.push(str31);';
echo '}'."\n";

echo '$("#'.$outputName.$key.'").text(str31);'."\n";

   break;

  case 32: //複数選択チェックボックスとその他記述
echo 'var other32 = false;';
echo 'var str32 = [];';
echo 'str32.length = 0;';

echo 'if($("input:checkbox[name='."'".$inputName.$key."[]']:checked".'").length > 0) {'."\n";
echo '$("input:checkbox[name='."'".$inputName.$key."[]']:checked".'").each(function() {';
echo '	str32.push($(this)[0].parentNode.textContent);';
echo 'if($(this).length > 0) {'."\n";
echo 'if($(this)[0].parentNode.textContent == "その他") {'."\n";
echo 'other32 = true;';
echo '}'."\n";
echo '}'."\n";
echo '	ids.push($(this)[0].value);';
echo '	labels.push($(this)[0].parentNode.textContent);';

echo '});';

echo '}'."\n";
echo 'else{'."\n";
echo ' str32 = "無回答" ;';
echo ' ids.push("0");'."\n";
echo '	labels.push(str32);';
echo '}'."\n";

echo 'var otherStr = ""'."\n";
echo 'if(other32) {'."\n";
echo 'otherStr = $("#'.$inputName.$key.'").val().substr( 0, 20 );'."\n";
echo '$("#'.$outputName.$key.'").text(str32+"("+otherStr+")");'."\n";
echo '}'."\n";
echo 'else {'."\n";
echo '$("#'.$outputName.$key.'").text(str32);'."\n";
echo '}'."\n";

   break;
  case 91: //自由記述一行
  case 99: //自由記述複数行
echo '$("#'.$outputName.$key.'").text($("#'.$inputName.$key.'").val());'."\n";
echo 'otherStr = $("#'.$inputName.$key.'").val();'."\n";
   break;
 }

echo 'qiddata= {'."\n";
echo 'kind:'.$value["kind"].','."\n";
echo 'sid:ids,'."\n";
echo 'slabel:labels,'."\n";
echo 'other:otherStr'."\n";
echo '};'."\n";

echo 'data= {'."\n";
echo '"'.$key.'":qiddata'."\n";
echo '};'."\n";
echo 'sendData.push(data);'."\n";

}
?>

 } else {
  // バリデーションNGの処理
  var param = {};
  param['cid'] = <?php echo '"'.$cookieData.'"'; ?>;
  param['gid'] = <?php echo '"'.$gid.'"'; ?>;
  param['aid'] = <?php echo '"'.$aid.'"'; ?>;
  param['rid'] = <?php echo '"'.$rid.'"'; ?>;

  $.ajax({
   url: "./api/log_update.php",
   type: "POST",
   data: param,
   success: function(jsonResponse) {
    var data = JSON.parse(jsonResponse);
    if(data.result == 'error') {
     //更新エラー
     window.location.href= "index.html?result="+data.result+"&errorCode="+data.errorcode+"&message="+data.message;
     return;
    }
   },
   error: function() {
    //送信エラー
    window.location.href= "index.html?result=error&errorCode=9901&message=送信エラー";
    return;
   }
  });
  return;
 }

 $('#form').on('show.bs.modal', function (event) {
  // コントロール制御
  $("#form #dialogTitle").text("入力内容確認");
  $("#form #sendRegistButton").show();
 }).modal({backdrop: 'static', keyboard: true, show: true});
});

$("#sendRegistButton").on("click", function(){
 // 回答送信処理
 var param = {};
 param['cid'] = <?php echo '"'.$cookieData.'"'; ?>;
 param['gid'] = <?php echo '"'.$gid.'"'; ?>;
 param['aid'] = <?php echo '"'.$aid.'"'; ?>;
 param['rid'] = <?php echo '"'.$rid.'"'; ?>;
 param['answer'] = sendData;

 $.ajax({
  url: "./api/answer.php",
  type: "POST",
  data: param,
  success: function(jsonResponse) {
   var data = JSON.parse(jsonResponse);
   if(data.result == 'error') {
    //更新エラー
    window.location.href= "index.html?result="+data.result+"&errorCode="+data.errorcode+"&message="+data.message;
    return;
   }
   //更新成功
   window.location.href= "index.html?result="+data.result;
  },
  error: function() {
   //送信エラー
   window.location.href= "index.html?result=error&errorCode=9901&message=送信エラー";
   return;
  }
 });

});

 </script>
</html>
