<?php
// 表示メッセージ
$message = "";

$init_success = true;

//環境定義configファイルチェック
if (file_exists(dirname(__FILE__).'/config.php')) {
 require_once (dirname(__FILE__).'/config.php');
}
else {
 if($init_success) {
  $message .= '<h2><font color="red">初期化失敗</font></h2>';
 }
 $message .= '<p>config.phpが見つかりません。</p>';
 $init_success = false;
}

//環境定義settingファイルチェック
if (file_exists(L_BASE.'/setting.php')) {
 require_once (L_BASE.'/setting.php');
}
else {
 if($init_success) {
  $message .= '<h2><font color="red">初期化失敗</font></h2>';
 }
 $message .= '<p>setting.phpが見つかりません。</p>';
 $init_success = false;
}

//アプリインストールチェック
if (!file_exists('.'.A_BASE.'/login.php')) {
 if($init_success) {
  $message .= '<h2><font color="red">初期化失敗</font></h2>';
 }
 $message .= '<p>管理用アプリケーションが正常にインストールされていません。</p>';
 $init_success = false;
}

//アンケートインストールチェック
if (!file_exists('.'.Q_BASE.'/index.php')) {
 if($init_success) {
  $message .= '<h2><font color="red">初期化失敗</font></h2>';
 }
 $message .= '<p>アンケート用アプリケーションが正常にインストールされていません。</p>';
 $init_success = false;
}

//ライブラリインストールチェック
if (!file_exists(L_BASE.'/db/dbconfig.php')) {
 if($init_success) {
  $message .= '<h2><font color="red">初期化失敗</font></h2>';
 }
 $message .= '<p>dbconfig.phpが見つかりません。</p>';
 $init_success = false;
}

if($init_success){ // init_success1

 //稼働モード時の動作を設定
 switch (DEBUG_LEVEL) {
  case '1': // テストモード
   ini_set('display_errors', 'Off');  //エラー表示をOFF
   ini_set('log_errors', 'On'); //エラーログをON
   error_log("[". date('Y-m-d H:i:s') . "]".$_SERVER['PHP_SELF']."\n","3","./debug.log");
   break;

  case '2': // 開発モード
   ini_set('display_errors', 'On');  //エラー表示をON
   ini_set('log_errors', 'On'); //エラーログをON
   error_log("[". date('Y-m-d H:i:s') . "]".$_SERVER['PHP_SELF']."\n","3","./debug.log");
   break;

  default: // 0: 本番モード
   ini_set('display_errors', 'Off');  //エラー表示をOFF
   ini_set('log_errors', 'Off'); //エラーログをON
   break;
 }

 //セッション名を指定
 session_name(SESSION_NAME);
 //セッション開始
 session_start();

 //セッションIDを初期化
 $cookie_session_id = session_id();

 //セッションIDを変更（セッションハイジャック対策）
 session_regenerate_id(TRUE); 

 //----------------------------------------------------------
 // 初期化処理 OKの場合は強制的にログインページにリダイレクト
 //----------------------------------------------------------
 $init_success = false;

 //データベース関数のファイルの読み込み
 require (L_BASE.'/db/meibo.php');
 require (L_BASE.'/db/gekijo.php');
 require (L_BASE.'/db/q_admin.php');
 require (L_BASE.'/db/q_setting.php');
 require (L_BASE.'/db/accesslog.php');

 // DB接続確認
 // エラーの内容はpdoDb.class.phpで出力
 try {
  $meibo = new meiboDb();
  $init_success = true;
 }catch(ErrorException $ex){
  print('ErrorException:' . $ex->getMessage());
  $message .= 'DB接続失敗</br>'.'ErrorException:' . $ex->getMessage();
 }catch(PDOException $ex){
  print('PDOException:DB接続失敗' . $ex->getMessage());
  $message .= 'DB接続失敗</br>'.'PDOException:' . $ex->getMessage();
 }

 // DB接続OK
 if($init_success){ // init_success2
  $init_success = false;
  // テーブルなしならテーブル作成
  try {
   $gekijo = new gekijoDb();
   $gekijo->createGekijotbl(); // TBL_GEKIJO作成
   $gekijo->closeDetaBase();

   $q_setting = new q_settingDb();
   $q_setting->createQsettingtbl(); // TBL_QUESTION作成
   $q_setting->createQgrouptbl(); // TBL_QUESTION_GROUP作成
   $q_setting->closeDetaBase();

   $q_admin = new q_adminDb();
   $q_admin->createAadmintbl(); // TBL_QUESTIONNAIRE作成
   $q_admin->createAnswertbl(); // TBL_ANSWER作成
   $q_admin->closeDetaBase();

   $accesslog = new accesslogDb();
   $accesslog->createAccessLogtbl(); // TBL_ACCESSLOG作成
   $accesslog->createInvalidLogtbl(); // TBL_INVALIDLOG作成
   $accesslog->closeDetaBase();

   $meibo->createMeibotbl(); // TBL_USERテーブル作成

   // 初期アカウントなければ作成
   $ret = $meibo->selectMeibo(AD_USER);
   if (!isset($ret[0]) || empty($ret[0]) || (count($ret) == 0)) {
    $ret = $meibo->insertAdminUser($cookie_session_id);
   }
   $meibo->closeDetaBase();

   // ログインページへ
   header("Location: ".A_URL, true , 302);
   exit();
  }catch(ErrorException $ex){
   print('ErrorException:' . $ex->getMessage());
   $message .= '初期化失敗</br>'.'ErrorException:' . $ex->getMessage();
  }catch(PDOException $ex){
   print('PDOException:' . $ex->getMessage());
   $message .= '初期化失敗</br>'.'PDOException:' . $ex->getMessage();
  }
 } // init_success2
} // init_success1

?>

<!DOCTYPE html>
<html lang="ja">
<head>
 <meta charset="UTF-8">
 <title><?php echo P_TITLE;?></title>
 <meta http-equiv="X-UA-Compatible" content="IE=edge">
 <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
 <meta name="robots" content="none">
</head>
<body>
 <h2>当WEBサイトは準備中です。</h2>
 <p><?php echo $message;?></p>
</body>
</html>