<?php
/*
 * ：ユーザーを管理するクラス
 * @親クラス  ：  ・pdodb
 */
require_once (dirname(__FILE__).'/pdoDb.class.php');
require_once (dirname(__FILE__).'/../setting.php');
require_once (dirname(__FILE__).'/dbconfig.php');

class meiboDb extends pdodb
{

 /*
  * @selectMeibo2（TBL_USERテーブルのデータを抽出する）
  * @引数：parm1　ユーザー種別
  * @引数：parm2  アカウント状態
  * @引数：parm3　劇場ID
  * @引数：parm4　管理権限
  * @返値：抽出データ
  */

 public function selectMeibo2($parm1, $parm2, $parm3 = null, $parm4 = null)
 {
  //ＳＱＬ設定
  $sql = '';
  $sql .= 'SELECT id ';
  $sql .= ', user_id ';
  $sql .= ', password ';
  $sql .= ', kind ';
  $sql .= ', authority ';
  $sql .= ', existence ';
  $sql .= ', error_cnt ';
  $sql .= ', gekijo_id ';
  $sql .= ', comment ';
  $sql .= ', creation_dt ';
  $sql .= ', creation_user ';
  $sql .= ', modification_dt ';
  $sql .= ', modification_user ';
  $sql .= ', login_dt ';
  $sql .= ', session_id ';
  $sql .= ', session_expiration ';
  $sql .= 'FROM '.TBL_USER.' ';
  $sql .= "WHERE kind >= :kind ";
  $sql .= ' AND existence <= :existence ';

  $params = array(
   'kind' => $parm1 ,
   'existence' => $parm2
  );

  //パラメータの有無を判断（あればパラメータをバインド変数として実行）
  if ( ($parm3 != "") &&  ($parm3 != null) && !empty( $parm3 ) ){
   $sql .= "AND gekijo_id = :gekijo_id ";
   $params += array(
    'gekijo_id' => $parm3
   );
  }
  //パラメータの有無を判断（あればパラメータをバインド変数として実行）
  if ( ($parm4 != "") &&  ($parm4 != null) && !empty( $parm4 ) ){
   if($parm1 != 0) {
    $sql .= "AND authority >= :authority ";
    $params += array(
    'authority' => 1
    );
   }
  }
  $sql .= 'ORDER BY kind desc, authority asc ';

  //ＳＱＬを実行及び返値をこのメソッドの返値として設定
  $stmt = parent::execute($sql, $params);
  $ret = $stmt->fetchAll();
  return $ret;
 }


 /*
  * @selectMeibo（TBL_USERテーブルのデータを抽出する）
  * @引数：parm　ユーザーID
  * @返値：抽出データ
  */

 public function selectMeibo($parm = null)
 {

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'SELECT id ';
  $sql .= ', user_id ';
  $sql .= ', password ';
  $sql .= ', kind ';
  $sql .= ', authority ';
  $sql .= ', existence ';
  $sql .= ', error_cnt ';
  $sql .= ', gekijo_id ';
  $sql .= ', comment ';
  $sql .= ', creation_dt ';
  $sql .= ', creation_user ';
  $sql .= ', modification_dt ';
  $sql .= ', modification_user ';
  $sql .= ', login_dt ';
  $sql .= ', session_id ';
  $sql .= ', session_expiration ';
  $sql .= 'FROM '.TBL_USER.' ';

  //パラメータの有無を判断（あればパラメータをバインド変数として実行）
  if ( $parm != null && !empty( $parm ) ){
   $sql .= "WHERE  user_id = :user_id";
   $params = array(
   'user_id' => $parm
   );
   $stmt = parent::execute($sql, $params);
  }
  else {
   $sql .= 'ORDER BY kind desc, authority asc ';
   $stmt = parent::execute($sql);
  }

  //ＳＱＬを実行及び返値をこのメソッドの返値として設定
  $ret = $stmt->fetchAll();
  return $ret;
 }


 /*
  * @selectSession（TBL_USERテーブルのデータを抽出する）
  * @引数：parm　セッションID
  * @返値：抽出データ
  */

 public function selectSession($parm = null)
 {
  //現在時間
  $mysqltime = date ("Y-m-d H:i:s",strtotime("now"));

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'SELECT id ';
  $sql .= ', user_id ';
  $sql .= ', password ';
  $sql .= ', kind ';
  $sql .= ', authority ';
  $sql .= ', existence ';
  $sql .= ', error_cnt ';
  $sql .= ', gekijo_id ';
  $sql .= ', comment ';
  $sql .= ', creation_dt ';
  $sql .= ', creation_user ';
  $sql .= ', modification_dt ';
  $sql .= ', modification_user ';
  $sql .= ', login_dt ';
  $sql .= ', session_id ';
  $sql .= ', session_expiration ';
  $sql .= 'FROM '.TBL_USER.' ';

  //パラメータの有無を判断（あればパラメータをバインド変数として実行）
  if ( $parm != null && !empty( $parm ) )
  {
   $sql .= "WHERE  session_id = :session_id AND session_expiration > :mysqltime" ;
   $params = array(
   'session_id' => $parm,
   'mysqltime' => $mysqltime
   );
   $stmt = parent::execute($sql, $params);
  }
  else {
   $stmt = parent::execute($sql);
  }

  //ＳＱＬを実行及び返値をこのメソッドの返値として設定
  $ret = $stmt->fetchAll();
  return $ret;
 }


 /*
  * @insertUser（TBL_USERテーブルにデータを追加する）
  * @引数：user_id　ユーザーID 他
  * @返値：実行結果
  */

 public function insertUser($user_id, $password, $kind, $authority, $existence, $error_cnt, $gekijo_id, $comment, $creation_user, $session_id)
 {
  //セッション有効期限
  $mysqltime = date ("Y-m-d H:i:s",strtotime(LOGIN_EXPIRATION));

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'INSERT INTO '.TBL_USER.' ';
  $sql .= "( ";
  $sql .= ' user_id ';
  $sql .= ', password ';
  $sql .= ', kind ';
  $sql .= ', authority ';
  $sql .= ', existence ';
  $sql .= ', error_cnt ';
  $sql .= ', gekijo_id ';
  $sql .= ', comment ';
  $sql .= ', creation_user ';
  $sql .= ', session_id ';
  $sql .= ", session_expiration ";
  $sql .= ") ";
  $sql .= "VALUES ";
  $sql .= "( ";
  $sql .= ":user_id ";
  $sql .= ",:password ";
  $sql .= ",:kind ";
  $sql .= ",:authority ";
  $sql .= ",:existence ";
  $sql .= ",:error_cnt ";
  $sql .= ",:gekijo_id ";
  $sql .= ",:comment ";
  $sql .= ",:creation_user ";
  $sql .= ",:session_id ";
  $sql .= ",:session_expiration ";
  $sql .= ") ";

  $params = array(
   "user_id" => $user_id,  //新しいログインユーザーID
   "password" => $password,  //ログインパスワード
   "kind" => $kind,  //ユーザー種別　0:システム管理者（メンテ用）　1:管理者　2:劇場管理者
   "authority" => $authority,  //管理権限　0:閲覧のみ  1:すべて　2:追加更新　3:追加のみ
   "existence" => $existence,  //アカウント状態　0:有効  1:停止　2:削除
   "error_cnt" => $error_cnt,  //ログインエラー回数
   "gekijo_id" => $gekijo_id,  //劇場ID　kind=3 の管理する劇場
   "comment" => $comment,  //自由記述コメント
   "creation_user" => $creation_user,  //作成者
   "session_id" => $session_id,  //新しいセッションID
   "session_expiration" => $mysqltime //有効期限
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @insertAdminUser（TBL_USERテーブルにシステム管理者を追加する）
  * @引数：session_id　セッションID
  * @返値：実行結果
  */

 public function insertAdminUser($session_id)
 {
  //セッション有効期限
  $mysqltime = date ("Y-m-d H:i:s",strtotime(LOGIN_EXPIRATION));

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'INSERT INTO '.TBL_USER.' ';
  $sql .= "( ";
  $sql .= ' user_id ';
  $sql .= ', password ';
  $sql .= ', kind ';
  $sql .= ', authority ';
  $sql .= ', existence ';
  $sql .= ', error_cnt ';
  $sql .= ', gekijo_id ';
  $sql .= ', comment ';
  $sql .= ', creation_user ';
  $sql .= ', session_id ';
  $sql .= ", session_expiration ";
  $sql .= ") ";
  $sql .= "VALUES ";
  $sql .= "( ";
  $sql .= ":user_id ";
  $sql .= ",:password ";
  $sql .= ",:kind ";
  $sql .= ",:authority ";
  $sql .= ",:existence ";
  $sql .= ",:error_cnt ";
  $sql .= ",:gekijo_id ";
  $sql .= ",:comment ";
  $sql .= ",:creation_user ";
  $sql .= ",:session_id ";
  $sql .= ",:session_expiration ";
  $sql .= ") ";

  $params = array(
   "user_id" => AD_USER,  //新しいログインユーザーID
   "password" => password_hash(AD_PASSWORD, PASSWORD_DEFAULT),  //ログインパスワード
   "kind" => 0,  //ユーザー種別　0:システム管理者（メンテ用）　1:管理者　2:劇場管理者
   "authority" => 0,   //管理権限　0:すべて　1:追加更新　2:追加のみ　3:閲覧のみ
   "existence" => 0,  //アカウント状態　0:有効  1:停止　2:削除
   "error_cnt" => 0,  //ログインエラー回数
   "gekijo_id" => "Sys1",  //劇場ID　kind=3 の管理する劇場
   "comment" => "システム管理者",  //自由記述コメント
   "creation_user" => AD_USER,  //作成者
   "session_id" => $session_id,  //新しいセッションID
   "session_expiration" => $mysqltime //有効期限
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @updateUser（TBL_USERテーブルのデータを更新する）
  * @引数：user_id　ユーザーID 他
  * @返値：実行結果
  */

 public function updateUser($user_id, $password, $kind, $authority, $existence, $error_cnt, $gekijo_id, $comment, $modification_user, $session_id)
 {
  //セッション有効期限
  $mynowtime = date ("Y-m-d H:i:s");
  $mysqltime = date ("Y-m-d H:i:s",strtotime(LOGIN_EXPIRATION));

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'UPDATE '.TBL_USER.' SET ';
  $sql .= "user_id = :user_id";
  $sql .= ", password = :password";
  $sql .= ", kind = :kind";
  $sql .= ", authority = :authority";
  $sql .= ", existence = :existence";
  $sql .= ", error_cnt = :error_cnt";
  $sql .= ", gekijo_id = :gekijo_id";
  $sql .= ", comment = :comment";
  $sql .= ", modification_dt = :modification_dt";
  $sql .= ", modification_user = :modification_user";
  $sql .= ", session_id = :session_id";
  $sql .= ", session_expiration = :session_expiration";
  $sql .= " WHERE user_id = :user_id";

  $params = array(
   "user_id" => $user_id,
   "password" => $password,
   "kind" => $kind,
   "authority" => $authority,
   "existence" => $existence,
   "error_cnt" => $error_cnt,
   "gekijo_id" => $gekijo_id,
   "comment" => $comment,
   "modification_dt" => $mynowtime, //最終更新日
   "modification_user" => $modification_user, //最終更新者
   "session_id" => $session_id,  // 新しいセッションID
   "session_expiration" => $mysqltime, // 有効期限時間
   "user_id" => $user_id
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @updateSession（TBL_USERテーブルのセッションIDを更新する）
  * @引数：session_id　セッションID
  * @引数：user_id　ユーザーID
  * @返値：実行結果
  */

 public function updateSession($session_id, $user_id)
 {
  //セッション有効期限
  $mysqltime = date ("Y-m-d H:i:s",strtotime(LOGIN_EXPIRATION));

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'UPDATE '.TBL_USER.' SET ';
  $sql .= "session_id = :session_id";
  $sql .= ", session_expiration = :session_expiration";
  $sql .= ", error_cnt = :error_cnt";
  $sql .= " WHERE user_id = :user_id";
  $params = array(
   "session_id" => $session_id,  // 新しいセッションID
   "session_expiration" => $mysqltime, // 有効期限時間
   "error_cnt" => 0,  // エラーカウントクリア
   "user_id" => $user_id
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @updateError（TBL_USERテーブルのログインエラー回数を更新する）
  * @引数：user_id　ユーザーID
  * @返値：実行結果
  */

 public function updateError($user_id)
 {
  //ＳＱＬ設定
  $sql = '';
  $sql .= 'UPDATE '.TBL_USER.' SET ';
  $sql .= "error_cnt = error_cnt + 1 ";
  $sql .= " WHERE user_id = :user_id";
  $params = array(
  "user_id" => $user_id
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @updateExistence（TBL_USERテーブルのアカウント状態を更新する）
  * @引数：user_id　ユーザーID
  * @引数：existence　アカウント状態
  * @返値：実行結果
  */

 public function updateExistence($user_id, $existence)
 {

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'UPDATE '.TBL_USER.' SET ';
  $sql .= " existence = :existence ";
  $sql .= " WHERE user_id = :user_id";
  $params = array(
   "existence" => $existence,
   "user_id" => $user_id
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @deleteUser（TBL_USERテーブルのユーザーを削除する）
  * @引数：user_id　ユーザーID
  * @返値：実行結果
  */

 public function deleteUser($user_id)
 {
  //ＳＱＬ設定
  $sql = '';
  $sql .= 'DELETE FROM '.TBL_USER.' ';
  $sql .= " WHERE user_id = :user_id";

  $params = array(
   "user_id" => $user_id
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @deleteGekijoUser（TBL_USERテーブルのユーザーを所属先を指定して削除する）
  * @引数：gekijo_id　劇場ID
  * @返値：実行結果
  */
 public function deleteGekijoUser($gekijo_id)
 {
  //ＳＱＬ設定
  $sql = '';
  $sql .= 'DELETE FROM '.TBL_USER.' ';
  $sql .= " WHERE gekijo_id = :gekijo_id";

  $params = array(
   "gekijo_id" => $gekijo_id
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @createMeibotbl（TBL_USERテーブルを作成する）
  * @引数：なし
  * @返値：実行結果
  */
 public function createMeibotbl( $sql = null )
 {

  $sql = "";
  $sql .= "create table IF NOT EXISTS ".TBL_USER." ";
  $sql .= "( ";
  $sql .= " id INT NOT NULL AUTO_INCREMENT primary key"; //ID
  $sql .= ", user_id varchar(150) unique not null default ''"; //ログインユーザーID
  $sql .= ", password varchar(150) not null default ''"; //ログインパスワード
  $sql .= ", kind int default 0"; //ユーザー種別　0:システム管理者（メンテ用）　1:管理者　2:劇場管理者
  $sql .= ", authority int default 0"; //管理権限　0:すべて　1:追加更新　2:追加のみ　3:閲覧のみ
  $sql .= ", existence int default 0"; //アカウント状態　0:有効  1:停止　2:削除
  $sql .= ", error_cnt int default 0"; //ログインエラー回数
  $sql .= ", gekijo_id varchar(150) default null"; //劇場ID　kind=3 の管理する劇場
  $sql .= ", comment varchar(150) default null"; //自由記述コメント
  // 自動更新エリア
  $sql .= ", creation_dt datetime NOT NULL DEFAULT CURRENT_TIMESTAMP"; //作成日
  $sql .= ", creation_user varchar(150) default null"; //作成者
  $sql .= ", modification_dt datetime not null default 0"; //最終更新日
  $sql .= ", modification_user varchar(150) default null"; //最終更新者
  $sql .= ", login_dt datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"; //最終ログイン日時
  $sql .= ", session_id varchar(150) unique"; //セッションID
  $sql .= ", session_expiration datetime not null default 0"; //セッションの有効期限
  $sql .= ")  ENGINE=InnoDB DEFAULT CHARSET=utf8;";
  //ＳＱＬを実行
  $id = parent::runSql( $sql );
  //最後に操作したデータのIDを返す
  return $id;
 }


}

?>