<?php
/*
 * ：アンケートを管理するクラス
 * @親クラス  ：  ・pdodb
 */
require_once (dirname(__FILE__).'/pdoDb.class.php');
require_once (dirname(__FILE__).'/../setting.php');
require_once (dirname(__FILE__).'/dbconfig.php');

class q_adminDb extends pdodb
{

 /*
  * @selectAadmin（TBL_QUESTIONNAIREテーブルのデータを抽出する）
  * @引数：parm1　劇場ID
  * @引数：parm2  データID
  * @返値：抽出データ
  */

 public function selectAadmin($parm1 = null, $parm2 = null)
 {

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'SELECT * ';
  $sql .= 'FROM '.TBL_QUESTIONNAIRE.' ';

  //パラメータの有無を判断（あればパラメータをバインド変数として実行）
  if ( $parm2 != null && !empty( $parm2 ) ){
   $sql .= "WHERE  id = :id";
   $params = array(
   'id' => $parm2
   );
   $stmt = parent::execute($sql, $params);
  }
  else if ( ($parm1 != "") &&  ($parm1 != null) && !empty( $parm1 ) ){
   $sql .= "WHERE gekijo_id = :gekijo_id ";
   $params = array(
    'gekijo_id' => $parm1
    );
   $stmt = parent::execute($sql, $params);
  }
  else {
   $stmt = parent::execute($sql);
  }

  //ＳＱＬを実行及び返値をこのメソッドの返値として設定
  $ret = $stmt->fetchAll();
  return $ret;
 }


 /*
  * @selectAadmin2（TBL_QUESTIONNAIREテーブルのデータを抽出する）
  * @引数：gid　劇場ID
  * @引数：aid  アンケートID
  * @返値：抽出データ
  */

 public function selectAadmin2($gid, $aid)
 {

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'SELECT * ';
  $sql .= 'FROM '.TBL_QUESTIONNAIRE.' ';
  $sql .= "WHERE  gekijo_id = :gekijo_id AND a_id = :aid ";

  $params = array(
   'gekijo_id' => $gid,
   'aid' => $aid
  );

  $stmt = parent::execute($sql, $params);

  //ＳＱＬを実行及び返値をこのメソッドの返値として設定
  $ret = $stmt->fetchAll();
  return $ret;
 }


 /*
  * @selectAadmin3（TBL_QUESTIONNAIREテーブルのデータを抽出する）
  * @引数：gid　劇場ID
  * @引数：aid  アンケートID
  * @引数：qid  設問ID
  * @返値：抽出データ
  */

 public function selectAadmin3($gid, $aid, $qid)
 {

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'SELECT * ';
  $sql .= 'FROM '.TBL_QUESTIONNAIRE.' ';
  $sql .= "WHERE  gekijo_id = :gekijo_id ";
  $sql .= " AND JSON_CONTAINS(a_qid,'{".'"qid":"'.$qid.'"}'."') ";
  $sql .= 'ORDER BY a_id = :aid DESC ,a_start DESC ,creation_dt DESC ';
  $sql .= 'LIMIT 10 ';

  $params = array(
  'gekijo_id' => $gid,
  'aid' => $aid
  );

  $stmt = parent::execute($sql, $params);

  //ＳＱＬを実行及び返値をこのメソッドの返値として設定
  $ret = $stmt->fetchAll();
  return $ret;
 }


 /*
  * @selectAnswer（TBL_ANSWERテーブルのデータを抽出する）
  * @引数：gid　劇場ID
  * @引数：aid  アンケートID
  * @返値：抽出データ
  */

 public function selectAnswer($gid, $aid)
 {
  //ＳＱＬ設定
  $sql = '';
  $sql .= 'SELECT * ';
  $sql .= 'FROM '.TBL_ANSWER.' ';
  $sql .= "WHERE  gekijo_id = :gekijo_id AND a_id = :aid ";

  $params = array(
   'gekijo_id' => $gid,
   'aid' => $aid
  );

  $stmt = parent::execute($sql, $params);

  //ＳＱＬを実行及び返値をこのメソッドの返値として設定
  $ret = $stmt->fetchAll();
  return $ret;
 }


 /*
  * @selectAnswer2（TBL_ANSWERテーブルを集計する,選択回答用）
  * @引数：gid　劇場ID
  * @引数：aid  アンケートID
  * @引数：qid  設問ID
  * @引数：startDay  アンケート開始日時
  * @引数：endDay  アンケート終了日時
  * @引数：qnos  回答番号の配列
  * @返値：抽出データ
  */

 public function selectAnswer2($gid,$aid,$qid,$startDay,$endDay,$qnos)
 {

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'SELECT ';

  foreach($qnos as $key=>$qno) {
   $sql .= "count(json_contains(answer->'$[*].".'"'.$qid.'"'.".sid', '[".'"'.$qno.'"'."]') OR NULL) AS '".$qno."' ,";
  }

  $sql .= 'count(*) as total ';
  $sql .= 'FROM '.TBL_ANSWER.' ';
  $sql .= "WHERE  gekijo_id = :gekijo_id";
  $sql .= " AND a_id = :aid ";
  $sql .= " AND creation_dt BETWEEN :sdate AND :edate ";
  $params = array(
   'gekijo_id' => $gid,
   'aid' => $aid,
   'sdate' => $startDay,
   'edate' => $endDay
  );

  $stmt = parent::execute($sql, $params);

  //ＳＱＬを実行及び返値をこのメソッドの返値として設定
  $ret = $stmt->fetchAll();
  return $ret;
 }

 /*
  * @selectAnswer3（TBL_ANSWERテーブルを集計する,記述回答用）
  * @引数：gid　劇場ID
  * @引数：aid  アンケートID
  * @引数：qid  設問ID
  * @引数：startDay  アンケート開始日時
  * @引数：endDay  アンケート終了日時
  * @返値：抽出データ
  */

  public function selectAnswer3($gid,$aid,$qid,$startDay,$endDay)
  {
  //ＳＱＬ設定
  $sql = '';
  $sql .= 'SELECT ';
  $sql .= "answer->'$[*].".'"'.$qid.'".'.'"other"'."' as other ";
  $sql .= 'FROM '.TBL_ANSWER.' ';
  $sql .= "WHERE  gekijo_id = :gekijo_id AND a_id = :aid ";
  $sql .= " AND JSON_UNQUOTE(JSON_EXTRACT(answer,'$[*].".'"'.$qid.'".'.'"other"'."')) <> '".'[""]'."' ";
  $sql .= " AND creation_dt BETWEEN :sdate AND :edate ";

  $params = array(
   'gekijo_id' => $gid,
   'aid' => $aid,
   'sdate' => $startDay,
   'edate' => $endDay
  );

  $stmt = parent::execute($sql, $params);

  //ＳＱＬを実行及び返値をこのメソッドの返値として設定
  $ret = $stmt->fetchAll();
  return $ret;
 }


 /*
  * @insertAadmin（TBL_QUESTIONNAIREテーブルにデータを追加する）
  * @引数：a_id  アンケートID　他
  * @返値：実行結果
  */

 public function insertAadmin($a_id, $gekijo_id, $a_name, $a_explanation, $a_existence, $a_start, $a_end, $a_qid, $a_disp, $creation_user)
 {
  //更新日時
  $mynowtime = date ("Y-m-d H:i:s");

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'INSERT INTO '.TBL_QUESTIONNAIRE.' ';
  $sql .= "( ";
  $sql .= ' a_id ';
  $sql .= ', gekijo_id ';
  $sql .= ', a_name ';
  $sql .= ', a_explanation ';
  $sql .= ', a_existence ';
  $sql .= ', a_start ';
  $sql .= ', a_end ';
  $sql .= ', a_qid ';
  $sql .= ', creation_dt ';
  $sql .= ', creation_user ';
  $sql .= ") ";
  $sql .= "VALUES ";
  $sql .= "( ";
  $sql .= ":a_id ";
  $sql .= ",:gekijo_id ";
  $sql .= ",:a_name ";
  $sql .= ",:a_explanation ";
  $sql .= ",:a_existence ";
  $sql .= ",:a_start ";
  $sql .= ",:a_end ";
  $sql .= ",:a_qid ";
  $sql .= ",:creation_dt ";
  $sql .= ",:creation_user ";
  $sql .= ") ";

  $params = array(
   "a_id" => $a_id,
   "gekijo_id" => $gekijo_id,
   "a_name" => $a_name,
   "a_explanation" => $a_explanation,
   "a_existence" => $a_existence,
   "a_start" => $a_start,
   "a_end" => $a_end,
   "a_qid" => $a_qid,
   "creation_dt" => $mynowtime,
   "creation_user" => $creation_user
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @insertAnswer（TBL_ANSWERテーブルにデータを追加する）
  * @引数：a_id  アンケートID　他
  * @返値：実行結果
  */
 public function insertAnswer($gekijo_id, $a_id, $r_id, $cookieData, $answer, $user_prefectures, $user_address1, $user_address2, $latitude, $longitude)
 {
  //更新日時
  $mynowtime = date ("Y-m-d H:i:s");

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'INSERT INTO '.TBL_ANSWER.' ';
  $sql .= "( ";
  $sql .= ' gekijo_id ';
  $sql .= ', a_id ';
  $sql .= ', r_id ';
  $sql .= ', cookieData ';
  $sql .= ', answer ';
  $sql .= ', creation_dt ';
  $sql .= ") ";
  $sql .= "VALUES ";
  $sql .= "( ";
  $sql .= ":gekijo_id ";
  $sql .= ",:a_id ";
  $sql .= ",:r_id ";
  $sql .= ",:cookieData ";
  $sql .= ",:answer ";
  $sql .= ",:creation_dt ";
  $sql .= ") ";

  $params = array(
   "gekijo_id" => $gekijo_id,  //新しいログインユーザーID
   "a_id" => $a_id,  //ログインパスワード
   "r_id" => $r_id,  //ログインパスワード
   "cookieData" => $cookieData,  //ログインパスワード
   "answer" => $answer,  //ログインパスワード
   "creation_dt" => $mynowtime  //ログインパスワード
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @updateAadmin（TBL_QUESTIONNAIREテーブルのデータを更新する）
  * @引数：id  データID　他
  * @返値：実行結果
  */

 public function updateAadmin($id, $a_id, $gekijo_id, $a_name, $a_explanation, $a_existence, $a_start, $a_end, $a_qid, $a_disp, $modification_user)
 {
  //更新日時
  $mynowtime = date ("Y-m-d H:i:s");

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'UPDATE '.TBL_QUESTIONNAIRE.' SET ';
  $sql .= "a_id = :a_id";
  $sql .= ", gekijo_id = :gekijo_id";
  $sql .= ", a_name = :a_name";
  $sql .= ", a_explanation = :a_explanation";
  $sql .= ", a_existence = :a_existence";
  $sql .= ", a_start = :a_start";
  $sql .= ", a_end = :a_end";
  $sql .= ", a_qid = :a_qid";
  $sql .= ", modification_dt = :modification_dt";
  $sql .= ", modification_user = :modification_user";
  $sql .= " WHERE id = :id";

  $params = array(
   "a_id" => $a_id,
   "gekijo_id" => $gekijo_id,
   "a_name" => $a_name,
   "a_explanation" => $a_explanation,
   "a_existence" => $a_existence,
   "a_start" => $a_start,
   "a_end" => $a_end,
   "a_qid" => $a_qid,
   "modification_dt" => $mynowtime, //最終更新日
   "modification_user" => $modification_user, //最終更新者
   "id" => $id
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @deleteAadmin（TBL_QUESTIONNAIREテーブルのデータを削除する）
  * @引数：id  データID
  * @返値：実行結果
  */

 public function deleteAadmin($id)
 {
  //ＳＱＬ設定
  $sql = '';
  $sql .= 'DELETE FROM '.TBL_QUESTIONNAIRE.' ';
  $sql .= " WHERE id = :id";
  $params = array(
   "id" => $id
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @deleteAnswer（TBL_ANSWERテーブルのデータを削除する）
  * @引数：id  データID
  * @返値：実行結果
  */

 public function deleteAnswer($id)
 {
  //ＳＱＬ設定
  $sql = '';
  $sql .= 'DELETE FROM '.TBL_ANSWER.' ';
  $sql .= " WHERE id = :id";
  $params = array(
   "id" => $id
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @createAadmintbl（TBL_QUESTIONNAIREテーブルを作成する）
  * @引数：なし
  * @返値：実行結果
  */

 public function createAadmintbl( $sql = null )
 {

  $sql = "";
  $sql .= "create table IF NOT EXISTS ".TBL_QUESTIONNAIRE." ";
  $sql .= "( ";
  $sql .= " id INT NOT NULL AUTO_INCREMENT primary key"; //ID
  $sql .= ", gekijo_id varchar(150) not null default ''"; //劇場ID
  $sql .= ", a_id varchar(150) not null default ''"; //アンケートID
  $sql .= ", a_name varchar(150) not null default ''"; //アンケート名称
  $sql .= ", a_explanation varchar(150) default null"; //アンケート説明文
  $sql .= ", a_existence int default 0"; //アンケート存在　0:有効  1:停止　2:削除
  $sql .= ", a_start datetime NOT NULL DEFAULT 0"; //アンケート開始日時
  $sql .= ", a_end datetime NOT NULL DEFAULT 0"; //アンケート終了日時
  $sql .= ", a_qid json DEFAULT NULL"; //設問項目　q_idと入力必須の配列
  $sql .= ", a_disp json DEFAULT NULL"; //アンケート表示方法と必須項目
  // 自動更新エリア
  $sql .= ", creation_dt datetime NOT NULL DEFAULT CURRENT_TIMESTAMP"; //作成日
  $sql .= ", creation_user varchar(150) default null"; //作成者
  $sql .= ", modification_dt datetime not null default 0"; //最終更新日
  $sql .= ", modification_user varchar(150) default null"; //最終更新者
  $sql .= ", unique a_id_index (gekijo_id, a_id)"; //インデックス
  $sql .= ")  ENGINE=InnoDB DEFAULT CHARSET=utf8;";
  //ＳＱＬを実行
  $id = parent::runSql( $sql );
  //最後に操作したデータのIDを返す
  return $id;
 }


 /*
  * @createAnswertbl（TBL_ANSWERテーブルを作成する）
  * @引数：なし
  * @返値：実行結果
  */

 public function createAnswertbl( $sql = null )
 {

  $sql = "";
  $sql .= "create table IF NOT EXISTS ".TBL_ANSWER." ";
  $sql .= "( ";
  $sql .= " id INT NOT NULL AUTO_INCREMENT primary key"; //ID
  $sql .= ", gekijo_id varchar(150) not null default ''"; //劇場ID
  $sql .= ", a_id varchar(150) not null default ''"; //アンケートID
  $sql .= ", r_id varchar(150) not null default ''"; //アンケート場所
  $sql .= ", cookieData varchar(150) not null default ''"; //クッキーデータ
  $sql .= ", answer json DEFAULT NULL"; //回答の配列
  $sql .= ", user_prefectures varchar(150) not null default ''"; //都道府県名
  $sql .= ", user_address1 varchar(150) not null default ''"; //市区町村名
  $sql .= ", user_address2 varchar(150) not null default ''"; //以降番地まで
  $sql .= ', location geometry';
  // 自動更新エリア
  $sql .= ", creation_dt datetime NOT NULL DEFAULT CURRENT_TIMESTAMP"; //作成日
  $sql .= ", index answer_index (gekijo_id, a_id)"; //インデックス
  $sql .= ")  ENGINE=InnoDB DEFAULT CHARSET=utf8;";
  //ＳＱＬを実行
  $id = parent::runSql( $sql );
  //最後に操作したデータのIDを返す
  return $id;
 }

}

?>