<?php
/*
 * ：アンケートの設問を管理するクラス
 * @親クラス  ：  ・pdodb
 */
require_once (dirname(__FILE__).'/pdoDb.class.php');
require_once (dirname(__FILE__).'/../setting.php');
require_once (dirname(__FILE__).'/dbconfig.php');

class q_settingDb extends pdodb
{

 /*
  * @selectQsetting（TBL_QUESTIONテーブルのデータを抽出する）
  * @引数：parm　データID
  * @返値：抽出データ
  */

 public function selectQsetting($parm = null)
 {

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'SELECT * ';
  $sql .= 'FROM '.TBL_QUESTION.' ';

  //パラメータの有無を判断（あればパラメータをバインド変数として実行）
  if ( $parm != null && !empty( $parm ) ){
   $sql .= "WHERE  id = :id";
   $params = array(
   'id' => $parm
  );
  $stmt = parent::execute($sql, $params);
  }
  else {
   $sql .= 'ORDER BY q_id asc ';
   $stmt = parent::execute($sql);
  }

  //ＳＱＬを実行及び返値をこのメソッドの返値として設定
  $ret = $stmt->fetchAll();
  return $ret;
 }


 /*
  * @selectQsetting2（TBL_QUESTIONテーブルのデータを抽出する）
  * @引数：parm　設問ID
  * @返値：抽出データ
  */

 public function selectQsetting2($parm = null)
 {

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'SELECT * ';
  $sql .= 'FROM '.TBL_QUESTION.' ';


  //パラメータの有無を判断（あればパラメータをバインド変数として実行）
  if ( $parm != null && !empty( $parm ) ){
   $sql .= "WHERE  q_id = :q_id";
   $params = array(
    'q_id' => $parm
   );

   $stmt = parent::execute($sql, $params);
  }
  else {
   $sql .= 'ORDER BY q_id asc ';
   $stmt = parent::execute($sql);
  }

  //ＳＱＬを実行及び返値をこのメソッドの返値として設定
  $ret = $stmt->fetchAll();
  return $ret;
 }


 /*
  * @selectQgroup（TBL_QUESTION_GROUPテーブルのデータを抽出する）
  * @引数：parm　データID
  * @返値：抽出データ
  */

 public function selectQgroup($parm = null)
 {

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'SELECT * ';
  $sql .= 'FROM '.TBL_QUESTION_GROUP.' ';

  //パラメータの有無を判断（あればパラメータをバインド変数として実行）
  if ( $parm != null && !empty( $parm ) ){
   $sql .= "WHERE  id = :id";
   $params = array(
    'id' => $parm
   );

   $stmt = parent::execute($sql, $params);
  }
  else {
   $sql .= 'ORDER BY group_id asc ';
   $stmt = parent::execute($sql);
  }

  //ＳＱＬを実行及び返値をこのメソッドの返値として設定
  $ret = $stmt->fetchAll();
  return $ret;
 }


 /*
  * @insertQsetting（TBL_QUESTIONテーブルにデータを追加する）
  * @引数：q_id　設問ID　他
  * @返値：実行結果
  */

 public function insertQsetting($q_id, $q_name, $q_sentence, $q_explanation, $q_kind, $q_select, $q_check, $q_minlength, $q_maxlength, $q_checkorg, $q_checkorgmsg, $q_unit, $group_id, $creation_user)
 {
  //更新日時
  $mynowtime = date ("Y-m-d H:i:s");

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'INSERT INTO '.TBL_QUESTION.' ';
  $sql .= "( ";
  $sql .= ' q_id ';
  $sql .= ', q_name ';
  $sql .= ', q_sentence ';
  $sql .= ', q_explanation ';
  $sql .= ', q_kind ';
  $sql .= ', q_select ';
  $sql .= ', q_check ';
  $sql .= ', q_minlength ';
  $sql .= ', q_maxlength ';
  $sql .= ', q_checkorg ';
  $sql .= ', q_checkorgmsg ';
  $sql .= ', q_unit ';
  $sql .= ', group_id ';
  $sql .= ', creation_dt ';
  $sql .= ', creation_user ';
  $sql .= ") ";
  $sql .= "VALUES ";
  $sql .= "( ";
  $sql .= ":q_id ";
  $sql .= ",:q_name ";
  $sql .= ",:q_sentence ";
  $sql .= ",:q_explanation ";
  $sql .= ",:q_kind ";
  $sql .= ",:q_select ";
  $sql .= ",:q_check ";
  $sql .= ",:q_minlength ";
  $sql .= ",:q_maxlength ";
  $sql .= ",:q_checkorg ";
  $sql .= ",:q_checkorgmsg ";
  $sql .= ",:q_unit ";
  $sql .= ",:group_id ";
  $sql .= ",:creation_dt ";
  $sql .= ",:creation_user ";
  $sql .= ") ";

  $params = array(
   "q_id" => $q_id,  //新しいログインユーザーID
   "q_name" => $q_name,  //ログインパスワード
   "q_sentence" => $q_sentence,  //ログインパスワード
   "q_explanation" => $q_explanation,  //ログインパスワード
   "q_kind" => $q_kind,  //ログインパスワード
   "q_select" => $q_select,  //ログインパスワード
   "q_check" => $q_check,  //ログインパスワード
   "q_minlength" => $q_minlength,  //ログインパスワード
   "q_maxlength" => $q_maxlength,  //ログインパスワード
   "q_checkorg" => $q_checkorg,  //ログインパスワード
   "q_checkorgmsg" => $q_checkorgmsg,  //ログインパスワード
   "q_unit" => $q_unit,  //ログインパスワード
   "group_id" => $group_id,  //ログインパスワード
   "creation_dt" => $mynowtime,  //ログインパスワード
   "creation_user" => $creation_user  //ユーザー種別　0:システム管理者（メンテ用）　1:管理者　2:劇場管理者
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @insertQgroup（TBL_QUESTION_GROUPテーブルにデータを追加する）
  * @引数：group_id　グループID　他
  * @返値：実行結果
  */

 public function insertQgroup($group_id, $group_name, $group_explanation, $creation_user)
 {
  //更新日時
  $mynowtime = date ("Y-m-d H:i:s");

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'INSERT INTO '.TBL_QUESTION_GROUP.' ';
  $sql .= "( ";
  $sql .= ' group_id ';
  $sql .= ', group_name ';
  $sql .= ', group_explanation ';
  $sql .= ', creation_dt ';
  $sql .= ', creation_user ';
  $sql .= ") ";
  $sql .= "VALUES ";
  $sql .= "( ";
  $sql .= ":group_id ";
  $sql .= ",:group_name ";
  $sql .= ",:group_explanation ";
  $sql .= ",:creation_dt ";
  $sql .= ",:creation_user ";
  $sql .= ") ";

  $params = array(
   "group_id" => $group_id,  //新しいログインユーザーID
   "group_name" => $group_name,  //ログインパスワード
   "group_explanation" => $group_explanation,  //ログインパスワード
   "creation_dt" => $mynowtime,  //ログインパスワード
   "creation_user" => $creation_user  //ユーザー種別　0:システム管理者（メンテ用）　1:管理者　2:劇場管理者
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @updateQsetting（TBL_QUESTIONテーブルのデータを更新する）
  * @引数：id　データID　他
  * @返値：実行結果
  */

 public function updateQsetting($id, $q_id, $q_name, $q_sentence, $q_explanation, $q_kind, $q_select, $q_check, $q_minlength, $q_maxlength, $q_checkorg, $q_checkorgmsg, $q_unit, $group_id, $modification_user)
 {
  //更新日時
  $mynowtime = date ("Y-m-d H:i:s");

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'UPDATE '.TBL_QUESTION.' SET ';
  $sql .= "q_id = :q_id";
  $sql .= ", q_name = :q_name";
  $sql .= ", q_sentence = :q_sentence";
  $sql .= ", q_explanation = :q_explanation";
  $sql .= ", q_kind = :q_kind";
  $sql .= ", q_select = :q_select";
  $sql .= ", q_check = :q_check";
  $sql .= ", q_minlength = :q_minlength";
  $sql .= ", q_maxlength = :q_maxlength";
  $sql .= ", q_checkorg = :q_checkorg";
  $sql .= ", q_checkorgmsg = :q_checkorgmsg";
  $sql .= ", q_unit = :q_unit";
  $sql .= ", group_id = :group_id";
  $sql .= ", modification_dt = :modification_dt";
  $sql .= ", modification_user = :modification_user";
  $sql .= " WHERE id = :id";

  $params = array(
   "q_id" => $q_id,
   "q_name" => $q_name,
   "q_sentence" => $q_sentence,
   "q_explanation" => $q_explanation,
   "q_kind" => $q_kind,
   "q_select" => $q_select,
   "q_check" => $q_check,
   "q_minlength" => $q_minlength,
   "q_maxlength" => $q_maxlength,
   "q_checkorg" => $q_checkorg,
   "q_checkorgmsg" => $q_checkorgmsg,
   "q_unit" => $q_unit,
   "group_id" => $group_id,
   "modification_dt" => $mynowtime, //最終更新日
   "modification_user" => $modification_user, //最終更新者
   "id" => $id
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @updateQgroup（TBL_QUESTION_GROUPテーブルにデータを追加する）
  * @引数：id　データID　他
  * @返値：実行結果
  */

 public function updateQgroup($id, $group_id, $group_name, $group_explanation, $modification_user)
 {
  //更新日時
  $mynowtime = date ("Y-m-d H:i:s");

  //ＳＱＬ設定
  $sql = '';
  $sql .= 'UPDATE '.TBL_QUESTION_GROUP.' SET ';
  $sql .= "group_id = :group_id";
  $sql .= ", group_name = :group_name";
  $sql .= ", group_explanation = :group_explanation";
  $sql .= ", modification_dt = :modification_dt";
  $sql .= ", modification_user = :modification_user";
  $sql .= " WHERE id = :id";

  $params = array(
   "group_id" => $group_id,
   "group_name" => $group_name,
   "group_explanation" => $group_explanation,
   "modification_dt" => $mynowtime, //最終更新日
   "modification_user" => $modification_user, //最終更新者
   "id" => $id
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @deleteQsetting（TBL_QUESTIONテーブルのデータを削除する）
  * @引数：id　データID
  * @返値：実行結果
  */

 public function deleteQsetting($id)
 {
  //ＳＱＬ設定
  $sql = '';
  $sql .= 'DELETE FROM '.TBL_QUESTION.' ';
  $sql .= " WHERE id = :id";

  $params = array(
   "id" => $id
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @deleteQgroup（TBL_QUESTION_GROUPテーブルのデータを削除する）
  * @引数：id　データID
  * @返値：実行結果
  */

 public function deleteQgroup($id)
 {
  //ＳＱＬ設定
  $sql = '';
  $sql .= 'DELETE FROM '.TBL_QUESTION_GROUP.' ';
  $sql .= " WHERE id = :id";

  $params = array(
   "id" => $id
  ) ;

  //ＳＱＬを実行
  $stmt = parent::execute($sql, $params);
  return $stmt;
  parent::closeStmt();
 }


 /*
  * @createQsettingtbl（TBL_QUESTIONテーブルを作成する）
  * @引数：なし
  * @返値：実行結果
 */

 public function createQsettingtbl( $sql = null )
 {

  $sql = "";
  $sql .= "create table IF NOT EXISTS ".TBL_QUESTION." ";
  $sql .= "( ";
  $sql .= " id INT NOT NULL AUTO_INCREMENT primary key"; //ID
  $sql .= ", q_id varchar(150) not null default ''"; //設問ID
  $sql .= ", q_name varchar(150) not null default ''"; //設問名称
  $sql .= ", q_sentence varchar(150) not null default ''"; //設問文
  $sql .= ", q_explanation varchar(150) default null"; //設問説明文
  $sql .= ", q_kind int default 0"; //回答形式
   // 1:単一選択ドロップダウン　2:単一選択ラジオボタン　3:複数選択チェックボックス
   // 11:単一選択ドロップダウンとその他記述　12:単一選択ラジオボタンとその他記述　13:複数選択とその他記述
   // 91:自由記述一行　99:自由記述複数行
  $sql .= ", q_select json DEFAULT NULL"; //回答選択項目
  $sql .= ", q_check int default 0"; //入力チェック方法
   // 0:無し　1:半角数字　2:半角英数字　3:半角英字　4:電話番号　5:メール　6:URL　7:日付　8:独自ルール
  $sql .= ", q_minlength int default 0"; //最小文字数
  $sql .= ", q_maxlength int default 0"; //最大文字数
  $sql .= ", q_checkorg varchar(150) default null"; //独自ルール
  $sql .= ", q_checkorgmsg varchar(150) default null"; //独自ルールエラーメッセージ
  $sql .= ", q_unit varchar(150) default null"; //記述単位表示
  $sql .= ", group_id varchar(150) not null default ''"; //設問グループID
  // 自動更新エリア
  $sql .= ", creation_dt datetime NOT NULL DEFAULT CURRENT_TIMESTAMP"; //作成日
  $sql .= ", creation_user varchar(150) default null"; //作成者
  $sql .= ", modification_dt datetime not null default 0"; //最終更新日
  $sql .= ", modification_user varchar(150) default null"; //最終更新者
  $sql .= ", index q_id_index (q_id)"; //インデックス
  $sql .= ")  ENGINE=InnoDB DEFAULT CHARSET=utf8;";
  //ＳＱＬを実行
  $id = parent::runSql( $sql );
  //最後に操作したデータのIDを返す
  return $id;
 }


 /*
  * @createQgrouptbl（TBL_QUESTION_GROUPテーブルを作成する）
  * @引数：なし
  * @返値：実行結果
  */

 public function createQgrouptbl( $sql = null )
 {

  $sql = "";
  $sql .= "create table IF NOT EXISTS ".TBL_QUESTION_GROUP." ";
  $sql .= "( ";
  $sql .= " id INT NOT NULL AUTO_INCREMENT primary key"; //ID
  $sql .= ", group_id varchar(150) not null default ''"; //設問グループID
  $sql .= ", group_name varchar(150) not null default ''"; //設問グループ名称
  $sql .= ", group_explanation varchar(150) default null"; //設問グループ説明
  // 自動更新エリア
  $sql .= ", creation_dt datetime NOT NULL DEFAULT CURRENT_TIMESTAMP"; //作成日
  $sql .= ", creation_user varchar(150) default null"; //作成者
  $sql .= ", modification_dt datetime not null default 0"; //最終更新日
  $sql .= ", modification_user varchar(150) default null"; //最終更新者
  $sql .= ", index group_id_index (group_id)"; //インデックス
  $sql .= ")  ENGINE=InnoDB DEFAULT CHARSET=utf8;";
  //ＳＱＬを実行
  $id = parent::runSql( $sql );
  //最後に操作したデータのIDを返す
  return $id;
 }

}

?>